<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestHeaderUserDefinedTableCustomerCollection
 * StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestHeaderUserDefinedTableCustomerCollection
 * @subpackage Structs
 */
class CreateFromRequestHeaderUserDefinedTableCustomerCollection extends AbstractStructBase
{
    /**
     * The UserDefinedTableCustomer
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer[]
     */
    public $UserDefinedTableCustomer;
    /**
     * Constructor method for CreateFromRequestHeaderUserDefinedTableCustomerCollection
     * @uses CreateFromRequestHeaderUserDefinedTableCustomerCollection::setUserDefinedTableCustomer()
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer[] $userDefinedTableCustomer
     */
    public function __construct(array $userDefinedTableCustomer = array())
    {
        $this
            ->setUserDefinedTableCustomer($userDefinedTableCustomer);
    }
    /**
     * Get UserDefinedTableCustomer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer[]|null
     */
    public function getUserDefinedTableCustomer()
    {
        return isset($this->UserDefinedTableCustomer) ? $this->UserDefinedTableCustomer : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserDefinedTableCustomer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserDefinedTableCustomer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserDefinedTableCustomerForArrayConstraintsFromSetUserDefinedTableCustomer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createFromRequestHeaderUserDefinedTableCustomerCollectionUserDefinedTableCustomerItem) {
            // validation for constraint: itemType
            if (!$createFromRequestHeaderUserDefinedTableCustomerCollectionUserDefinedTableCustomerItem instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer) {
                $invalidValues[] = is_object($createFromRequestHeaderUserDefinedTableCustomerCollectionUserDefinedTableCustomerItem) ? get_class($createFromRequestHeaderUserDefinedTableCustomerCollectionUserDefinedTableCustomerItem) : sprintf('%s(%s)', gettype($createFromRequestHeaderUserDefinedTableCustomerCollectionUserDefinedTableCustomerItem), var_export($createFromRequestHeaderUserDefinedTableCustomerCollectionUserDefinedTableCustomerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserDefinedTableCustomer property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserDefinedTableCustomer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer[] $userDefinedTableCustomer
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomerCollection
     */
    public function setUserDefinedTableCustomer(array $userDefinedTableCustomer = array())
    {
        // validation for constraint: array
        if ('' !== ($userDefinedTableCustomerArrayErrorMessage = self::validateUserDefinedTableCustomerForArrayConstraintsFromSetUserDefinedTableCustomer($userDefinedTableCustomer))) {
            throw new \InvalidArgumentException($userDefinedTableCustomerArrayErrorMessage, __LINE__);
        }
        if (is_null($userDefinedTableCustomer) || (is_array($userDefinedTableCustomer) && empty($userDefinedTableCustomer))) {
            unset($this->UserDefinedTableCustomer);
        } else {
            $this->UserDefinedTableCustomer = $userDefinedTableCustomer;
        }
        return $this;
    }
    /**
     * Add item to UserDefinedTableCustomer value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer $item
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomerCollection
     */
    public function addToUserDefinedTableCustomer(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedTableCustomer property can only contain items of type \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserDefinedTableCustomer[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestHeaderUserDefinedTableCustomerCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
