<?php

namespace FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateFromRequestLine StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CreateFromRequestLine
 * @subpackage Structs
 */
class CreateFromRequestLine extends AbstractStructBase
{
    /**
     * The ItemIdentifier
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLineItemIdentifier
     */
    public $ItemIdentifier;
    /**
     * The Quantity
     * @var float
     */
    public $Quantity;
    /**
     * The SerialNumberId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SerialNumberId;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for CreateFromRequestLine
     * @uses CreateFromRequestLine::setItemIdentifier()
     * @uses CreateFromRequestLine::setQuantity()
     * @uses CreateFromRequestLine::setSerialNumberId()
     * @uses CreateFromRequestLine::setWarehouseId()
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier
     * @param float $quantity
     * @param string $serialNumberId
     * @param string $warehouseId
     */
    public function __construct(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier = null, $quantity = null, $serialNumberId = null, $warehouseId = null)
    {
        $this
            ->setItemIdentifier($itemIdentifier)
            ->setQuantity($quantity)
            ->setSerialNumberId($serialNumberId)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get ItemIdentifier value
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLineItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return $this->ItemIdentifier;
    }
    /**
     * Set ItemIdentifier value
     * @param \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLine
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLineItemIdentifier $itemIdentifier = null)
    {
        $this->ItemIdentifier = $itemIdentifier;
        return $this;
    }
    /**
     * Get Quantity value
     * @return float|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param float $quantity
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLine
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: float
        if (!is_null($quantity) && !(is_float($quantity) || is_numeric($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get SerialNumberId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerialNumberId()
    {
        return isset($this->SerialNumberId) ? $this->SerialNumberId : null;
    }
    /**
     * Set SerialNumberId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serialNumberId
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLine
     */
    public function setSerialNumberId($serialNumberId = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumberId) && !is_string($serialNumberId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serialNumberId, true), gettype($serialNumberId)), __LINE__);
        }
        if (is_null($serialNumberId) || (is_array($serialNumberId) && empty($serialNumberId))) {
            unset($this->SerialNumberId);
        } else {
            $this->SerialNumberId = $serialNumberId;
        }
        return $this;
    }
    /**
     * Get WarehouseId value
     * @return string|null
     */
    public function getWarehouseId()
    {
        return $this->WarehouseId;
    }
    /**
     * Set WarehouseId value
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLine
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        $this->WarehouseId = $warehouseId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerOrderManagementService\StructType\CreateFromRequestLine
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
