<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetCustomerIdByReference
     * Meta information extracted from the WSDL
     * - documentation: Renvoie l'identifiant du client correspondant à une référence client donnée. | Référence permettant d'identifier le client. | Renvoie l'identifiant du client trouvé.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerIdByReference $parameters
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerIdByReferenceResponse|bool
     */
    public function GetCustomerIdByReference(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerIdByReference $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetCustomerIdByReference($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetCustomerDetail
     * Meta information extracted from the WSDL
     * - documentation: Renvoie les informations consultables de la fiche client. | Identifiant du client.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerDetail $parameters
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerDetailResponse|bool
     */
    public function GetCustomerDetail(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerDetail $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetCustomerDetail($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerDetailResponse|\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerIdByReferenceResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
