<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerIdByReferenceResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Renvoie l'identifiant du client correspondant à une référence client donnée.
 * @subpackage Structs
 */
class GetCustomerIdByReferenceResponse extends AbstractStructBase
{
    /**
     * The GetCustomerIdByReferenceResult
     * Meta information extracted from the WSDL
     * - documentation: Renvoie l'identifiant du client trouvé.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GetCustomerIdByReferenceResult;
    /**
     * Constructor method for GetCustomerIdByReferenceResponse
     * @uses GetCustomerIdByReferenceResponse::setGetCustomerIdByReferenceResult()
     * @param string $getCustomerIdByReferenceResult
     */
    public function __construct($getCustomerIdByReferenceResult = null)
    {
        $this
            ->setGetCustomerIdByReferenceResult($getCustomerIdByReferenceResult);
    }
    /**
     * Get GetCustomerIdByReferenceResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGetCustomerIdByReferenceResult()
    {
        return isset($this->GetCustomerIdByReferenceResult) ? $this->GetCustomerIdByReferenceResult : null;
    }
    /**
     * Set GetCustomerIdByReferenceResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $getCustomerIdByReferenceResult
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerIdByReferenceResponse
     */
    public function setGetCustomerIdByReferenceResult($getCustomerIdByReferenceResult = null)
    {
        // validation for constraint: string
        if (!is_null($getCustomerIdByReferenceResult) && !is_string($getCustomerIdByReferenceResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($getCustomerIdByReferenceResult, true), gettype($getCustomerIdByReferenceResult)), __LINE__);
        }
        if (is_null($getCustomerIdByReferenceResult) || (is_array($getCustomerIdByReferenceResult) && empty($getCustomerIdByReferenceResult))) {
            unset($this->GetCustomerIdByReferenceResult);
        } else {
            $this->GetCustomerIdByReferenceResult = $getCustomerIdByReferenceResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\GetCustomerIdByReferenceResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
