<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserDefinedDate StructType
 * Meta information extracted from the WSDL
 * - documentation: Donnée d'une date libre
 * - nillable: true
 * - type: q33:UserDefinedDate
 * @subpackage Structs
 */
class UserDefinedDate extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la date libre.
     * - minOccurs: 0
     * @var string
     */
    public $Id;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - documentation: Valeur de la date libre. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * @var string
     */
    public $Value;
    /**
     * Constructor method for UserDefinedDate
     * @uses UserDefinedDate::setId()
     * @uses UserDefinedDate::setValue()
     * @param string $id
     * @param string $value
     */
    public function __construct($id = null, $value = null)
    {
        $this
            ->setId($id)
            ->setValue($value);
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @uses \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $id
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDate
     */
    public function setId($id = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::valueIsValid($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId', is_array($id) ? implode(', ', $id) : var_export($id, true), implode(', ', \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::getValidValues())), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Value value
     * @return string|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param string $value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDate
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->Value = $value;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedDate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
