<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetAvailableQty
     * Meta information extracted from the WSDL
     * - documentation: Returns the quantity available in stock for an item without dimension or SKU. | [Obsolete] - Item reference - uses the item search priorities | Returns the quantity available in stock. Value 0 is returned if the item identifier or
     * the warehouse identifier are incorrect.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQtyResponse|bool
     */
    public function GetAvailableQty(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetAvailableQty($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetAvailableCumulativeQtyAllStores
     * Meta information extracted from the WSDL
     * - documentation: Returns the cumulative quantities available in stock for all the stores accessible to the current user. | [Obsolete] - Reference to use to determine the item for which the cumulative quantity from all stores must be returned. |
     * Returns an object containing both the cumulative quantity available in stock and the warehouse search status. If no warehouse can be determined, the cumulative quantity will be 0.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStoresResponse|bool
     */
    public function GetAvailableCumulativeQtyAllStores(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetAvailableCumulativeQtyAllStores($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetInventoryDetailByStore
     * Meta information extracted from the WSDL
     * - documentation: Returns the detail by warehouse of the quantity available in stock for an item without dimension or SKU. | [Obsolete] - Reference to use to determine the item for which the detail by store must be returned. | Returns a list of "store
     * - available quantity" combinations. If no store is open or if the item is unknown, the returned list will be empty.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStore $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStoreResponse|bool
     */
    public function GetInventoryDetailByStore(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStore $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetInventoryDetailByStore($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetListItemInventoryDetailByStore
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/10 - V1104] - Returns the detail of the quantity available in stock for an item list (generic, without dimension, or SKU) and a store list. | Returns the list of inventory details
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStoreResponse|bool
     */
    public function GetListItemInventoryDetailByStore(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetListItemInventoryDetailByStore($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStoresResponse|\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQtyResponse|\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStoreResponse|\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStoreResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
