<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Reset ServiceType
 * @subpackage Services
 */
class Reset extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named ResetShoppingCart
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/08 - V1105] - Resets the "Web shopping cart" quantity of a item for a given warehouse. If no item is specified, the quantity is reset to 0 for all the warehouse.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCartResponse|bool
     */
    public function ResetShoppingCart(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCart $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->ResetShoppingCart($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ResetShoppingCartResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
