<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailableSkuQty StructType
 * Meta information extracted from the WSDL
 * - documentation: Dimension list of the SKU with quantity in stock
 * - nillable: true
 * - type: tns:AvailableSkuQty
 * @subpackage Structs
 */
class AvailableSkuQty extends AbstractStructBase
{
    /**
     * The AvailableQty
     * Meta information extracted from the WSDL
     * - documentation: SKU quantity available in stock.
     * - minOccurs: 0
     * @var float
     */
    public $AvailableQty;
    /**
     * The Dimension1
     * Meta information extracted from the WSDL
     * - documentation: Code of dimension 1.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Dimension1;
    /**
     * The Dimension2
     * Meta information extracted from the WSDL
     * - documentation: Code of dimension 2.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Dimension2;
    /**
     * The Dimension3
     * Meta information extracted from the WSDL
     * - documentation: Code of dimension 3.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Dimension3;
    /**
     * The Dimension4
     * Meta information extracted from the WSDL
     * - documentation: Code of dimension 4.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Dimension4;
    /**
     * The Dimension5
     * Meta information extracted from the WSDL
     * - documentation: Code of dimension 5.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Dimension5;
    /**
     * Constructor method for AvailableSkuQty
     * @uses AvailableSkuQty::setAvailableQty()
     * @uses AvailableSkuQty::setDimension1()
     * @uses AvailableSkuQty::setDimension2()
     * @uses AvailableSkuQty::setDimension3()
     * @uses AvailableSkuQty::setDimension4()
     * @uses AvailableSkuQty::setDimension5()
     * @param float $availableQty
     * @param string $dimension1
     * @param string $dimension2
     * @param string $dimension3
     * @param string $dimension4
     * @param string $dimension5
     */
    public function __construct($availableQty = null, $dimension1 = null, $dimension2 = null, $dimension3 = null, $dimension4 = null, $dimension5 = null)
    {
        $this
            ->setAvailableQty($availableQty)
            ->setDimension1($dimension1)
            ->setDimension2($dimension2)
            ->setDimension3($dimension3)
            ->setDimension4($dimension4)
            ->setDimension5($dimension5);
    }
    /**
     * Get AvailableQty value
     * @return float|null
     */
    public function getAvailableQty()
    {
        return $this->AvailableQty;
    }
    /**
     * Set AvailableQty value
     * @param float $availableQty
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableSkuQty
     */
    public function setAvailableQty($availableQty = null)
    {
        // validation for constraint: float
        if (!is_null($availableQty) && !(is_float($availableQty) || is_numeric($availableQty))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($availableQty, true), gettype($availableQty)), __LINE__);
        }
        $this->AvailableQty = $availableQty;
        return $this;
    }
    /**
     * Get Dimension1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDimension1()
    {
        return isset($this->Dimension1) ? $this->Dimension1 : null;
    }
    /**
     * Set Dimension1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dimension1
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableSkuQty
     */
    public function setDimension1($dimension1 = null)
    {
        // validation for constraint: string
        if (!is_null($dimension1) && !is_string($dimension1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dimension1, true), gettype($dimension1)), __LINE__);
        }
        if (is_null($dimension1) || (is_array($dimension1) && empty($dimension1))) {
            unset($this->Dimension1);
        } else {
            $this->Dimension1 = $dimension1;
        }
        return $this;
    }
    /**
     * Get Dimension2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDimension2()
    {
        return isset($this->Dimension2) ? $this->Dimension2 : null;
    }
    /**
     * Set Dimension2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dimension2
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableSkuQty
     */
    public function setDimension2($dimension2 = null)
    {
        // validation for constraint: string
        if (!is_null($dimension2) && !is_string($dimension2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dimension2, true), gettype($dimension2)), __LINE__);
        }
        if (is_null($dimension2) || (is_array($dimension2) && empty($dimension2))) {
            unset($this->Dimension2);
        } else {
            $this->Dimension2 = $dimension2;
        }
        return $this;
    }
    /**
     * Get Dimension3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDimension3()
    {
        return isset($this->Dimension3) ? $this->Dimension3 : null;
    }
    /**
     * Set Dimension3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dimension3
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableSkuQty
     */
    public function setDimension3($dimension3 = null)
    {
        // validation for constraint: string
        if (!is_null($dimension3) && !is_string($dimension3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dimension3, true), gettype($dimension3)), __LINE__);
        }
        if (is_null($dimension3) || (is_array($dimension3) && empty($dimension3))) {
            unset($this->Dimension3);
        } else {
            $this->Dimension3 = $dimension3;
        }
        return $this;
    }
    /**
     * Get Dimension4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDimension4()
    {
        return isset($this->Dimension4) ? $this->Dimension4 : null;
    }
    /**
     * Set Dimension4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dimension4
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableSkuQty
     */
    public function setDimension4($dimension4 = null)
    {
        // validation for constraint: string
        if (!is_null($dimension4) && !is_string($dimension4)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dimension4, true), gettype($dimension4)), __LINE__);
        }
        if (is_null($dimension4) || (is_array($dimension4) && empty($dimension4))) {
            unset($this->Dimension4);
        } else {
            $this->Dimension4 = $dimension4;
        }
        return $this;
    }
    /**
     * Get Dimension5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDimension5()
    {
        return isset($this->Dimension5) ? $this->Dimension5 : null;
    }
    /**
     * Set Dimension5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dimension5
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableSkuQty
     */
    public function setDimension5($dimension5 = null)
    {
        // validation for constraint: string
        if (!is_null($dimension5) && !is_string($dimension5)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dimension5, true), gettype($dimension5)), __LINE__);
        }
        if (is_null($dimension5) || (is_array($dimension5) && empty($dimension5))) {
            unset($this->Dimension5);
        } else {
            $this->Dimension5 = $dimension5;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableSkuQty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
