<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StoreAvailableQty StructType
 * Meta information extracted from the WSDL
 * - documentation: Quantity in stock for a store
 * - nillable: true
 * - type: tns:StoreAvailableQty
 * @subpackage Structs
 */
class StoreAvailableQty extends AbstractStructBase
{
    /**
     * The AvailableQuantity
     * Meta information extracted from the WSDL
     * - documentation: Quantity in stock.
     * - minOccurs: 0
     * @var float
     */
    public $AvailableQuantity;
    /**
     * The AvailableSkusQty
     * Meta information extracted from the WSDL
     * - documentation: List of SKUs and their quantity in stock.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableSkuQty
     */
    public $AvailableSkusQty;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Store ID.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * The StoreName
     * Meta information extracted from the WSDL
     * - documentation: Store name.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreName;
    /**
     * Constructor method for StoreAvailableQty
     * @uses StoreAvailableQty::setAvailableQuantity()
     * @uses StoreAvailableQty::setAvailableSkusQty()
     * @uses StoreAvailableQty::setStoreId()
     * @uses StoreAvailableQty::setStoreName()
     * @param float $availableQuantity
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableSkuQty $availableSkusQty
     * @param string $storeId
     * @param string $storeName
     */
    public function __construct($availableQuantity = null, \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableSkuQty $availableSkusQty = null, $storeId = null, $storeName = null)
    {
        $this
            ->setAvailableQuantity($availableQuantity)
            ->setAvailableSkusQty($availableSkusQty)
            ->setStoreId($storeId)
            ->setStoreName($storeName);
    }
    /**
     * Get AvailableQuantity value
     * @return float|null
     */
    public function getAvailableQuantity()
    {
        return $this->AvailableQuantity;
    }
    /**
     * Set AvailableQuantity value
     * @param float $availableQuantity
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty
     */
    public function setAvailableQuantity($availableQuantity = null)
    {
        // validation for constraint: float
        if (!is_null($availableQuantity) && !(is_float($availableQuantity) || is_numeric($availableQuantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($availableQuantity, true), gettype($availableQuantity)), __LINE__);
        }
        $this->AvailableQuantity = $availableQuantity;
        return $this;
    }
    /**
     * Get AvailableSkusQty value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableSkuQty|null
     */
    public function getAvailableSkusQty()
    {
        return isset($this->AvailableSkusQty) ? $this->AvailableSkusQty : null;
    }
    /**
     * Set AvailableSkusQty value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableSkuQty $availableSkusQty
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty
     */
    public function setAvailableSkusQty(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableSkuQty $availableSkusQty = null)
    {
        if (is_null($availableSkusQty) || (is_array($availableSkusQty) && empty($availableSkusQty))) {
            unset($this->AvailableSkusQty);
        } else {
            $this->AvailableSkusQty = $availableSkusQty;
        }
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Get StoreName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreName()
    {
        return isset($this->StoreName) ? $this->StoreName : null;
    }
    /**
     * Set StoreName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeName
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty
     */
    public function setStoreName($storeName = null)
    {
        // validation for constraint: string
        if (!is_null($storeName) && !is_string($storeName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeName, true), gettype($storeName)), __LINE__);
        }
        if (is_null($storeName) || (is_array($storeName) && empty($storeName))) {
            unset($this->StoreName);
        } else {
            $this->StoreName = $storeName;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\StoreAvailableQty
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
