<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'HelloWorld' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\HelloWorld',
            'RetailContext' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\RetailContext',
            'HelloWorldResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\HelloWorldResponse',
            'GetAvailableLoyaltyPoints' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetAvailableLoyaltyPoints',
            'GetAvailableLoyaltyPointsResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetAvailableLoyaltyPointsResponse',
            'GetCustomerAvailableLoyaltyPoints' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetCustomerAvailableLoyaltyPoints',
            'GetCustomerAvailableLoyaltyPointsResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetCustomerAvailableLoyaltyPointsResponse',
            'CreateLoyaltyCard' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CreateLoyaltyCard',
            'CreateLoyaltyCardResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CreateLoyaltyCardResponse',
            'GetCustomerCards' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetCustomerCards',
            'GetCustomerCardsRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetCustomerCardsRequest',
            'GetCustomerCardsResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetCustomerCardsResponse',
            'ArrayOfCardHeaderGet' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\ArrayType\\ArrayOfCardHeaderGet',
            'CardHeaderGet' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CardHeaderGet',
            'ProgramCardGet' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\ProgramCardGet',
            'GetLoyaltyCard' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetLoyaltyCard',
            'GetLoyaltyCardResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetLoyaltyCardResponse',
            'GetLoyaltyPointsForSale' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetLoyaltyPointsForSale',
            'SaleDocumentIdentifier' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\SaleDocumentIdentifier',
            'SaleDocumentKey' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\SaleDocumentKey',
            'SaleDocumentReference' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\SaleDocumentReference',
            'GetLoyaltyPointsForSaleResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\GetLoyaltyPointsForSaleResponse',
            'UpdatePoints' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdatePoints',
            'UpdatePointsRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdatePointsRequest',
            'UpdatePointsResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdatePointsResponse',
            'CreateExternCard' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CreateExternCard',
            'CreateExternCardRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CreateExternCardRequest',
            'ValidityPeriodType' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\ValidityPeriodType',
            'CreateExternCardResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CreateExternCardResponse',
            'UpdateProgram' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateProgram',
            'UpdateProgramRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateProgramRequest',
            'UpdateProgramResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateProgramResponse',
            'UpdateValidityPeriod' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateValidityPeriod',
            'UpdateValidityPeriodRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateValidityPeriodRequest',
            'UpdateValidityPeriodResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateValidityPeriodResponse',
            'UpdateCardId' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateCardId',
            'UpdateCardIdRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateCardIdRequest',
            'UpdateCardIdResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\UpdateCardIdResponse',
            'CloseCard' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CloseCard',
            'CloseCardRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CloseCardRequest',
            'CloseCardResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CloseCardResponse',
            'ReOpenCard' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\ReOpenCard',
            'ReOpenCardRequest' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\ReOpenCardRequest',
            'ReOpenCardResponse' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\ReOpenCardResponse',
            'CbpFaultDetail' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CbpFaultDetail',
            'BusinessFaultDetail' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\BusinessFaultDetail',
            'ExceptionDetail' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\ExceptionDetail',
            'CbpExceptionDetail' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\StructType\\CbpExceptionDetail',
            'ArrayOfstring' => '\\FiloBlu\\CegidY2\\Api\\LoyaltyWcfService\\ArrayType\\ArrayOfstring',
        );
    }
}
