<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Close ServiceType
 * @subpackage Services
 */
class Close extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CloseCard
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2016/04 - V1110] [Bêta] - Permet la fermeture de la carte active du client
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCard $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardResponse|bool
     */
    public function CloseCard(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCard $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CloseCard($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
