<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetAvailableLoyaltyPoints
     * Meta information extracted from the WSDL
     * - documentation: Renvoie le solde de points d'une carte de fidélité. | Identifiant de la carte de fidélité. - Relatif à la colonne [MCARETFIDENT.MFC_NUMCARTE]
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPoints $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPointsResponse|bool
     */
    public function GetAvailableLoyaltyPoints(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPoints $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetAvailableLoyaltyPoints($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetCustomerAvailableLoyaltyPoints
     * Meta information extracted from the WSDL
     * - documentation: Renvoie le solde de points d'un client donné. | Référence permettant d'identifier le client. | Renvoie le solde de points de fidélité du client trouvé.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPoints $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPointsResponse|bool
     */
    public function GetCustomerAvailableLoyaltyPoints(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPoints $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetCustomerAvailableLoyaltyPoints($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetCustomerCards
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Renvoie la liste des cartes de fidélité associées à un client. | Liste de cartes de fidélité
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCards $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsResponse|bool
     */
    public function GetCustomerCards(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCards $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetCustomerCards($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetLoyaltyCard
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Retourne les informations d'une carte de fidélité | Identifiant de la carte de fidélité - Relatif à la colonne [MCARETFIDENT.MFC_NUMCARTE] | Informations d'une carte de fidélité
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCard $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCardResponse|bool
     */
    public function GetLoyaltyCard(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCard $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetLoyaltyCard($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetLoyaltyPointsForSale
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/05 - V1102] - Retourne les points de fidélité gagnés pour un document de vente existant. | Paramètres de requête | Points de fidélité gagnés.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSale $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSaleResponse|bool
     */
    public function GetLoyaltyPointsForSale(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSale $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetLoyaltyPointsForSale($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPointsResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPointsResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCardResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSaleResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
