<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CardHeaderGet StructType
 * Meta information extracted from the WSDL
 * - documentation: Carte de fidélité.
 * - nillable: true
 * - type: tns:CardHeaderGet
 * @subpackage Structs
 */
class CardHeaderGet extends AbstractStructBase
{
    /**
     * The ActivationDate
     * Meta information extracted from the WSDL
     * - documentation: Date d'activation. - Relatif à la colonne [MCARTEFIDENT.MFC_DATEACTIVE].
     * - minOccurs: 0
     * @var string
     */
    public $ActivationDate;
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - documentation: Carte active. - Relatif à la colonne [MCARTEFIDENT.MFC_ACTIVEE].
     * - minOccurs: 0
     * @var bool
     */
    public $Active;
    /**
     * The AvailableLoyaltyPoints
     * Meta information extracted from the WSDL
     * - documentation: Solde de points de la carte.
     * - minOccurs: 0
     * @var float
     */
    public $AvailableLoyaltyPoints;
    /**
     * The BenefitEnable
     * Meta information extracted from the WSDL
     * - documentation: Bénéfice disponible. Cette valeur est calculée uniquement si le client et l'établissement sont fournis.
     * - minOccurs: 0
     * @var bool
     */
    public $BenefitEnable;
    /**
     * The BenefitExpiracyDate
     * Meta information extracted from the WSDL
     * - documentation: Date d'expiration des bénéfices (incluse).. - Relatif à la colonne [MCARETFIDENT.MFC_DATEFERMETURE].
     * - minOccurs: 0
     * @var string
     */
    public $BenefitExpiracyDate;
    /**
     * The Closed
     * Meta information extracted from the WSDL
     * - documentation: Carte fermée. - Relatif à la colonne [MCARTEFIDENT.MFC_FERME].
     * - minOccurs: 0
     * @var bool
     */
    public $Closed;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du client associé à la carte. - Relatif à la colonne [MCARTEFIDENT.MCARETFIDENT.MFC_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The ExpiracyDate
     * Meta information extracted from the WSDL
     * - documentation: Date d'expiration (incluse). - Relatif à la colonne [MCARTEFIDENT.MFC_DATEVALFIN].
     * - minOccurs: 0
     * @var string
     */
    public $ExpiracyDate;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la carte. - Relatif à la colonne [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Id;
    /**
     * The Program
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public $Program;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de l'établissement de création de la carte. - Relatif à la colonne [MCARTEFIDENT.MFC_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * Constructor method for CardHeaderGet
     * @uses CardHeaderGet::setActivationDate()
     * @uses CardHeaderGet::setActive()
     * @uses CardHeaderGet::setAvailableLoyaltyPoints()
     * @uses CardHeaderGet::setBenefitEnable()
     * @uses CardHeaderGet::setBenefitExpiracyDate()
     * @uses CardHeaderGet::setClosed()
     * @uses CardHeaderGet::setCustomerId()
     * @uses CardHeaderGet::setExpiracyDate()
     * @uses CardHeaderGet::setId()
     * @uses CardHeaderGet::setProgram()
     * @uses CardHeaderGet::setStoreId()
     * @param string $activationDate
     * @param bool $active
     * @param float $availableLoyaltyPoints
     * @param bool $benefitEnable
     * @param string $benefitExpiracyDate
     * @param bool $closed
     * @param string $customerId
     * @param string $expiracyDate
     * @param string $id
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet $program
     * @param string $storeId
     */
    public function __construct($activationDate = null, $active = null, $availableLoyaltyPoints = null, $benefitEnable = null, $benefitExpiracyDate = null, $closed = null, $customerId = null, $expiracyDate = null, $id = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet $program = null, $storeId = null)
    {
        $this
            ->setActivationDate($activationDate)
            ->setActive($active)
            ->setAvailableLoyaltyPoints($availableLoyaltyPoints)
            ->setBenefitEnable($benefitEnable)
            ->setBenefitExpiracyDate($benefitExpiracyDate)
            ->setClosed($closed)
            ->setCustomerId($customerId)
            ->setExpiracyDate($expiracyDate)
            ->setId($id)
            ->setProgram($program)
            ->setStoreId($storeId);
    }
    /**
     * Get ActivationDate value
     * @return string|null
     */
    public function getActivationDate()
    {
        return $this->ActivationDate;
    }
    /**
     * Set ActivationDate value
     * @param string $activationDate
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setActivationDate($activationDate = null)
    {
        // validation for constraint: string
        if (!is_null($activationDate) && !is_string($activationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($activationDate, true), gettype($activationDate)), __LINE__);
        }
        $this->ActivationDate = $activationDate;
        return $this;
    }
    /**
     * Get Active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->Active;
    }
    /**
     * Set Active value
     * @param bool $active
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->Active = $active;
        return $this;
    }
    /**
     * Get AvailableLoyaltyPoints value
     * @return float|null
     */
    public function getAvailableLoyaltyPoints()
    {
        return $this->AvailableLoyaltyPoints;
    }
    /**
     * Set AvailableLoyaltyPoints value
     * @param float $availableLoyaltyPoints
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setAvailableLoyaltyPoints($availableLoyaltyPoints = null)
    {
        // validation for constraint: float
        if (!is_null($availableLoyaltyPoints) && !(is_float($availableLoyaltyPoints) || is_numeric($availableLoyaltyPoints))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($availableLoyaltyPoints, true), gettype($availableLoyaltyPoints)), __LINE__);
        }
        $this->AvailableLoyaltyPoints = $availableLoyaltyPoints;
        return $this;
    }
    /**
     * Get BenefitEnable value
     * @return bool|null
     */
    public function getBenefitEnable()
    {
        return $this->BenefitEnable;
    }
    /**
     * Set BenefitEnable value
     * @param bool $benefitEnable
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setBenefitEnable($benefitEnable = null)
    {
        // validation for constraint: boolean
        if (!is_null($benefitEnable) && !is_bool($benefitEnable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($benefitEnable, true), gettype($benefitEnable)), __LINE__);
        }
        $this->BenefitEnable = $benefitEnable;
        return $this;
    }
    /**
     * Get BenefitExpiracyDate value
     * @return string|null
     */
    public function getBenefitExpiracyDate()
    {
        return $this->BenefitExpiracyDate;
    }
    /**
     * Set BenefitExpiracyDate value
     * @param string $benefitExpiracyDate
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setBenefitExpiracyDate($benefitExpiracyDate = null)
    {
        // validation for constraint: string
        if (!is_null($benefitExpiracyDate) && !is_string($benefitExpiracyDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($benefitExpiracyDate, true), gettype($benefitExpiracyDate)), __LINE__);
        }
        $this->BenefitExpiracyDate = $benefitExpiracyDate;
        return $this;
    }
    /**
     * Get Closed value
     * @return bool|null
     */
    public function getClosed()
    {
        return $this->Closed;
    }
    /**
     * Set Closed value
     * @param bool $closed
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setClosed($closed = null)
    {
        // validation for constraint: boolean
        if (!is_null($closed) && !is_bool($closed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($closed, true), gettype($closed)), __LINE__);
        }
        $this->Closed = $closed;
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get ExpiracyDate value
     * @return string|null
     */
    public function getExpiracyDate()
    {
        return $this->ExpiracyDate;
    }
    /**
     * Set ExpiracyDate value
     * @param string $expiracyDate
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setExpiracyDate($expiracyDate = null)
    {
        // validation for constraint: string
        if (!is_null($expiracyDate) && !is_string($expiracyDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiracyDate, true), gettype($expiracyDate)), __LINE__);
        }
        $this->ExpiracyDate = $expiracyDate;
        return $this;
    }
    /**
     * Get Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId()
    {
        return isset($this->Id) ? $this->Id : null;
    }
    /**
     * Set Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->Id);
        } else {
            $this->Id = $id;
        }
        return $this;
    }
    /**
     * Get Program value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet|null
     */
    public function getProgram()
    {
        return isset($this->Program) ? $this->Program : null;
    }
    /**
     * Set Program value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet $program
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setProgram(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet $program = null)
    {
        if (is_null($program) || (is_array($program) && empty($program))) {
            unset($this->Program);
        } else {
            $this->Program = $program;
        }
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CardHeaderGet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
