<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CbpFaultDetail StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CbpFaultDetail
 * @subpackage Structs
 */
class CbpFaultDetail extends AbstractStructBase
{
    /**
     * The Cause
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Cause;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Description;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Id;
    /**
     * The Message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Message;
    /**
     * The SourceLocation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SourceLocation;
    /**
     * The ToDo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ToDo;
    /**
     * Constructor method for CbpFaultDetail
     * @uses CbpFaultDetail::setCause()
     * @uses CbpFaultDetail::setDescription()
     * @uses CbpFaultDetail::setId()
     * @uses CbpFaultDetail::setMessage()
     * @uses CbpFaultDetail::setSourceLocation()
     * @uses CbpFaultDetail::setToDo()
     * @param string $cause
     * @param string $description
     * @param string $id
     * @param string $message
     * @param string $sourceLocation
     * @param string $toDo
     */
    public function __construct($cause = null, $description = null, $id = null, $message = null, $sourceLocation = null, $toDo = null)
    {
        $this
            ->setCause($cause)
            ->setDescription($description)
            ->setId($id)
            ->setMessage($message)
            ->setSourceLocation($sourceLocation)
            ->setToDo($toDo);
    }
    /**
     * Get Cause value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCause()
    {
        return isset($this->Cause) ? $this->Cause : null;
    }
    /**
     * Set Cause value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cause
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CbpFaultDetail
     */
    public function setCause($cause = null)
    {
        // validation for constraint: string
        if (!is_null($cause) && !is_string($cause)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cause, true), gettype($cause)), __LINE__);
        }
        if (is_null($cause) || (is_array($cause) && empty($cause))) {
            unset($this->Cause);
        } else {
            $this->Cause = $cause;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CbpFaultDetail
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId()
    {
        return isset($this->Id) ? $this->Id : null;
    }
    /**
     * Set Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CbpFaultDetail
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->Id);
        } else {
            $this->Id = $id;
        }
        return $this;
    }
    /**
     * Get Message value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMessage()
    {
        return isset($this->Message) ? $this->Message : null;
    }
    /**
     * Set Message value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $message
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CbpFaultDetail
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        if (is_null($message) || (is_array($message) && empty($message))) {
            unset($this->Message);
        } else {
            $this->Message = $message;
        }
        return $this;
    }
    /**
     * Get SourceLocation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSourceLocation()
    {
        return isset($this->SourceLocation) ? $this->SourceLocation : null;
    }
    /**
     * Set SourceLocation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sourceLocation
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CbpFaultDetail
     */
    public function setSourceLocation($sourceLocation = null)
    {
        // validation for constraint: string
        if (!is_null($sourceLocation) && !is_string($sourceLocation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sourceLocation, true), gettype($sourceLocation)), __LINE__);
        }
        if (is_null($sourceLocation) || (is_array($sourceLocation) && empty($sourceLocation))) {
            unset($this->SourceLocation);
        } else {
            $this->SourceLocation = $sourceLocation;
        }
        return $this;
    }
    /**
     * Get ToDo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getToDo()
    {
        return isset($this->ToDo) ? $this->ToDo : null;
    }
    /**
     * Set ToDo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $toDo
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CbpFaultDetail
     */
    public function setToDo($toDo = null)
    {
        // validation for constraint: string
        if (!is_null($toDo) && !is_string($toDo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($toDo, true), gettype($toDo)), __LINE__);
        }
        if (is_null($toDo) || (is_array($toDo) && empty($toDo))) {
            unset($this->ToDo);
        } else {
            $this->ToDo = $toDo;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CbpFaultDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
