<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateExternCard StructType
 * Meta information extracted from the WSDL
 * - documentation: [Ajouté 2016/04 - V1110] [Bêta] - Permet la création d'une carte de fidélité provenant d’un système externe
 * @subpackage Structs
 */
class CreateExternCard extends AbstractStructBase
{
    /**
     * The CreateExternCardRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest
     */
    public $CreateExternCardRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for CreateExternCard
     * @uses CreateExternCard::setCreateExternCardRequest()
     * @uses CreateExternCard::setClientContext()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest $createExternCardRequest
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest $createExternCardRequest = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setCreateExternCardRequest($createExternCardRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get CreateExternCardRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest|null
     */
    public function getCreateExternCardRequest()
    {
        return isset($this->CreateExternCardRequest) ? $this->CreateExternCardRequest : null;
    }
    /**
     * Set CreateExternCardRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest $createExternCardRequest
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCard
     */
    public function setCreateExternCardRequest(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCardRequest $createExternCardRequest = null)
    {
        if (is_null($createExternCardRequest) || (is_array($createExternCardRequest) && empty($createExternCardRequest))) {
            unset($this->CreateExternCardRequest);
        } else {
            $this->CreateExternCardRequest = $createExternCardRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCard
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateExternCard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
