<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateLoyaltyCardResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Permet la création d'une carte de fidélité.
 * @subpackage Structs
 */
class CreateLoyaltyCardResponse extends AbstractStructBase
{
    /**
     * The CreateLoyaltyCardResult
     * Meta information extracted from the WSDL
     * - documentation: Renvoie le numéro de la carte générée. - Relatif à la colonne [MCARETFIDENT.MFC_NUMCARTE]
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CreateLoyaltyCardResult;
    /**
     * Constructor method for CreateLoyaltyCardResponse
     * @uses CreateLoyaltyCardResponse::setCreateLoyaltyCardResult()
     * @param string $createLoyaltyCardResult
     */
    public function __construct($createLoyaltyCardResult = null)
    {
        $this
            ->setCreateLoyaltyCardResult($createLoyaltyCardResult);
    }
    /**
     * Get CreateLoyaltyCardResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCreateLoyaltyCardResult()
    {
        return isset($this->CreateLoyaltyCardResult) ? $this->CreateLoyaltyCardResult : null;
    }
    /**
     * Set CreateLoyaltyCardResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $createLoyaltyCardResult
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCardResponse
     */
    public function setCreateLoyaltyCardResult($createLoyaltyCardResult = null)
    {
        // validation for constraint: string
        if (!is_null($createLoyaltyCardResult) && !is_string($createLoyaltyCardResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createLoyaltyCardResult, true), gettype($createLoyaltyCardResult)), __LINE__);
        }
        if (is_null($createLoyaltyCardResult) || (is_array($createLoyaltyCardResult) && empty($createLoyaltyCardResult))) {
            unset($this->CreateLoyaltyCardResult);
        } else {
            $this->CreateLoyaltyCardResult = $createLoyaltyCardResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CreateLoyaltyCardResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
