<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerCards StructType
 * Meta information extracted from the WSDL
 * - documentation: [Ajouté 2013/04 - V1102] - Renvoie la liste des cartes de fidélité associées à un client.
 * @subpackage Structs
 */
class GetCustomerCards extends AbstractStructBase
{
    /**
     * The customerCardsRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest
     */
    public $customerCardsRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for GetCustomerCards
     * @uses GetCustomerCards::setCustomerCardsRequest()
     * @uses GetCustomerCards::setClientContext()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest $customerCardsRequest
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest $customerCardsRequest = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setCustomerCardsRequest($customerCardsRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get customerCardsRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest|null
     */
    public function getCustomerCardsRequest()
    {
        return isset($this->customerCardsRequest) ? $this->customerCardsRequest : null;
    }
    /**
     * Set customerCardsRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest $customerCardsRequest
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCards
     */
    public function setCustomerCardsRequest(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsRequest $customerCardsRequest = null)
    {
        if (is_null($customerCardsRequest) || (is_array($customerCardsRequest) && empty($customerCardsRequest))) {
            unset($this->customerCardsRequest);
        } else {
            $this->customerCardsRequest = $customerCardsRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCards
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCards
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
