<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetLoyaltyPointsForSale StructType
 * Meta information extracted from the WSDL
 * - documentation: [Ajouté 2013/05 - V1102] - Retourne les points de fidélité gagnés pour un document de vente existant.
 * @subpackage Structs
 */
class GetLoyaltyPointsForSale extends AbstractStructBase
{
    /**
     * The loyaltyPointsForSaleRequest
     * Meta information extracted from the WSDL
     * - documentation: Paramètres de requête
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier
     */
    public $loyaltyPointsForSaleRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for GetLoyaltyPointsForSale
     * @uses GetLoyaltyPointsForSale::setLoyaltyPointsForSaleRequest()
     * @uses GetLoyaltyPointsForSale::setClientContext()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier $loyaltyPointsForSaleRequest
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier $loyaltyPointsForSaleRequest = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setLoyaltyPointsForSaleRequest($loyaltyPointsForSaleRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get loyaltyPointsForSaleRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier|null
     */
    public function getLoyaltyPointsForSaleRequest()
    {
        return isset($this->loyaltyPointsForSaleRequest) ? $this->loyaltyPointsForSaleRequest : null;
    }
    /**
     * Set loyaltyPointsForSaleRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier $loyaltyPointsForSaleRequest
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSale
     */
    public function setLoyaltyPointsForSaleRequest(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentIdentifier $loyaltyPointsForSaleRequest = null)
    {
        if (is_null($loyaltyPointsForSaleRequest) || (is_array($loyaltyPointsForSaleRequest) && empty($loyaltyPointsForSaleRequest))) {
            unset($this->loyaltyPointsForSaleRequest);
        } else {
            $this->loyaltyPointsForSaleRequest = $loyaltyPointsForSaleRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSale
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSale
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
