<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProgramCardGet StructType
 * Meta information extracted from the WSDL
 * - documentation: Programme de fidélité associé à la carte.
 * - nillable: true
 * - type: tns:ProgramCardGet
 * @subpackage Structs
 */
class ProgramCardGet extends AbstractStructBase
{
    /**
     * The Closed
     * Meta information extracted from the WSDL
     * - documentation: Programme fermé. - Relatif à la colonne [MPROGFIDELITE.MFP_FERME].
     * - minOccurs: 0
     * @var bool
     */
    public $Closed;
    /**
     * The CurrencyId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la devise du programme. - Relatif à la colonne [MPROGFIDELITE.MFP_DEVISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CurrencyId;
    /**
     * The ExpiracyDate
     * Meta information extracted from the WSDL
     * - documentation: Date d'expiration. - Relatif à la colonne [MPROGFIDELITE.MFP_DATEPROGFIN].
     * - minOccurs: 0
     * @var string
     */
    public $ExpiracyDate;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du programme. - Relatif à la colonne [MPROGFIDELITE.MFP_PROGFIDELITE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Id;
    /**
     * The Label
     * Meta information extracted from the WSDL
     * - documentation: Libellé du programme. - Relatif à la colonne [MPROGFIDELITE.MFP_LIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Label;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - documentation: Type du programme. - Relatif à la colonne [MPROGFIDELITE.TYPECUMULFID2].
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * Constructor method for ProgramCardGet
     * @uses ProgramCardGet::setClosed()
     * @uses ProgramCardGet::setCurrencyId()
     * @uses ProgramCardGet::setExpiracyDate()
     * @uses ProgramCardGet::setId()
     * @uses ProgramCardGet::setLabel()
     * @uses ProgramCardGet::setType()
     * @param bool $closed
     * @param string $currencyId
     * @param string $expiracyDate
     * @param string $id
     * @param string $label
     * @param string $type
     */
    public function __construct($closed = null, $currencyId = null, $expiracyDate = null, $id = null, $label = null, $type = null)
    {
        $this
            ->setClosed($closed)
            ->setCurrencyId($currencyId)
            ->setExpiracyDate($expiracyDate)
            ->setId($id)
            ->setLabel($label)
            ->setType($type);
    }
    /**
     * Get Closed value
     * @return bool|null
     */
    public function getClosed()
    {
        return $this->Closed;
    }
    /**
     * Set Closed value
     * @param bool $closed
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public function setClosed($closed = null)
    {
        // validation for constraint: boolean
        if (!is_null($closed) && !is_bool($closed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($closed, true), gettype($closed)), __LINE__);
        }
        $this->Closed = $closed;
        return $this;
    }
    /**
     * Get CurrencyId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrencyId()
    {
        return isset($this->CurrencyId) ? $this->CurrencyId : null;
    }
    /**
     * Set CurrencyId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currencyId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public function setCurrencyId($currencyId = null)
    {
        // validation for constraint: string
        if (!is_null($currencyId) && !is_string($currencyId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencyId, true), gettype($currencyId)), __LINE__);
        }
        if (is_null($currencyId) || (is_array($currencyId) && empty($currencyId))) {
            unset($this->CurrencyId);
        } else {
            $this->CurrencyId = $currencyId;
        }
        return $this;
    }
    /**
     * Get ExpiracyDate value
     * @return string|null
     */
    public function getExpiracyDate()
    {
        return $this->ExpiracyDate;
    }
    /**
     * Set ExpiracyDate value
     * @param string $expiracyDate
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public function setExpiracyDate($expiracyDate = null)
    {
        // validation for constraint: string
        if (!is_null($expiracyDate) && !is_string($expiracyDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiracyDate, true), gettype($expiracyDate)), __LINE__);
        }
        $this->ExpiracyDate = $expiracyDate;
        return $this;
    }
    /**
     * Get Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId()
    {
        return isset($this->Id) ? $this->Id : null;
    }
    /**
     * Set Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->Id);
        } else {
            $this->Id = $id;
        }
        return $this;
    }
    /**
     * Get Label value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabel()
    {
        return isset($this->Label) ? $this->Label : null;
    }
    /**
     * Set Label value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $label
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        if (is_null($label) || (is_array($label) && empty($label))) {
            unset($this->Label);
        } else {
            $this->Label = $label;
        }
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\LoyaltyProgramType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\LoyaltyProgramType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\LoyaltyProgramType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\LoyaltyProgramType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\LoyaltyProgramType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\ProgramCardGet
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
