<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaleDocumentKey StructType
 * Meta information extracted from the WSDL
 * - documentation: Clé identifiant le document de vente.
 * - nillable: true
 * - type: tns:SaleDocumentKey
 * @subpackage Structs
 */
class SaleDocumentKey extends AbstractStructBase
{
    /**
     * The Number
     * Meta information extracted from the WSDL
     * - documentation: Numéro - Relatif à la colonne [PIECE.GP_NUMERO].
     * - minOccurs: 0
     * @var int
     */
    public $Number;
    /**
     * The Stump
     * Meta information extracted from the WSDL
     * - documentation: Souche - Relatif à la colonne [PIECE.GP_SOUCHE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Stump;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - documentation: Type de document - Relatif à la colonne [PIECE.GP_NATUREPIECEG].
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * Constructor method for SaleDocumentKey
     * @uses SaleDocumentKey::setNumber()
     * @uses SaleDocumentKey::setStump()
     * @uses SaleDocumentKey::setType()
     * @param int $number
     * @param string $stump
     * @param string $type
     */
    public function __construct($number = null, $stump = null, $type = null)
    {
        $this
            ->setNumber($number)
            ->setStump($stump)
            ->setType($type);
    }
    /**
     * Get Number value
     * @return int|null
     */
    public function getNumber()
    {
        return $this->Number;
    }
    /**
     * Set Number value
     * @param int $number
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey
     */
    public function setNumber($number = null)
    {
        // validation for constraint: int
        if (!is_null($number) && !(is_int($number) || ctype_digit($number))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->Number = $number;
        return $this;
    }
    /**
     * Get Stump value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStump()
    {
        return isset($this->Stump) ? $this->Stump : null;
    }
    /**
     * Set Stump value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stump
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey
     */
    public function setStump($stump = null)
    {
        // validation for constraint: string
        if (!is_null($stump) && !is_string($stump)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stump, true), gettype($stump)), __LINE__);
        }
        if (is_null($stump) || (is_array($stump) && empty($stump))) {
            unset($this->Stump);
        } else {
            $this->Stump = $stump;
        }
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\SaleDocumentType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\SaleDocumentType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\SaleDocumentType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\SaleDocumentType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \FiloBlu\CegidY2\Api\LoyaltyWcfService\EnumType\SaleDocumentType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\SaleDocumentKey
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
