<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateCardIdRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Mise à jour du numéro de carte de fidélité
 * - nillable: true
 * - type: tns:UpdateCardIdRequest
 * @subpackage Structs
 */
class UpdateCardIdRequest extends AbstractStructBase
{
    /**
     * The LoyaltyCardId
     * Meta information extracted from the WSDL
     * - documentation: Numéro de la carte de fidélité - Relatif à la colonne [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoyaltyCardId;
    /**
     * The NewLoyaltyCardId
     * Meta information extracted from the WSDL
     * - documentation: Nouveau numéro de la carte de fidélité - Relatif à la colonne [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NewLoyaltyCardId;
    /**
     * Constructor method for UpdateCardIdRequest
     * @uses UpdateCardIdRequest::setLoyaltyCardId()
     * @uses UpdateCardIdRequest::setNewLoyaltyCardId()
     * @param string $loyaltyCardId
     * @param string $newLoyaltyCardId
     */
    public function __construct($loyaltyCardId = null, $newLoyaltyCardId = null)
    {
        $this
            ->setLoyaltyCardId($loyaltyCardId)
            ->setNewLoyaltyCardId($newLoyaltyCardId);
    }
    /**
     * Get LoyaltyCardId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoyaltyCardId()
    {
        return isset($this->LoyaltyCardId) ? $this->LoyaltyCardId : null;
    }
    /**
     * Set LoyaltyCardId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loyaltyCardId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateCardIdRequest
     */
    public function setLoyaltyCardId($loyaltyCardId = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyCardId) && !is_string($loyaltyCardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loyaltyCardId, true), gettype($loyaltyCardId)), __LINE__);
        }
        if (is_null($loyaltyCardId) || (is_array($loyaltyCardId) && empty($loyaltyCardId))) {
            unset($this->LoyaltyCardId);
        } else {
            $this->LoyaltyCardId = $loyaltyCardId;
        }
        return $this;
    }
    /**
     * Get NewLoyaltyCardId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNewLoyaltyCardId()
    {
        return isset($this->NewLoyaltyCardId) ? $this->NewLoyaltyCardId : null;
    }
    /**
     * Set NewLoyaltyCardId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $newLoyaltyCardId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateCardIdRequest
     */
    public function setNewLoyaltyCardId($newLoyaltyCardId = null)
    {
        // validation for constraint: string
        if (!is_null($newLoyaltyCardId) && !is_string($newLoyaltyCardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newLoyaltyCardId, true), gettype($newLoyaltyCardId)), __LINE__);
        }
        if (is_null($newLoyaltyCardId) || (is_array($newLoyaltyCardId) && empty($newLoyaltyCardId))) {
            unset($this->NewLoyaltyCardId);
        } else {
            $this->NewLoyaltyCardId = $newLoyaltyCardId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateCardIdRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
