<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdatePoints StructType
 * Meta information extracted from the WSDL
 * - documentation: [Ajouté 2013/10 - V1104] [Bêta] - Permet la mise à jour des points d'une carte de fidélité donnée.
 * @subpackage Structs
 */
class UpdatePoints extends AbstractStructBase
{
    /**
     * The updatePointsRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest
     */
    public $updatePointsRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for UpdatePoints
     * @uses UpdatePoints::setUpdatePointsRequest()
     * @uses UpdatePoints::setClientContext()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest $updatePointsRequest
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest $updatePointsRequest = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setUpdatePointsRequest($updatePointsRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get updatePointsRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest|null
     */
    public function getUpdatePointsRequest()
    {
        return isset($this->updatePointsRequest) ? $this->updatePointsRequest : null;
    }
    /**
     * Set updatePointsRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest $updatePointsRequest
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePoints
     */
    public function setUpdatePointsRequest(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePointsRequest $updatePointsRequest = null)
    {
        if (is_null($updatePointsRequest) || (is_array($updatePointsRequest) && empty($updatePointsRequest))) {
            unset($this->updatePointsRequest);
        } else {
            $this->updatePointsRequest = $updatePointsRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePoints
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdatePoints
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
