<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpdate_ShippingTax ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUpdate_ShippingTax
 * @subpackage Arrays
 */
class ArrayOfUpdate_ShippingTax extends AbstractStructArrayBase
{
    /**
     * The Update_ShippingTax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax[]
     */
    public $Update_ShippingTax;
    /**
     * Constructor method for ArrayOfUpdate_ShippingTax
     * @uses ArrayOfUpdate_ShippingTax::setUpdate_ShippingTax()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax[] $update_ShippingTax
     */
    public function __construct(array $update_ShippingTax = array())
    {
        $this
            ->setUpdate_ShippingTax($update_ShippingTax);
    }
    /**
     * Get Update_ShippingTax value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax[]|null
     */
    public function getUpdate_ShippingTax()
    {
        return isset($this->Update_ShippingTax) ? $this->Update_ShippingTax : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdate_ShippingTax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdate_ShippingTax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdate_ShippingTaxForArrayConstraintsFromSetUpdate_ShippingTax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUpdate_ShippingTaxUpdate_ShippingTaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpdate_ShippingTaxUpdate_ShippingTaxItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax) {
                $invalidValues[] = is_object($arrayOfUpdate_ShippingTaxUpdate_ShippingTaxItem) ? get_class($arrayOfUpdate_ShippingTaxUpdate_ShippingTaxItem) : sprintf('%s(%s)', gettype($arrayOfUpdate_ShippingTaxUpdate_ShippingTaxItem), var_export($arrayOfUpdate_ShippingTaxUpdate_ShippingTaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Update_ShippingTax property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Update_ShippingTax value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax[] $update_ShippingTax
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax
     */
    public function setUpdate_ShippingTax(array $update_ShippingTax = array())
    {
        // validation for constraint: array
        if ('' !== ($update_ShippingTaxArrayErrorMessage = self::validateUpdate_ShippingTaxForArrayConstraintsFromSetUpdate_ShippingTax($update_ShippingTax))) {
            throw new \InvalidArgumentException($update_ShippingTaxArrayErrorMessage, __LINE__);
        }
        if (is_null($update_ShippingTax) || (is_array($update_ShippingTax) && empty($update_ShippingTax))) {
            unset($this->Update_ShippingTax);
        } else {
            $this->Update_ShippingTax = $update_ShippingTax;
        }
        return $this;
    }
    /**
     * Add item to Update_ShippingTax value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax
     */
    public function addToUpdate_ShippingTax(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax) {
            throw new \InvalidArgumentException(sprintf('The Update_ShippingTax property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Update_ShippingTax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_ShippingTax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Update_ShippingTax
     */
    public function getAttributeName()
    {
        return 'Update_ShippingTax';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
