<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for FollowUpStatus EnumType
 * Meta information extracted from the WSDL
 * - documentation: e-Commerce follow-up status
 * - nillable: true
 * - type: tns:FollowUpStatus
 * @subpackage Enumerations
 */
class FollowUpStatus
{
    /**
     * Constant for value 'ToBeProcessed'
     * Meta information extracted from the WSDL
     * - documentation: To process.
     * @return string 'ToBeProcessed'
     */
    const VALUE_TO_BE_PROCESSED = 'ToBeProcessed';
    /**
     * Constant for value 'Validated'
     * Meta information extracted from the WSDL
     * - documentation: Validated.
     * @return string 'Validated'
     */
    const VALUE_VALIDATED = 'Validated';
    /**
     * Constant for value 'ToSupplyInCentral'
     * Meta information extracted from the WSDL
     * - documentation: To supply at Headquarters.
     * @return string 'ToSupplyInCentral'
     */
    const VALUE_TO_SUPPLY_IN_CENTRAL = 'ToSupplyInCentral';
    /**
     * Constant for value 'ToSupplyInStore'
     * Meta information extracted from the WSDL
     * - documentation: Requested at Headquarters.
     * @return string 'ToSupplyInStore'
     */
    const VALUE_TO_SUPPLY_IN_STORE = 'ToSupplyInStore';
    /**
     * Constant for value 'ToBeDeliveredByStore'
     * Meta information extracted from the WSDL
     * - documentation: To deliver by the store.
     * @return string 'ToBeDeliveredByStore'
     */
    const VALUE_TO_BE_DELIVERED_BY_STORE = 'ToBeDeliveredByStore';
    /**
     * Constant for value 'InPreparation'
     * Meta information extracted from the WSDL
     * - documentation: Preparation in progress.
     * @return string 'InPreparation'
     */
    const VALUE_IN_PREPARATION = 'InPreparation';
    /**
     * Constant for value 'Prepared'
     * Meta information extracted from the WSDL
     * - documentation: Prepared.
     * @return string 'Prepared'
     */
    const VALUE_PREPARED = 'Prepared';
    /**
     * Constant for value 'ShipByCentral'
     * Meta information extracted from the WSDL
     * - documentation: Sent.
     * @return string 'ShipByCentral'
     */
    const VALUE_SHIP_BY_CENTRAL = 'ShipByCentral';
    /**
     * Constant for value 'ShipByLogistic'
     * Meta information extracted from the WSDL
     * - documentation: Sent by logistician.
     * @return string 'ShipByLogistic'
     */
    const VALUE_SHIP_BY_LOGISTIC = 'ShipByLogistic';
    /**
     * Constant for value 'ShipByStore'
     * Meta information extracted from the WSDL
     * - documentation: Sent from store.
     * @return string 'ShipByStore'
     */
    const VALUE_SHIP_BY_STORE = 'ShipByStore';
    /**
     * Constant for value 'RequestedStoreBooking'
     * Meta information extracted from the WSDL
     * - documentation: Requested in store.
     * @return string 'RequestedStoreBooking'
     */
    const VALUE_REQUESTED_STORE_BOOKING = 'RequestedStoreBooking';
    /**
     * Constant for value 'BookedInStore'
     * Meta information extracted from the WSDL
     * - documentation: Reserved in store.
     * @return string 'BookedInStore'
     */
    const VALUE_BOOKED_IN_STORE = 'BookedInStore';
    /**
     * Constant for value 'PickedUpInStore'
     * Meta information extracted from the WSDL
     * - documentation: Picked up in store.
     * @return string 'PickedUpInStore'
     */
    const VALUE_PICKED_UP_IN_STORE = 'PickedUpInStore';
    /**
     * Constant for value 'Closed'
     * Meta information extracted from the WSDL
     * - documentation: Closed.
     * @return string 'Closed'
     */
    const VALUE_CLOSED = 'Closed';
    /**
     * Constant for value 'TransferedInStore'
     * Meta information extracted from the WSDL
     * - documentation: Transferred to store.
     * @return string 'TransferedInStore'
     */
    const VALUE_TRANSFERED_IN_STORE = 'TransferedInStore';
    /**
     * Constant for value 'AvailableInStore'
     * Meta information extracted from the WSDL
     * - documentation: Available in store.
     * @return string 'AvailableInStore'
     */
    const VALUE_AVAILABLE_IN_STORE = 'AvailableInStore';
    /**
     * Constant for value 'BookingRefused'
     * Meta information extracted from the WSDL
     * - documentation: Merchandise request denied.
     * @return string 'BookingRefused'
     */
    const VALUE_BOOKING_REFUSED = 'BookingRefused';
    /**
     * Constant for value 'Ordered'
     * Meta information extracted from the WSDL
     * - documentation: Ordered.
     * @return string 'Ordered'
     */
    const VALUE_ORDERED = 'Ordered';
    /**
     * Constant for value 'GoodTakenOut'
     * Meta information extracted from the WSDL
     * - documentation: Goods picked up.
     * @return string 'GoodTakenOut'
     */
    const VALUE_GOOD_TAKEN_OUT = 'GoodTakenOut';
    /**
     * Constant for value 'RecievedByCustomer'
     * Meta information extracted from the WSDL
     * - documentation: Accepted by the customer.
     * @return string 'RecievedByCustomer'
     */
    const VALUE_RECIEVED_BY_CUSTOMER = 'RecievedByCustomer';
    /**
     * Constant for value 'Booked'
     * Meta information extracted from the WSDL
     * - documentation: Reserved.
     * @return string 'Booked'
     */
    const VALUE_BOOKED = 'Booked';
    /**
     * Constant for value 'AvailableInWarehouse'
     * Meta information extracted from the WSDL
     * - documentation: Available in warehouse.
     * @return string 'AvailableInWarehouse'
     */
    const VALUE_AVAILABLE_IN_WAREHOUSE = 'AvailableInWarehouse';
    /**
     * Constant for value 'WaitingForReturn'
     * Meta information extracted from the WSDL
     * - documentation: Awaiting return.
     * @return string 'WaitingForReturn'
     */
    const VALUE_WAITING_FOR_RETURN = 'WaitingForReturn';
    /**
     * Constant for value 'AcceptedOrder'
     * Meta information extracted from the WSDL
     * - documentation: Order accepted.
     * @return string 'AcceptedOrder'
     */
    const VALUE_ACCEPTED_ORDER = 'AcceptedOrder';
    /**
     * Constant for value 'WaitingCommodity'
     * Meta information extracted from the WSDL
     * - documentation: Awaiting goods.
     * @return string 'WaitingCommodity'
     */
    const VALUE_WAITING_COMMODITY = 'WaitingCommodity';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_TO_BE_PROCESSED
     * @uses self::VALUE_VALIDATED
     * @uses self::VALUE_TO_SUPPLY_IN_CENTRAL
     * @uses self::VALUE_TO_SUPPLY_IN_STORE
     * @uses self::VALUE_TO_BE_DELIVERED_BY_STORE
     * @uses self::VALUE_IN_PREPARATION
     * @uses self::VALUE_PREPARED
     * @uses self::VALUE_SHIP_BY_CENTRAL
     * @uses self::VALUE_SHIP_BY_LOGISTIC
     * @uses self::VALUE_SHIP_BY_STORE
     * @uses self::VALUE_REQUESTED_STORE_BOOKING
     * @uses self::VALUE_BOOKED_IN_STORE
     * @uses self::VALUE_PICKED_UP_IN_STORE
     * @uses self::VALUE_CLOSED
     * @uses self::VALUE_TRANSFERED_IN_STORE
     * @uses self::VALUE_AVAILABLE_IN_STORE
     * @uses self::VALUE_BOOKING_REFUSED
     * @uses self::VALUE_ORDERED
     * @uses self::VALUE_GOOD_TAKEN_OUT
     * @uses self::VALUE_RECIEVED_BY_CUSTOMER
     * @uses self::VALUE_BOOKED
     * @uses self::VALUE_AVAILABLE_IN_WAREHOUSE
     * @uses self::VALUE_WAITING_FOR_RETURN
     * @uses self::VALUE_ACCEPTED_ORDER
     * @uses self::VALUE_WAITING_COMMODITY
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_TO_BE_PROCESSED,
            self::VALUE_VALIDATED,
            self::VALUE_TO_SUPPLY_IN_CENTRAL,
            self::VALUE_TO_SUPPLY_IN_STORE,
            self::VALUE_TO_BE_DELIVERED_BY_STORE,
            self::VALUE_IN_PREPARATION,
            self::VALUE_PREPARED,
            self::VALUE_SHIP_BY_CENTRAL,
            self::VALUE_SHIP_BY_LOGISTIC,
            self::VALUE_SHIP_BY_STORE,
            self::VALUE_REQUESTED_STORE_BOOKING,
            self::VALUE_BOOKED_IN_STORE,
            self::VALUE_PICKED_UP_IN_STORE,
            self::VALUE_CLOSED,
            self::VALUE_TRANSFERED_IN_STORE,
            self::VALUE_AVAILABLE_IN_STORE,
            self::VALUE_BOOKING_REFUSED,
            self::VALUE_ORDERED,
            self::VALUE_GOOD_TAKEN_OUT,
            self::VALUE_RECIEVED_BY_CUSTOMER,
            self::VALUE_BOOKED,
            self::VALUE_AVAILABLE_IN_WAREHOUSE,
            self::VALUE_WAITING_FOR_RETURN,
            self::VALUE_ACCEPTED_ORDER,
            self::VALUE_WAITING_COMMODITY,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
