<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for SaleDocumentType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Sales document type
 * - nillable: true
 * - type: tns:SaleDocumentType
 * @subpackage Enumerations
 */
class SaleDocumentType
{
    /**
     * Constant for value 'ReturnNotice'
     * Meta information extracted from the WSDL
     * - documentation: Return notice.
     * @return string 'ReturnNotice'
     */
    const VALUE_RETURN_NOTICE = 'ReturnNotice';
    /**
     * Constant for value 'CustomerDelivery'
     * Meta information extracted from the WSDL
     * - documentation: Customer delivery.
     * @return string 'CustomerDelivery'
     */
    const VALUE_CUSTOMER_DELIVERY = 'CustomerDelivery';
    /**
     * Constant for value 'CustomerOrder'
     * Meta information extracted from the WSDL
     * - documentation: Customer order.
     * @return string 'CustomerOrder'
     */
    const VALUE_CUSTOMER_ORDER = 'CustomerOrder';
    /**
     * Constant for value 'AvailableOrder'
     * Meta information extracted from the WSDL
     * - documentation: Available order.
     * @return string 'AvailableOrder'
     */
    const VALUE_AVAILABLE_ORDER = 'AvailableOrder';
    /**
     * Constant for value 'CustomerReservationRequest'
     * Meta information extracted from the WSDL
     * - documentation: Customer reservation requests. Usable only when viewing sales documents. .
     * @return string 'CustomerReservationRequest'
     */
    const VALUE_CUSTOMER_RESERVATION_REQUEST = 'CustomerReservationRequest';
    /**
     * Constant for value 'ReceiptOnHold'
     * Meta information extracted from the WSDL
     * - documentation: Receipt on hold.
     * @return string 'ReceiptOnHold'
     */
    const VALUE_RECEIPT_ON_HOLD = 'ReceiptOnHold';
    /**
     * Constant for value 'Receipt'
     * Meta information extracted from the WSDL
     * - documentation: Receipt.
     * @return string 'Receipt'
     */
    const VALUE_RECEIPT = 'Receipt';
    /**
     * Constant for value 'DeliveryPreparation'
     * Meta information extracted from the WSDL
     * - documentation: Delivery worksheet.
     * @return string 'DeliveryPreparation'
     */
    const VALUE_DELIVERY_PREPARATION = 'DeliveryPreparation';
    /**
     * Constant for value 'CustomersReservation'
     * Meta information extracted from the WSDL
     * - documentation: Customer reservations. Usable only when viewing sales documents. .
     * @return string 'CustomersReservation'
     */
    const VALUE_CUSTOMERS_RESERVATION = 'CustomersReservation';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_RETURN_NOTICE
     * @uses self::VALUE_CUSTOMER_DELIVERY
     * @uses self::VALUE_CUSTOMER_ORDER
     * @uses self::VALUE_AVAILABLE_ORDER
     * @uses self::VALUE_CUSTOMER_RESERVATION_REQUEST
     * @uses self::VALUE_RECEIPT_ON_HOLD
     * @uses self::VALUE_RECEIPT
     * @uses self::VALUE_DELIVERY_PREPARATION
     * @uses self::VALUE_CUSTOMERS_RESERVATION
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_RETURN_NOTICE,
            self::VALUE_CUSTOMER_DELIVERY,
            self::VALUE_CUSTOMER_ORDER,
            self::VALUE_AVAILABLE_ORDER,
            self::VALUE_CUSTOMER_RESERVATION_REQUEST,
            self::VALUE_RECEIPT_ON_HOLD,
            self::VALUE_RECEIPT,
            self::VALUE_DELIVERY_PREPARATION,
            self::VALUE_CUSTOMERS_RESERVATION,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
