<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for UserDefinedId EnumType
 * Meta information extracted from the WSDL
 * - documentation: Identifiant de donnée libre (Date /Table/Texte/Booléen/Nombre)
 * - nillable: true
 * - type: tns:UserDefinedId
 * @subpackage Enumerations
 */
class UserDefinedId
{
    /**
     * Constant for value '1'
     * Meta information extracted from the WSDL
     * - documentation: Donnée libre (Date/Table/Texte/Booléen/Nombre) n°1.
     * @return string '1'
     */
    const VALUE_1 = '1';
    /**
     * Constant for value '2'
     * Meta information extracted from the WSDL
     * - documentation: Donnée libre (Date/Table/Texte/Booléen/Nombre) n°2.
     * @return string '2'
     */
    const VALUE_2 = '2';
    /**
     * Constant for value '3'
     * Meta information extracted from the WSDL
     * - documentation: Donnée libre (Date/Table/Texte/Booléen/Nombre) n°3.
     * @return string '3'
     */
    const VALUE_3 = '3';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_1
     * @uses self::VALUE_2
     * @uses self::VALUE_3
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_1,
            self::VALUE_2,
            self::VALUE_3,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
