<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Customers ServiceType
 * @subpackage Services
 */
class Customers extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CustomersReservationCreate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/05 - V1110] [Bêta] - Permet la création d'une réservation client.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreateResponse|bool
     */
    public function CustomersReservationCreate(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CustomersReservationCreate($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreateResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
