<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetHeaderList
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Permet d'obtenir la liste de l'historique de vente (entête) d'un client. La liste est triée par dates décroissantes. La restriction 'Consultation des ventes d’un client' est appliquée dans le calcul
     * de cet historique.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderListResponse|bool
     */
    public function GetHeaderList(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetHeaderList($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetByKey
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Permet d'obtenir un document de vente en fonction de sa clé unique. | Renvoie le document de vente.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKeyResponse|bool
     */
    public function GetByKey(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetByKey($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetByReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Permet d'obtenir un document de vente en fonction de sa référence client.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReference $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReferenceResponse|bool
     */
    public function GetByReference(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReference $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetByReference($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetByExternalReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Permet d'obtenir une liste de documents de vente en fonction d'une référence externe.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReference $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReferenceResponse|bool
     */
    public function GetByExternalReference(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReference $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetByExternalReference($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByExternalReferenceResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKeyResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReferenceResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderListResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
