<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Update ServiceType
 * @subpackage Services
 */
class Update extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Update
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Permet la modification d'un document de vente. Annule et remplace le document d'origine tout en conservant ses identifiants. Le document ne doit pas avoir de lien vers d'autres pièces. Pour mettre à jour
     * des règlements percus existants, utiliser la méthode UpdatePayments
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateResponse|bool
     */
    public function Update(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->Update($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UpdatePayments
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1105] - Permet la modification des paiments d'un document de vente.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePaymentsResponse|bool
     */
    public function UpdatePayments(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePayments $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdatePayments($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named UpdateHeader
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/04 - V1102] - Permet la modification des éléments de l'entête d'un document de vente.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeaderResponse|bool
     */
    public function UpdateHeader(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->UpdateHeader($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeaderResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdatePaymentsResponse|\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
