<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Address StructType
 * Meta information extracted from the WSDL
 * - documentation: Données de l'adresse de livraison ou de facturation d'un document.
 * - nillable: true
 * - type: tns:Address
 * @subpackage Structs
 */
class Address extends AbstractStructBase
{
    /**
     * The City
     * Meta information extracted from the WSDL
     * - documentation: Ville de l'adresse. - Relatif à la colonne [PIECEADRESSE.GPA_VILLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $City;
    /**
     * The ContactNumber
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2016/03 - V1201] [Optionnel] - Numéro du contact. 0 = pas de contact. - Relatif à la colonne [PIECEADRESSE.GPA_NUMEROCONTACT ].
     * - minOccurs: 0
     * @var int
     */
    public $ContactNumber;
    /**
     * The CountryId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du pays. - Relatif à la colonne [PIECEADRESSE.GPA_PAYS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CountryId;
    /**
     * The CountryIdType
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du type du pays - Relatif à la colonne [PIECEADRESSE.GPA_PAYS].
     * - minOccurs: 0
     * @var string
     */
    public $CountryIdType;
    /**
     * The FirstName
     * Meta information extracted from the WSDL
     * - documentation: Raison sociale suite ou prénom du tiers. - Relatif à la colonne [PIECEADRESSE.GPA_LIBELLE2].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FirstName;
    /**
     * The LastName
     * Meta information extracted from the WSDL
     * - documentation: Raison sociale ou nom du tiers. - Relatif à la colonne [PIECEADRESSE.GPA_LIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LastName;
    /**
     * The Line1
     * Meta information extracted from the WSDL
     * - documentation: 1ère ligne d'adresse. - Relatif à la colonne [PIECEADRESSE.GPA_ADRESSE1].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Line1;
    /**
     * The Line2
     * Meta information extracted from the WSDL
     * - documentation: 2ème ligne d'adresse. - Relatif à la colonne [PIECEADRESSE.GPA_ADRESSE2].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Line2;
    /**
     * The Line3
     * Meta information extracted from the WSDL
     * - documentation: 3ème ligne d'adresse. - Relatif à la colonne [PIECEADRESSE.GPA_ADRESSE3].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Line3;
    /**
     * The PhoneNumber
     * Meta information extracted from the WSDL
     * - documentation: Téléphone défini à cette adresse. - Relatif à la colonne [PIECEADRESSE.GPA_TELEPHONE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PhoneNumber;
    /**
     * The Region
     * Meta information extracted from the WSDL
     * - documentation: Région - Relatif à la colonne [PIECEADRESSE.GPA_REGION].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Region;
    /**
     * The TitleId
     * Meta information extracted from the WSDL
     * - documentation: Forme juridique ou civilité du tiers. - Relatif à la colonne [PIECEADRESSE.GPA_JURIDIQUE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TitleId;
    /**
     * The ZipCode
     * Meta information extracted from the WSDL
     * - documentation: Code postal de l'adresse. - Relatif à la colonne [PIECEADRESSE.GPA_CODEPOSTAL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ZipCode;
    /**
     * Constructor method for Address
     * @uses Address::setCity()
     * @uses Address::setContactNumber()
     * @uses Address::setCountryId()
     * @uses Address::setCountryIdType()
     * @uses Address::setFirstName()
     * @uses Address::setLastName()
     * @uses Address::setLine1()
     * @uses Address::setLine2()
     * @uses Address::setLine3()
     * @uses Address::setPhoneNumber()
     * @uses Address::setRegion()
     * @uses Address::setTitleId()
     * @uses Address::setZipCode()
     * @param string $city
     * @param int $contactNumber
     * @param string $countryId
     * @param string $countryIdType
     * @param string $firstName
     * @param string $lastName
     * @param string $line1
     * @param string $line2
     * @param string $line3
     * @param string $phoneNumber
     * @param string $region
     * @param string $titleId
     * @param string $zipCode
     */
    public function __construct($city = null, $contactNumber = null, $countryId = null, $countryIdType = null, $firstName = null, $lastName = null, $line1 = null, $line2 = null, $line3 = null, $phoneNumber = null, $region = null, $titleId = null, $zipCode = null)
    {
        $this
            ->setCity($city)
            ->setContactNumber($contactNumber)
            ->setCountryId($countryId)
            ->setCountryIdType($countryIdType)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setLine1($line1)
            ->setLine2($line2)
            ->setLine3($line3)
            ->setPhoneNumber($phoneNumber)
            ->setRegion($region)
            ->setTitleId($titleId)
            ->setZipCode($zipCode);
    }
    /**
     * Get City value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCity()
    {
        return isset($this->City) ? $this->City : null;
    }
    /**
     * Set City value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $city
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        if (is_null($city) || (is_array($city) && empty($city))) {
            unset($this->City);
        } else {
            $this->City = $city;
        }
        return $this;
    }
    /**
     * Get ContactNumber value
     * @return int|null
     */
    public function getContactNumber()
    {
        return $this->ContactNumber;
    }
    /**
     * Set ContactNumber value
     * @param int $contactNumber
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setContactNumber($contactNumber = null)
    {
        // validation for constraint: int
        if (!is_null($contactNumber) && !(is_int($contactNumber) || ctype_digit($contactNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($contactNumber, true), gettype($contactNumber)), __LINE__);
        }
        $this->ContactNumber = $contactNumber;
        return $this;
    }
    /**
     * Get CountryId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountryId()
    {
        return isset($this->CountryId) ? $this->CountryId : null;
    }
    /**
     * Set CountryId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $countryId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setCountryId($countryId = null)
    {
        // validation for constraint: string
        if (!is_null($countryId) && !is_string($countryId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryId, true), gettype($countryId)), __LINE__);
        }
        if (is_null($countryId) || (is_array($countryId) && empty($countryId))) {
            unset($this->CountryId);
        } else {
            $this->CountryId = $countryId;
        }
        return $this;
    }
    /**
     * Get CountryIdType value
     * @return string|null
     */
    public function getCountryIdType()
    {
        return $this->CountryIdType;
    }
    /**
     * Set CountryIdType value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CountryIdType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CountryIdType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $countryIdType
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setCountryIdType($countryIdType = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CountryIdType::valueIsValid($countryIdType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CountryIdType', is_array($countryIdType) ? implode(', ', $countryIdType) : var_export($countryIdType, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CountryIdType::getValidValues())), __LINE__);
        }
        $this->CountryIdType = $countryIdType;
        return $this;
    }
    /**
     * Get FirstName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFirstName()
    {
        return isset($this->FirstName) ? $this->FirstName : null;
    }
    /**
     * Set FirstName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $firstName
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        if (is_null($firstName) || (is_array($firstName) && empty($firstName))) {
            unset($this->FirstName);
        } else {
            $this->FirstName = $firstName;
        }
        return $this;
    }
    /**
     * Get LastName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLastName()
    {
        return isset($this->LastName) ? $this->LastName : null;
    }
    /**
     * Set LastName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lastName
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        if (is_null($lastName) || (is_array($lastName) && empty($lastName))) {
            unset($this->LastName);
        } else {
            $this->LastName = $lastName;
        }
        return $this;
    }
    /**
     * Get Line1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLine1()
    {
        return isset($this->Line1) ? $this->Line1 : null;
    }
    /**
     * Set Line1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $line1
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setLine1($line1 = null)
    {
        // validation for constraint: string
        if (!is_null($line1) && !is_string($line1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($line1, true), gettype($line1)), __LINE__);
        }
        if (is_null($line1) || (is_array($line1) && empty($line1))) {
            unset($this->Line1);
        } else {
            $this->Line1 = $line1;
        }
        return $this;
    }
    /**
     * Get Line2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLine2()
    {
        return isset($this->Line2) ? $this->Line2 : null;
    }
    /**
     * Set Line2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $line2
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setLine2($line2 = null)
    {
        // validation for constraint: string
        if (!is_null($line2) && !is_string($line2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($line2, true), gettype($line2)), __LINE__);
        }
        if (is_null($line2) || (is_array($line2) && empty($line2))) {
            unset($this->Line2);
        } else {
            $this->Line2 = $line2;
        }
        return $this;
    }
    /**
     * Get Line3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLine3()
    {
        return isset($this->Line3) ? $this->Line3 : null;
    }
    /**
     * Set Line3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $line3
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setLine3($line3 = null)
    {
        // validation for constraint: string
        if (!is_null($line3) && !is_string($line3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($line3, true), gettype($line3)), __LINE__);
        }
        if (is_null($line3) || (is_array($line3) && empty($line3))) {
            unset($this->Line3);
        } else {
            $this->Line3 = $line3;
        }
        return $this;
    }
    /**
     * Get PhoneNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPhoneNumber()
    {
        return isset($this->PhoneNumber) ? $this->PhoneNumber : null;
    }
    /**
     * Set PhoneNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $phoneNumber
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setPhoneNumber($phoneNumber = null)
    {
        // validation for constraint: string
        if (!is_null($phoneNumber) && !is_string($phoneNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phoneNumber, true), gettype($phoneNumber)), __LINE__);
        }
        if (is_null($phoneNumber) || (is_array($phoneNumber) && empty($phoneNumber))) {
            unset($this->PhoneNumber);
        } else {
            $this->PhoneNumber = $phoneNumber;
        }
        return $this;
    }
    /**
     * Get Region value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRegion()
    {
        return isset($this->Region) ? $this->Region : null;
    }
    /**
     * Set Region value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $region
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setRegion($region = null)
    {
        // validation for constraint: string
        if (!is_null($region) && !is_string($region)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($region, true), gettype($region)), __LINE__);
        }
        if (is_null($region) || (is_array($region) && empty($region))) {
            unset($this->Region);
        } else {
            $this->Region = $region;
        }
        return $this;
    }
    /**
     * Get TitleId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTitleId()
    {
        return isset($this->TitleId) ? $this->TitleId : null;
    }
    /**
     * Set TitleId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $titleId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setTitleId($titleId = null)
    {
        // validation for constraint: string
        if (!is_null($titleId) && !is_string($titleId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($titleId, true), gettype($titleId)), __LINE__);
        }
        if (is_null($titleId) || (is_array($titleId) && empty($titleId))) {
            unset($this->TitleId);
        } else {
            $this->TitleId = $titleId;
        }
        return $this;
    }
    /**
     * Get ZipCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getZipCode()
    {
        return isset($this->ZipCode) ? $this->ZipCode : null;
    }
    /**
     * Set ZipCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $zipCode
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public function setZipCode($zipCode = null)
    {
        // validation for constraint: string
        if (!is_null($zipCode) && !is_string($zipCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipCode, true), gettype($zipCode)), __LINE__);
        }
        if (is_null($zipCode) || (is_array($zipCode) && empty($zipCode))) {
            unset($this->ZipCode);
        } else {
            $this->ZipCode = $zipCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
