<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Create_Line StructType
 * Meta information extracted from the WSDL
 * - documentation: Ligne de document à créer.
 * - nillable: true
 * - type: tns:Create_Line
 * @subpackage Structs
 */
class Create_Line extends AbstractStructBase
{
    /**
     * The BonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/03 - V1105] [Optionnel] - Identifiant de la carte cadeau. Associé à un article financier de type achat de carte cadeau, il permet la création de la carte cadeau. Valable uniquement pour les documents de type commande
     * client eCommerce. - Relatif à la colonne [OPERCAISSE.GOC_NUMBON].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BonId;
    /**
     * The CatalogReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2018/01 - V1400] [Optionnel] - Référence catalogue - Relatif à la colonne [LIGNE.GL_REFCATALOGUE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CatalogReference;
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/01 - V1201] [Optionnel] - Commentaire sur la ligne du document, pouvant être du texte brut ou du texte formaté RTF - Relatif à la colonne [LIGNE.GL_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The ComplementaryDescription
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11 - V1300] [Optionnel] - Libellé complémentaire à la ligne - Relatif à la colonne [LIGNE.GL_LIBCOMPL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ComplementaryDescription;
    /**
     * The DeliveryDate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11 - V1300] [Optionnel] - Date de livraison à la ligne - Relatif à la colonne [LIGNE.GL_DATELIVRAISON].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeliveryDate;
    /**
     * The DiscountTypeId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du type de remise. - Relatif à la colonne [LIGNE.GL_TYPEREMISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DiscountTypeId;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/02 - V1105] [Optionnel] - Référence externe de la ligne. - Relatif à la colonne [LIGNE.GL_REFEXTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The InitialDeliveryDate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11 - V1300] [Optionnel] - Date de livraison initiale à la ligne - Relatif à la colonne [LIGNE.GL_DATELIVINITIALE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InitialDeliveryDate;
    /**
     * The ItemIdentifier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier
     */
    public $ItemIdentifier;
    /**
     * The Label
     * Meta information extracted from the WSDL
     * - documentation: Libellé de la ligne. - Relatif à la colonne [LIGNE.GL_LIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Label;
    /**
     * The MovementReasonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/02 - V1105] [Optionnel] - Identifiant du motif de mouvement associé à la ligne. - Relatif à la colonne [LIGNE.GL_MOTIFMVT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MovementReasonId;
    /**
     * The NetUnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Prix unitaire net. Permet avec [UnitPrice], le calul de la remise ligne. HT ou TTC en fonction de la valeur de [TaxExcluded] - Relatif à la colonne [LIGNE.GL_PUHTNET / LIGNE.GL_PUTTCNET].
     * - minOccurs: 0
     * @var float
     */
    public $NetUnitPrice;
    /**
     * The OmniChannel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannelLine
     */
    public $OmniChannel;
    /**
     * The Origin
     * Meta information extracted from the WSDL
     * - documentation: Provenance. - Relatif à la colonne [LIGNE.GL_TYPEPROVENANCE].
     * - minOccurs: 0
     * @var string
     */
    public $Origin;
    /**
     * The PackageReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/01 - V1201] [Optionnel] - Référence du colis - Relatif à la colonne [LIGNE.GL_REFCOLIS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PackageReference;
    /**
     * The Quantity
     * Meta information extracted from the WSDL
     * - documentation: Quantité. - Relatif à la colonne [LIGNE.GL_QTEFACT].
     * - minOccurs: 0
     * @var float
     */
    public $Quantity;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/10 - V1105] [Optionnel] - Identifiant du vendeur de la ligne. - Relatif à la colonne [LIGNE.GL_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The SerialNumberId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/12 - V1300] [Optionnel] - Numéro de série de l'article - Relatif à la colonne [LIGNESERIE.GLS_IDSERIE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SerialNumberId;
    /**
     * The Taxes
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Liste des taxes associées a la ligne (5 taxes maxi). L'ordre dans la collection détermine l'affectation vers les 5 zones de taxe de la ligne du document.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax
     */
    public $Taxes;
    /**
     * The UnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Prix unitaire. Permet avec la propriété NetUnitPrice, le calul de la remise ligne. HT ou TTC en fonction de la valeur de [TaxExcluded] - Relatif à la colonne [LIGNE.GL_PUHT / LIGNE.GL_PUTTC].
     * - minOccurs: 0
     * @var float
     */
    public $UnitPrice;
    /**
     * Constructor method for Create_Line
     * @uses Create_Line::setBonId()
     * @uses Create_Line::setCatalogReference()
     * @uses Create_Line::setComment()
     * @uses Create_Line::setComplementaryDescription()
     * @uses Create_Line::setDeliveryDate()
     * @uses Create_Line::setDiscountTypeId()
     * @uses Create_Line::setExternalReference()
     * @uses Create_Line::setInitialDeliveryDate()
     * @uses Create_Line::setItemIdentifier()
     * @uses Create_Line::setLabel()
     * @uses Create_Line::setMovementReasonId()
     * @uses Create_Line::setNetUnitPrice()
     * @uses Create_Line::setOmniChannel()
     * @uses Create_Line::setOrigin()
     * @uses Create_Line::setPackageReference()
     * @uses Create_Line::setQuantity()
     * @uses Create_Line::setSalesPersonId()
     * @uses Create_Line::setSerialNumberId()
     * @uses Create_Line::setTaxes()
     * @uses Create_Line::setUnitPrice()
     * @param string $bonId
     * @param string $catalogReference
     * @param string $comment
     * @param string $complementaryDescription
     * @param string $deliveryDate
     * @param string $discountTypeId
     * @param string $externalReference
     * @param string $initialDeliveryDate
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier
     * @param string $label
     * @param string $movementReasonId
     * @param float $netUnitPrice
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannelLine $omniChannel
     * @param string $origin
     * @param string $packageReference
     * @param float $quantity
     * @param string $salesPersonId
     * @param string $serialNumberId
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes
     * @param float $unitPrice
     */
    public function __construct($bonId = null, $catalogReference = null, $comment = null, $complementaryDescription = null, $deliveryDate = null, $discountTypeId = null, $externalReference = null, $initialDeliveryDate = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier = null, $label = null, $movementReasonId = null, $netUnitPrice = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannelLine $omniChannel = null, $origin = null, $packageReference = null, $quantity = null, $salesPersonId = null, $serialNumberId = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes = null, $unitPrice = null)
    {
        $this
            ->setBonId($bonId)
            ->setCatalogReference($catalogReference)
            ->setComment($comment)
            ->setComplementaryDescription($complementaryDescription)
            ->setDeliveryDate($deliveryDate)
            ->setDiscountTypeId($discountTypeId)
            ->setExternalReference($externalReference)
            ->setInitialDeliveryDate($initialDeliveryDate)
            ->setItemIdentifier($itemIdentifier)
            ->setLabel($label)
            ->setMovementReasonId($movementReasonId)
            ->setNetUnitPrice($netUnitPrice)
            ->setOmniChannel($omniChannel)
            ->setOrigin($origin)
            ->setPackageReference($packageReference)
            ->setQuantity($quantity)
            ->setSalesPersonId($salesPersonId)
            ->setSerialNumberId($serialNumberId)
            ->setTaxes($taxes)
            ->setUnitPrice($unitPrice);
    }
    /**
     * Get BonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBonId()
    {
        return isset($this->BonId) ? $this->BonId : null;
    }
    /**
     * Set BonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setBonId($bonId = null)
    {
        // validation for constraint: string
        if (!is_null($bonId) && !is_string($bonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bonId, true), gettype($bonId)), __LINE__);
        }
        if (is_null($bonId) || (is_array($bonId) && empty($bonId))) {
            unset($this->BonId);
        } else {
            $this->BonId = $bonId;
        }
        return $this;
    }
    /**
     * Get CatalogReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCatalogReference()
    {
        return isset($this->CatalogReference) ? $this->CatalogReference : null;
    }
    /**
     * Set CatalogReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $catalogReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setCatalogReference($catalogReference = null)
    {
        // validation for constraint: string
        if (!is_null($catalogReference) && !is_string($catalogReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($catalogReference, true), gettype($catalogReference)), __LINE__);
        }
        if (is_null($catalogReference) || (is_array($catalogReference) && empty($catalogReference))) {
            unset($this->CatalogReference);
        } else {
            $this->CatalogReference = $catalogReference;
        }
        return $this;
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get ComplementaryDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComplementaryDescription()
    {
        return isset($this->ComplementaryDescription) ? $this->ComplementaryDescription : null;
    }
    /**
     * Set ComplementaryDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $complementaryDescription
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setComplementaryDescription($complementaryDescription = null)
    {
        // validation for constraint: string
        if (!is_null($complementaryDescription) && !is_string($complementaryDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($complementaryDescription, true), gettype($complementaryDescription)), __LINE__);
        }
        if (is_null($complementaryDescription) || (is_array($complementaryDescription) && empty($complementaryDescription))) {
            unset($this->ComplementaryDescription);
        } else {
            $this->ComplementaryDescription = $complementaryDescription;
        }
        return $this;
    }
    /**
     * Get DeliveryDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeliveryDate()
    {
        return isset($this->DeliveryDate) ? $this->DeliveryDate : null;
    }
    /**
     * Set DeliveryDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deliveryDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setDeliveryDate($deliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDate) && !is_string($deliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryDate, true), gettype($deliveryDate)), __LINE__);
        }
        if (is_null($deliveryDate) || (is_array($deliveryDate) && empty($deliveryDate))) {
            unset($this->DeliveryDate);
        } else {
            $this->DeliveryDate = $deliveryDate;
        }
        return $this;
    }
    /**
     * Get DiscountTypeId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDiscountTypeId()
    {
        return isset($this->DiscountTypeId) ? $this->DiscountTypeId : null;
    }
    /**
     * Set DiscountTypeId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $discountTypeId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setDiscountTypeId($discountTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($discountTypeId) && !is_string($discountTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($discountTypeId, true), gettype($discountTypeId)), __LINE__);
        }
        if (is_null($discountTypeId) || (is_array($discountTypeId) && empty($discountTypeId))) {
            unset($this->DiscountTypeId);
        } else {
            $this->DiscountTypeId = $discountTypeId;
        }
        return $this;
    }
    /**
     * Get ExternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalReference()
    {
        return isset($this->ExternalReference) ? $this->ExternalReference : null;
    }
    /**
     * Set ExternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        if (is_null($externalReference) || (is_array($externalReference) && empty($externalReference))) {
            unset($this->ExternalReference);
        } else {
            $this->ExternalReference = $externalReference;
        }
        return $this;
    }
    /**
     * Get InitialDeliveryDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInitialDeliveryDate()
    {
        return isset($this->InitialDeliveryDate) ? $this->InitialDeliveryDate : null;
    }
    /**
     * Set InitialDeliveryDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $initialDeliveryDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setInitialDeliveryDate($initialDeliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($initialDeliveryDate) && !is_string($initialDeliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($initialDeliveryDate, true), gettype($initialDeliveryDate)), __LINE__);
        }
        if (is_null($initialDeliveryDate) || (is_array($initialDeliveryDate) && empty($initialDeliveryDate))) {
            unset($this->InitialDeliveryDate);
        } else {
            $this->InitialDeliveryDate = $initialDeliveryDate;
        }
        return $this;
    }
    /**
     * Get ItemIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return isset($this->ItemIdentifier) ? $this->ItemIdentifier : null;
    }
    /**
     * Set ItemIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier = null)
    {
        if (is_null($itemIdentifier) || (is_array($itemIdentifier) && empty($itemIdentifier))) {
            unset($this->ItemIdentifier);
        } else {
            $this->ItemIdentifier = $itemIdentifier;
        }
        return $this;
    }
    /**
     * Get Label value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabel()
    {
        return isset($this->Label) ? $this->Label : null;
    }
    /**
     * Set Label value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $label
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        if (is_null($label) || (is_array($label) && empty($label))) {
            unset($this->Label);
        } else {
            $this->Label = $label;
        }
        return $this;
    }
    /**
     * Get MovementReasonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMovementReasonId()
    {
        return isset($this->MovementReasonId) ? $this->MovementReasonId : null;
    }
    /**
     * Set MovementReasonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $movementReasonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setMovementReasonId($movementReasonId = null)
    {
        // validation for constraint: string
        if (!is_null($movementReasonId) && !is_string($movementReasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($movementReasonId, true), gettype($movementReasonId)), __LINE__);
        }
        if (is_null($movementReasonId) || (is_array($movementReasonId) && empty($movementReasonId))) {
            unset($this->MovementReasonId);
        } else {
            $this->MovementReasonId = $movementReasonId;
        }
        return $this;
    }
    /**
     * Get NetUnitPrice value
     * @return float|null
     */
    public function getNetUnitPrice()
    {
        return $this->NetUnitPrice;
    }
    /**
     * Set NetUnitPrice value
     * @param float $netUnitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setNetUnitPrice($netUnitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($netUnitPrice) && !(is_float($netUnitPrice) || is_numeric($netUnitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($netUnitPrice, true), gettype($netUnitPrice)), __LINE__);
        }
        $this->NetUnitPrice = $netUnitPrice;
        return $this;
    }
    /**
     * Get OmniChannel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannelLine|null
     */
    public function getOmniChannel()
    {
        return isset($this->OmniChannel) ? $this->OmniChannel : null;
    }
    /**
     * Set OmniChannel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannelLine $omniChannel
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setOmniChannel(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannelLine $omniChannel = null)
    {
        if (is_null($omniChannel) || (is_array($omniChannel) && empty($omniChannel))) {
            unset($this->OmniChannel);
        } else {
            $this->OmniChannel = $omniChannel;
        }
        return $this;
    }
    /**
     * Get Origin value
     * @return string|null
     */
    public function getOrigin()
    {
        return $this->Origin;
    }
    /**
     * Set Origin value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $origin
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setOrigin($origin = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid($origin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin', is_array($origin) ? implode(', ', $origin) : var_export($origin, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues())), __LINE__);
        }
        $this->Origin = $origin;
        return $this;
    }
    /**
     * Get PackageReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPackageReference()
    {
        return isset($this->PackageReference) ? $this->PackageReference : null;
    }
    /**
     * Set PackageReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $packageReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setPackageReference($packageReference = null)
    {
        // validation for constraint: string
        if (!is_null($packageReference) && !is_string($packageReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($packageReference, true), gettype($packageReference)), __LINE__);
        }
        if (is_null($packageReference) || (is_array($packageReference) && empty($packageReference))) {
            unset($this->PackageReference);
        } else {
            $this->PackageReference = $packageReference;
        }
        return $this;
    }
    /**
     * Get Quantity value
     * @return float|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param float $quantity
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: float
        if (!is_null($quantity) && !(is_float($quantity) || is_numeric($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get SerialNumberId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerialNumberId()
    {
        return isset($this->SerialNumberId) ? $this->SerialNumberId : null;
    }
    /**
     * Set SerialNumberId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serialNumberId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setSerialNumberId($serialNumberId = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumberId) && !is_string($serialNumberId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serialNumberId, true), gettype($serialNumberId)), __LINE__);
        }
        if (is_null($serialNumberId) || (is_array($serialNumberId) && empty($serialNumberId))) {
            unset($this->SerialNumberId);
        } else {
            $this->SerialNumberId = $serialNumberId;
        }
        return $this;
    }
    /**
     * Get Taxes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax|null
     */
    public function getTaxes()
    {
        return isset($this->Taxes) ? $this->Taxes : null;
    }
    /**
     * Set Taxes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setTaxes(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes = null)
    {
        if (is_null($taxes) || (is_array($taxes) && empty($taxes))) {
            unset($this->Taxes);
        } else {
            $this->Taxes = $taxes;
        }
        return $this;
    }
    /**
     * Get UnitPrice value
     * @return float|null
     */
    public function getUnitPrice()
    {
        return $this->UnitPrice;
    }
    /**
     * Set UnitPrice value
     * @param float $unitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public function setUnitPrice($unitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($unitPrice) && !(is_float($unitPrice) || is_numeric($unitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($unitPrice, true), gettype($unitPrice)), __LINE__);
        }
        $this->UnitPrice = $unitPrice;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
