<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Create_Payment StructType
 * Meta information extracted from the WSDL
 * - documentation: Paiement du document à créer.
 * - nillable: true
 * - type: tns:Create_Payment
 * @subpackage Structs
 */
class Create_Payment extends AbstractStructBase
{
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - documentation: Montant payé dans la devise du document. - Relatif à la colonne [PIEDECHE.GPE_MONTANTDEV].
     * - minOccurs: 0
     * @var float
     */
    public $Amount;
    /**
     * The BonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/04 - V1105] [Optionnel] - Identifiant de la carte cadeau. Doit être associé à un mode paiement de type carte cadeau. Valable uniquement pour les documents de type commande client eCommerce. - Relatif à la colonne
     * [OPERCAISSE.GOC_NUMBON].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BonId;
    /**
     * The CreditCard
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard
     */
    public $CreditCard;
    /**
     * The CurrencyId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la devise. - Relatif à la colonne [DEVISE.D_DEVISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CurrencyId;
    /**
     * The DueDate
     * Meta information extracted from the WSDL
     * - documentation: Date de l'échance. - Relatif à la colonne [PIEDECHE.GPE_DATEECHE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * @var string
     */
    public $DueDate;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du paiement. - Relatif à la colonne [PIEDECHE.GPE_NUMECHE].
     * @var int
     */
    public $Id;
    /**
     * The IsReceivedPayment
     * Meta information extracted from the WSDL
     * - documentation: Dans le cas d'une commande non eCommerce, indique que le règlement est un règlement percu. Dans les autres cas la valeur par défaut est false. - Relatif à la colonne [PIEDECHE.GPE_PERCU].
     * - minOccurs: 0
     * @var bool
     */
    public $IsReceivedPayment;
    /**
     * The MethodId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du mode de paiment. - Relatif à la colonne [MODEPAIE.MP_MODEPAIE].
     * - nillable: true
     * @var string
     */
    public $MethodId;
    /**
     * The RegisterOperationForReceivedPayment
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Dans le cas d'un règlement perçu, permet d'indiquer l'opération de caisse associée au règlement.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RegisterOperationForReceivedPayment;
    /**
     * Constructor method for Create_Payment
     * @uses Create_Payment::setAmount()
     * @uses Create_Payment::setBonId()
     * @uses Create_Payment::setCreditCard()
     * @uses Create_Payment::setCurrencyId()
     * @uses Create_Payment::setDueDate()
     * @uses Create_Payment::setId()
     * @uses Create_Payment::setIsReceivedPayment()
     * @uses Create_Payment::setMethodId()
     * @uses Create_Payment::setRegisterOperationForReceivedPayment()
     * @param float $amount
     * @param string $bonId
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard
     * @param string $currencyId
     * @param string $dueDate
     * @param int $id
     * @param bool $isReceivedPayment
     * @param string $methodId
     * @param string $registerOperationForReceivedPayment
     */
    public function __construct($amount = null, $bonId = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard = null, $currencyId = null, $dueDate = null, $id = null, $isReceivedPayment = null, $methodId = null, $registerOperationForReceivedPayment = null)
    {
        $this
            ->setAmount($amount)
            ->setBonId($bonId)
            ->setCreditCard($creditCard)
            ->setCurrencyId($currencyId)
            ->setDueDate($dueDate)
            ->setId($id)
            ->setIsReceivedPayment($isReceivedPayment)
            ->setMethodId($methodId)
            ->setRegisterOperationForReceivedPayment($registerOperationForReceivedPayment);
    }
    /**
     * Get Amount value
     * @return float|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: float
        if (!is_null($amount) && !(is_float($amount) || is_numeric($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get BonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBonId()
    {
        return isset($this->BonId) ? $this->BonId : null;
    }
    /**
     * Set BonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $bonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setBonId($bonId = null)
    {
        // validation for constraint: string
        if (!is_null($bonId) && !is_string($bonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bonId, true), gettype($bonId)), __LINE__);
        }
        if (is_null($bonId) || (is_array($bonId) && empty($bonId))) {
            unset($this->BonId);
        } else {
            $this->BonId = $bonId;
        }
        return $this;
    }
    /**
     * Get CreditCard value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard|null
     */
    public function getCreditCard()
    {
        return isset($this->CreditCard) ? $this->CreditCard : null;
    }
    /**
     * Set CreditCard value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setCreditCard(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard = null)
    {
        if (is_null($creditCard) || (is_array($creditCard) && empty($creditCard))) {
            unset($this->CreditCard);
        } else {
            $this->CreditCard = $creditCard;
        }
        return $this;
    }
    /**
     * Get CurrencyId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrencyId()
    {
        return isset($this->CurrencyId) ? $this->CurrencyId : null;
    }
    /**
     * Set CurrencyId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currencyId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setCurrencyId($currencyId = null)
    {
        // validation for constraint: string
        if (!is_null($currencyId) && !is_string($currencyId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencyId, true), gettype($currencyId)), __LINE__);
        }
        if (is_null($currencyId) || (is_array($currencyId) && empty($currencyId))) {
            unset($this->CurrencyId);
        } else {
            $this->CurrencyId = $currencyId;
        }
        return $this;
    }
    /**
     * Get DueDate value
     * @return string|null
     */
    public function getDueDate()
    {
        return $this->DueDate;
    }
    /**
     * Set DueDate value
     * @param string $dueDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setDueDate($dueDate = null)
    {
        // validation for constraint: string
        if (!is_null($dueDate) && !is_string($dueDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dueDate, true), gettype($dueDate)), __LINE__);
        }
        $this->DueDate = $dueDate;
        return $this;
    }
    /**
     * Get Id value
     * @return int|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get IsReceivedPayment value
     * @return bool|null
     */
    public function getIsReceivedPayment()
    {
        return $this->IsReceivedPayment;
    }
    /**
     * Set IsReceivedPayment value
     * @param bool $isReceivedPayment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setIsReceivedPayment($isReceivedPayment = null)
    {
        // validation for constraint: boolean
        if (!is_null($isReceivedPayment) && !is_bool($isReceivedPayment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isReceivedPayment, true), gettype($isReceivedPayment)), __LINE__);
        }
        $this->IsReceivedPayment = $isReceivedPayment;
        return $this;
    }
    /**
     * Get MethodId value
     * @return string|null
     */
    public function getMethodId()
    {
        return $this->MethodId;
    }
    /**
     * Set MethodId value
     * @param string $methodId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setMethodId($methodId = null)
    {
        // validation for constraint: string
        if (!is_null($methodId) && !is_string($methodId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($methodId, true), gettype($methodId)), __LINE__);
        }
        $this->MethodId = $methodId;
        return $this;
    }
    /**
     * Get RegisterOperationForReceivedPayment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRegisterOperationForReceivedPayment()
    {
        return isset($this->RegisterOperationForReceivedPayment) ? $this->RegisterOperationForReceivedPayment : null;
    }
    /**
     * Set RegisterOperationForReceivedPayment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $registerOperationForReceivedPayment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public function setRegisterOperationForReceivedPayment($registerOperationForReceivedPayment = null)
    {
        // validation for constraint: string
        if (!is_null($registerOperationForReceivedPayment) && !is_string($registerOperationForReceivedPayment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($registerOperationForReceivedPayment, true), gettype($registerOperationForReceivedPayment)), __LINE__);
        }
        if (is_null($registerOperationForReceivedPayment) || (is_array($registerOperationForReceivedPayment) && empty($registerOperationForReceivedPayment))) {
            unset($this->RegisterOperationForReceivedPayment);
        } else {
            $this->RegisterOperationForReceivedPayment = $registerOperationForReceivedPayment;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_Payment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
