<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Create_ShippingTax StructType
 * Meta information extracted from the WSDL
 * - documentation: Frais de port à créer.
 * - nillable: true
 * - type: tns:Create_ShippingTax
 * @subpackage Structs
 */
class Create_ShippingTax extends AbstractStructBase
{
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - documentation: Montant du port. - Relatif à la colonne [PIEDPORT.GPT_TOTALHT / PIEDPORT.GPT_TOTALTTC].
     * - minOccurs: 0
     * @var float
     */
    public $Amount;
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du frais de port. - Relatif à la colonne [PIEDPORT.GPT_CODEPORT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Id;
    /**
     * Constructor method for Create_ShippingTax
     * @uses Create_ShippingTax::setAmount()
     * @uses Create_ShippingTax::setId()
     * @param float $amount
     * @param string $id
     */
    public function __construct($amount = null, $id = null)
    {
        $this
            ->setAmount($amount)
            ->setId($id);
    }
    /**
     * Get Amount value
     * @return float|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: float
        if (!is_null($amount) && !(is_float($amount) || is_numeric($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get Id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getId()
    {
        return isset($this->Id) ? $this->Id : null;
    }
    /**
     * Set Id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $id
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->Id);
        } else {
            $this->Id = $id;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
