<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomersReservationCreate_Header StructType
 * Meta information extracted from the WSDL
 * - documentation: Entête d'une réservation client
 * - nillable: true
 * - type: tns:CustomersReservationCreate_Header
 * @subpackage Structs
 */
class CustomersReservationCreate_Header extends AbstractStructBase
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - documentation: Document actif. - Relatif à la colonne [PIECE.GP_VIVANTE].
     * - minOccurs: 0
     * @var bool
     */
    public $Active;
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2016/06 - V1201] [Optionnel] - Commentaire sur l'en-tête de document, pouvant être du texte brut ou du texte formaté RTF - Relatif à la colonne [PIECE.GP_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The CurrencyId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la devise du document. Si la devise n'est pas renseignée, la valeur par défaut est l'identifiant de la devise du dossier. - Relatif à la colonne [DEVISE.D_DEVISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CurrencyId;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du client associé au document. - Relatif à la colonne [TIERS.T_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - documentation: Date du document. - Relatif à la colonne [PIECE.GP_DATEPIECE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The Deposit
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11 - V1201] [Optionnel] - Ligne de document d'origine du versement d'arrhes du ticket de vente - Valeur par defaut: nil.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier
     */
    public $Deposit;
    /**
     * The ExpirationDate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/07 - V1110] [Optionnel] - Date d'expiration. - Relatif à la colonne [PIECE.GP_DATEEXPIRATION]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExpirationDate;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - documentation: Référence externe. - Relatif à la colonne [PIECE.GP_REFEXTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The ExternalReferenceDate
     * Meta information extracted from the WSDL
     * - documentation: Date de référencement externe. - Relatif à la colonne [PIECE.GP_DATEREFEXTERNE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * @var string
     */
    public $ExternalReferenceDate;
    /**
     * The FollowedReference
     * Meta information extracted from the WSDL
     * - documentation: Référence de suivi. - Relatif à la colonne [PIECE.GP_REFSUIVI].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowedReference;
    /**
     * The InternalReference
     * Meta information extracted from the WSDL
     * - documentation: Référence interne. - Relatif à la colonne [PIECE.GP_REFINTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InternalReference;
    /**
     * The LinesUnmodifiable
     * Meta information extracted from the WSDL
     * - documentation: Précise si les lignes sont non modifiables. - Relatif à la colonne [PIECE.GP_NONMODIFIABLE].
     * - minOccurs: 0
     * @var bool
     */
    public $LinesUnmodifiable;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/10 - V1105] [Optionnel] - Identifiant du vendeur. - Relatif à la colonne [PIECE.GP_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The StoreId
     * Meta information extracted from the WSDL
     * - documentation: Etablissement du document. - Relatif à la colonne [ETABLISSEMENT.ET_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $StoreId;
    /**
     * The TaxExcluded
     * Meta information extracted from the WSDL
     * - documentation: Document H.T. - Relatif à la colonne [PIECE.GP_FACTUREHT].
     * - minOccurs: 0
     * @var bool
     */
    public $TaxExcluded;
    /**
     * The UserDefinedDates
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Dates libres utilisateur. - Relatif à la colonne [PIECE.GP_DATELIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate
     */
    public $UserDefinedDates;
    /**
     * The UserDefinedTableCustomers
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Tables libres Tiers. - Relatif à la colonne [PIECE.GP_LIBRETIERSx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTableCustomer
     */
    public $UserDefinedTableCustomers;
    /**
     * The UserDefinedTables
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Tables libres utilisateur. - Relatif à la colonne [PIECE.GP_LIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable
     */
    public $UserDefinedTables;
    /**
     * The UserFields
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Champs utilisateur du document.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField
     */
    public $UserFields;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/02 - V1201] [Optionnel] - Identifiant du dépôt de l'établissement du document - Relatif à la colonne [DEPOTS.GDE_DEPOT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for CustomersReservationCreate_Header
     * @uses CustomersReservationCreate_Header::setActive()
     * @uses CustomersReservationCreate_Header::setComment()
     * @uses CustomersReservationCreate_Header::setCurrencyId()
     * @uses CustomersReservationCreate_Header::setCustomerId()
     * @uses CustomersReservationCreate_Header::setDate()
     * @uses CustomersReservationCreate_Header::setDeposit()
     * @uses CustomersReservationCreate_Header::setExpirationDate()
     * @uses CustomersReservationCreate_Header::setExternalReference()
     * @uses CustomersReservationCreate_Header::setExternalReferenceDate()
     * @uses CustomersReservationCreate_Header::setFollowedReference()
     * @uses CustomersReservationCreate_Header::setInternalReference()
     * @uses CustomersReservationCreate_Header::setLinesUnmodifiable()
     * @uses CustomersReservationCreate_Header::setSalesPersonId()
     * @uses CustomersReservationCreate_Header::setStoreId()
     * @uses CustomersReservationCreate_Header::setTaxExcluded()
     * @uses CustomersReservationCreate_Header::setUserDefinedDates()
     * @uses CustomersReservationCreate_Header::setUserDefinedTableCustomers()
     * @uses CustomersReservationCreate_Header::setUserDefinedTables()
     * @uses CustomersReservationCreate_Header::setUserFields()
     * @uses CustomersReservationCreate_Header::setWarehouseId()
     * @param bool $active
     * @param string $comment
     * @param string $currencyId
     * @param string $customerId
     * @param string $date
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier $deposit
     * @param string $expirationDate
     * @param string $externalReference
     * @param string $externalReferenceDate
     * @param string $followedReference
     * @param string $internalReference
     * @param bool $linesUnmodifiable
     * @param string $salesPersonId
     * @param string $storeId
     * @param bool $taxExcluded
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTableCustomer $userDefinedTableCustomers
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     * @param string $warehouseId
     */
    public function __construct($active = null, $comment = null, $currencyId = null, $customerId = null, $date = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier $deposit = null, $expirationDate = null, $externalReference = null, $externalReferenceDate = null, $followedReference = null, $internalReference = null, $linesUnmodifiable = null, $salesPersonId = null, $storeId = null, $taxExcluded = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTableCustomer $userDefinedTableCustomers = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null, $warehouseId = null)
    {
        $this
            ->setActive($active)
            ->setComment($comment)
            ->setCurrencyId($currencyId)
            ->setCustomerId($customerId)
            ->setDate($date)
            ->setDeposit($deposit)
            ->setExpirationDate($expirationDate)
            ->setExternalReference($externalReference)
            ->setExternalReferenceDate($externalReferenceDate)
            ->setFollowedReference($followedReference)
            ->setInternalReference($internalReference)
            ->setLinesUnmodifiable($linesUnmodifiable)
            ->setSalesPersonId($salesPersonId)
            ->setStoreId($storeId)
            ->setTaxExcluded($taxExcluded)
            ->setUserDefinedDates($userDefinedDates)
            ->setUserDefinedTableCustomers($userDefinedTableCustomers)
            ->setUserDefinedTables($userDefinedTables)
            ->setUserFields($userFields)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get Active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->Active;
    }
    /**
     * Set Active value
     * @param bool $active
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->Active = $active;
        return $this;
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get CurrencyId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrencyId()
    {
        return isset($this->CurrencyId) ? $this->CurrencyId : null;
    }
    /**
     * Set CurrencyId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currencyId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setCurrencyId($currencyId = null)
    {
        // validation for constraint: string
        if (!is_null($currencyId) && !is_string($currencyId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencyId, true), gettype($currencyId)), __LINE__);
        }
        if (is_null($currencyId) || (is_array($currencyId) && empty($currencyId))) {
            unset($this->CurrencyId);
        } else {
            $this->CurrencyId = $currencyId;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get Deposit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier|null
     */
    public function getDeposit()
    {
        return isset($this->Deposit) ? $this->Deposit : null;
    }
    /**
     * Set Deposit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier $deposit
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setDeposit(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier $deposit = null)
    {
        if (is_null($deposit) || (is_array($deposit) && empty($deposit))) {
            unset($this->Deposit);
        } else {
            $this->Deposit = $deposit;
        }
        return $this;
    }
    /**
     * Get ExpirationDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExpirationDate()
    {
        return isset($this->ExpirationDate) ? $this->ExpirationDate : null;
    }
    /**
     * Set ExpirationDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $expirationDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setExpirationDate($expirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($expirationDate) && !is_string($expirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expirationDate, true), gettype($expirationDate)), __LINE__);
        }
        if (is_null($expirationDate) || (is_array($expirationDate) && empty($expirationDate))) {
            unset($this->ExpirationDate);
        } else {
            $this->ExpirationDate = $expirationDate;
        }
        return $this;
    }
    /**
     * Get ExternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalReference()
    {
        return isset($this->ExternalReference) ? $this->ExternalReference : null;
    }
    /**
     * Set ExternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        if (is_null($externalReference) || (is_array($externalReference) && empty($externalReference))) {
            unset($this->ExternalReference);
        } else {
            $this->ExternalReference = $externalReference;
        }
        return $this;
    }
    /**
     * Get ExternalReferenceDate value
     * @return string|null
     */
    public function getExternalReferenceDate()
    {
        return $this->ExternalReferenceDate;
    }
    /**
     * Set ExternalReferenceDate value
     * @param string $externalReferenceDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setExternalReferenceDate($externalReferenceDate = null)
    {
        // validation for constraint: string
        if (!is_null($externalReferenceDate) && !is_string($externalReferenceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReferenceDate, true), gettype($externalReferenceDate)), __LINE__);
        }
        $this->ExternalReferenceDate = $externalReferenceDate;
        return $this;
    }
    /**
     * Get FollowedReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowedReference()
    {
        return isset($this->FollowedReference) ? $this->FollowedReference : null;
    }
    /**
     * Set FollowedReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $followedReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setFollowedReference($followedReference = null)
    {
        // validation for constraint: string
        if (!is_null($followedReference) && !is_string($followedReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($followedReference, true), gettype($followedReference)), __LINE__);
        }
        if (is_null($followedReference) || (is_array($followedReference) && empty($followedReference))) {
            unset($this->FollowedReference);
        } else {
            $this->FollowedReference = $followedReference;
        }
        return $this;
    }
    /**
     * Get InternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInternalReference()
    {
        return isset($this->InternalReference) ? $this->InternalReference : null;
    }
    /**
     * Set InternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $internalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setInternalReference($internalReference = null)
    {
        // validation for constraint: string
        if (!is_null($internalReference) && !is_string($internalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalReference, true), gettype($internalReference)), __LINE__);
        }
        if (is_null($internalReference) || (is_array($internalReference) && empty($internalReference))) {
            unset($this->InternalReference);
        } else {
            $this->InternalReference = $internalReference;
        }
        return $this;
    }
    /**
     * Get LinesUnmodifiable value
     * @return bool|null
     */
    public function getLinesUnmodifiable()
    {
        return $this->LinesUnmodifiable;
    }
    /**
     * Set LinesUnmodifiable value
     * @param bool $linesUnmodifiable
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setLinesUnmodifiable($linesUnmodifiable = null)
    {
        // validation for constraint: boolean
        if (!is_null($linesUnmodifiable) && !is_bool($linesUnmodifiable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($linesUnmodifiable, true), gettype($linesUnmodifiable)), __LINE__);
        }
        $this->LinesUnmodifiable = $linesUnmodifiable;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get StoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStoreId()
    {
        return isset($this->StoreId) ? $this->StoreId : null;
    }
    /**
     * Set StoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $storeId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setStoreId($storeId = null)
    {
        // validation for constraint: string
        if (!is_null($storeId) && !is_string($storeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($storeId, true), gettype($storeId)), __LINE__);
        }
        if (is_null($storeId) || (is_array($storeId) && empty($storeId))) {
            unset($this->StoreId);
        } else {
            $this->StoreId = $storeId;
        }
        return $this;
    }
    /**
     * Get TaxExcluded value
     * @return bool|null
     */
    public function getTaxExcluded()
    {
        return $this->TaxExcluded;
    }
    /**
     * Set TaxExcluded value
     * @param bool $taxExcluded
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setTaxExcluded($taxExcluded = null)
    {
        // validation for constraint: boolean
        if (!is_null($taxExcluded) && !is_bool($taxExcluded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($taxExcluded, true), gettype($taxExcluded)), __LINE__);
        }
        $this->TaxExcluded = $taxExcluded;
        return $this;
    }
    /**
     * Get UserDefinedDates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate|null
     */
    public function getUserDefinedDates()
    {
        return isset($this->UserDefinedDates) ? $this->UserDefinedDates : null;
    }
    /**
     * Set UserDefinedDates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setUserDefinedDates(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null)
    {
        if (is_null($userDefinedDates) || (is_array($userDefinedDates) && empty($userDefinedDates))) {
            unset($this->UserDefinedDates);
        } else {
            $this->UserDefinedDates = $userDefinedDates;
        }
        return $this;
    }
    /**
     * Get UserDefinedTableCustomers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTableCustomer|null
     */
    public function getUserDefinedTableCustomers()
    {
        return isset($this->UserDefinedTableCustomers) ? $this->UserDefinedTableCustomers : null;
    }
    /**
     * Set UserDefinedTableCustomers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTableCustomer $userDefinedTableCustomers
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setUserDefinedTableCustomers(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTableCustomer $userDefinedTableCustomers = null)
    {
        if (is_null($userDefinedTableCustomers) || (is_array($userDefinedTableCustomers) && empty($userDefinedTableCustomers))) {
            unset($this->UserDefinedTableCustomers);
        } else {
            $this->UserDefinedTableCustomers = $userDefinedTableCustomers;
        }
        return $this;
    }
    /**
     * Get UserDefinedTables value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable|null
     */
    public function getUserDefinedTables()
    {
        return isset($this->UserDefinedTables) ? $this->UserDefinedTables : null;
    }
    /**
     * Set UserDefinedTables value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setUserDefinedTables(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null)
    {
        if (is_null($userDefinedTables) || (is_array($userDefinedTables) && empty($userDefinedTables))) {
            unset($this->UserDefinedTables);
        } else {
            $this->UserDefinedTables = $userDefinedTables;
        }
        return $this;
    }
    /**
     * Get UserFields value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField|null
     */
    public function getUserFields()
    {
        return isset($this->UserFields) ? $this->UserFields : null;
    }
    /**
     * Set UserFields value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setUserFields(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null)
    {
        if (is_null($userFields) || (is_array($userFields) && empty($userFields))) {
            unset($this->UserFields);
        } else {
            $this->UserFields = $userFields;
        }
        return $this;
    }
    /**
     * Get WarehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarehouseId()
    {
        return isset($this->WarehouseId) ? $this->WarehouseId : null;
    }
    /**
     * Set WarehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        if (is_null($warehouseId) || (is_array($warehouseId) && empty($warehouseId))) {
            unset($this->WarehouseId);
        } else {
            $this->WarehouseId = $warehouseId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
