<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomersReservationCreate_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Réservation client à créer.
 * - nillable: true
 * - type: tns:CustomersReservationCreate_Request
 * @subpackage Structs
 */
class CustomersReservationCreate_Request extends AbstractStructBase
{
    /**
     * The Header
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header
     */
    public $Header;
    /**
     * The Lines
     * Meta information extracted from the WSDL
     * - documentation: Liste des lignes de la réservation client.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line
     */
    public $Lines;
    /**
     * The Payments
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Liste des paiements du document.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Payment
     */
    public $Payments;
    /**
     * Constructor method for CustomersReservationCreate_Request
     * @uses CustomersReservationCreate_Request::setHeader()
     * @uses CustomersReservationCreate_Request::setLines()
     * @uses CustomersReservationCreate_Request::setPayments()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header $header
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line $lines
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Payment $payments
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header $header = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line $lines = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Payment $payments = null)
    {
        $this
            ->setHeader($header)
            ->setLines($lines)
            ->setPayments($payments);
    }
    /**
     * Get Header value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header|null
     */
    public function getHeader()
    {
        return isset($this->Header) ? $this->Header : null;
    }
    /**
     * Set Header value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header $header
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request
     */
    public function setHeader(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Header $header = null)
    {
        if (is_null($header) || (is_array($header) && empty($header))) {
            unset($this->Header);
        } else {
            $this->Header = $header;
        }
        return $this;
    }
    /**
     * Get Lines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line|null
     */
    public function getLines()
    {
        return isset($this->Lines) ? $this->Lines : null;
    }
    /**
     * Set Lines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line $lines
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request
     */
    public function setLines(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCustomersReservationCreate_Line $lines = null)
    {
        if (is_null($lines) || (is_array($lines) && empty($lines))) {
            unset($this->Lines);
        } else {
            $this->Lines = $lines;
        }
        return $this;
    }
    /**
     * Get Payments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Payment|null
     */
    public function getPayments()
    {
        return isset($this->Payments) ? $this->Payments : null;
    }
    /**
     * Set Payments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Payment $payments
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request
     */
    public function setPayments(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Payment $payments = null)
    {
        if (is_null($payments) || (is_array($payments) && empty($payments))) {
            unset($this->Payments);
        } else {
            $this->Payments = $payments;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
