<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetByKey StructType
 * Meta information extracted from the WSDL
 * - documentation: [Ajouté 2013/04 - V1102] - Permet d'obtenir un document de vente en fonction de sa clé unique.
 * @subpackage Structs
 */
class GetByKey extends AbstractStructBase
{
    /**
     * The searchRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request
     */
    public $searchRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for GetByKey
     * @uses GetByKey::setSearchRequest()
     * @uses GetByKey::setClientContext()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request $searchRequest
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request $searchRequest = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setSearchRequest($searchRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get searchRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request|null
     */
    public function getSearchRequest()
    {
        return isset($this->searchRequest) ? $this->searchRequest : null;
    }
    /**
     * Set searchRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request $searchRequest
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey
     */
    public function setSearchRequest(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request $searchRequest = null)
    {
        if (is_null($searchRequest) || (is_array($searchRequest) && empty($searchRequest))) {
            unset($this->searchRequest);
        } else {
            $this->searchRequest = $searchRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
