<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetByKey_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Objet utilisé pour véhiculer les données pour l'obtention d'un document de vente
 * - nillable: true
 * - type: tns:GetByKey_Request
 * @subpackage Structs
 */
class GetByKey_Request extends AbstractStructBase
{
    /**
     * The Key
     * Meta information extracted from the WSDL
     * - documentation: Clé du document.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey
     */
    public $Key;
    /**
     * Constructor method for GetByKey_Request
     * @uses GetByKey_Request::setKey()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key = null)
    {
        $this
            ->setKey($key);
    }
    /**
     * Get Key value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey|null
     */
    public function getKey()
    {
        return isset($this->Key) ? $this->Key : null;
    }
    /**
     * Set Key value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request
     */
    public function setKey(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentKey $key = null)
    {
        if (is_null($key) || (is_array($key) && empty($key))) {
            unset($this->Key);
        } else {
            $this->Key = $key;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKey_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
