<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetByReference_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Objet utilisé pour véhiculer les données pour l'obtention d'un document de vente
 * - nillable: true
 * - type: tns:GetByReference_Request
 * @subpackage Structs
 */
class GetByReference_Request extends AbstractStructBase
{
    /**
     * The Reference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentReference
     */
    public $Reference;
    /**
     * Constructor method for GetByReference_Request
     * @uses GetByReference_Request::setReference()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentReference $reference
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentReference $reference = null)
    {
        $this
            ->setReference($reference);
    }
    /**
     * Get Reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentReference|null
     */
    public function getReference()
    {
        return isset($this->Reference) ? $this->Reference : null;
    }
    /**
     * Set Reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentReference $reference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReference_Request
     */
    public function setReference(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentReference $reference = null)
    {
        if (is_null($reference) || (is_array($reference) && empty($reference))) {
            unset($this->Reference);
        } else {
            $this->Reference = $reference;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByReference_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
