<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetHeaderList_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Objet utilisé pour véhiculer les données pour l'obtention d'un historique des ventes.
 * - nillable: true
 * - type: tns:GetHeaderList_Request
 * @subpackage Structs
 */
class GetHeaderList_Request extends AbstractStructBase
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Documents de vente actifs seulement. - Relatif à la colonne [PIECE.GP_VIVANTE].
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $Active;
    /**
     * The BeginDate
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Date de début à utiliser pour retrouver les documents de ventes. Borne incluse. - Relatif à la colonne [PIECE.GP_DATEPIECE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BeginDate;
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Identifiant du client pour lequel on veut obtenir l'historique des ventes. - Relatif à la colonne [TIERS.T_TIERS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CustomerId;
    /**
     * The DocumentTypes
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Liste des types de document de ventes - Relatif à la colonne [PIECE.GP_NATUREPIECEG].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType
     */
    public $DocumentTypes;
    /**
     * The EndDate
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Date de fin à utiliser pour retrouver les documents de ventes. Borne incluse. - Relatif à la colonne [PIECE.GP_DATEPIECE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EndDate;
    /**
     * The Pager
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Objet de gestion de la pagination.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Pager
     */
    public $Pager;
    /**
     * The StoreIds
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Liste des établissements. - Relatif à la colonne [ETABLISS.ET_ETABLISSEMENT].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfstring
     */
    public $StoreIds;
    /**
     * Constructor method for GetHeaderList_Request
     * @uses GetHeaderList_Request::setActive()
     * @uses GetHeaderList_Request::setBeginDate()
     * @uses GetHeaderList_Request::setCustomerId()
     * @uses GetHeaderList_Request::setDocumentTypes()
     * @uses GetHeaderList_Request::setEndDate()
     * @uses GetHeaderList_Request::setPager()
     * @uses GetHeaderList_Request::setStoreIds()
     * @param bool $active
     * @param string $beginDate
     * @param string $customerId
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType $documentTypes
     * @param string $endDate
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Pager $pager
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfstring $storeIds
     */
    public function __construct($active = null, $beginDate = null, $customerId = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType $documentTypes = null, $endDate = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Pager $pager = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfstring $storeIds = null)
    {
        $this
            ->setActive($active)
            ->setBeginDate($beginDate)
            ->setCustomerId($customerId)
            ->setDocumentTypes($documentTypes)
            ->setEndDate($endDate)
            ->setPager($pager)
            ->setStoreIds($storeIds);
    }
    /**
     * Get Active value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getActive()
    {
        return isset($this->Active) ? $this->Active : null;
    }
    /**
     * Set Active value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $active
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        if (is_null($active) || (is_array($active) && empty($active))) {
            unset($this->Active);
        } else {
            $this->Active = $active;
        }
        return $this;
    }
    /**
     * Get BeginDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBeginDate()
    {
        return isset($this->BeginDate) ? $this->BeginDate : null;
    }
    /**
     * Set BeginDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $beginDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public function setBeginDate($beginDate = null)
    {
        // validation for constraint: string
        if (!is_null($beginDate) && !is_string($beginDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($beginDate, true), gettype($beginDate)), __LINE__);
        }
        if (is_null($beginDate) || (is_array($beginDate) && empty($beginDate))) {
            unset($this->BeginDate);
        } else {
            $this->BeginDate = $beginDate;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get DocumentTypes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType|null
     */
    public function getDocumentTypes()
    {
        return isset($this->DocumentTypes) ? $this->DocumentTypes : null;
    }
    /**
     * Set DocumentTypes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType $documentTypes
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public function setDocumentTypes(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfSaleDocumentType $documentTypes = null)
    {
        if (is_null($documentTypes) || (is_array($documentTypes) && empty($documentTypes))) {
            unset($this->DocumentTypes);
        } else {
            $this->DocumentTypes = $documentTypes;
        }
        return $this;
    }
    /**
     * Get EndDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEndDate()
    {
        return isset($this->EndDate) ? $this->EndDate : null;
    }
    /**
     * Set EndDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $endDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endDate, true), gettype($endDate)), __LINE__);
        }
        if (is_null($endDate) || (is_array($endDate) && empty($endDate))) {
            unset($this->EndDate);
        } else {
            $this->EndDate = $endDate;
        }
        return $this;
    }
    /**
     * Get Pager value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Pager|null
     */
    public function getPager()
    {
        return isset($this->Pager) ? $this->Pager : null;
    }
    /**
     * Set Pager value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Pager $pager
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public function setPager(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Pager $pager = null)
    {
        if (is_null($pager) || (is_array($pager) && empty($pager))) {
            unset($this->Pager);
        } else {
            $this->Pager = $pager;
        }
        return $this;
    }
    /**
     * Get StoreIds value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfstring|null
     */
    public function getStoreIds()
    {
        return isset($this->StoreIds) ? $this->StoreIds : null;
    }
    /**
     * Set StoreIds value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfstring $storeIds
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public function setStoreIds(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfstring $storeIds = null)
    {
        if (is_null($storeIds) || (is_array($storeIds) && empty($storeIds))) {
            unset($this->StoreIds);
        } else {
            $this->StoreIds = $storeIds;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
