<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_Line StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Get_Line
 * @subpackage Structs
 */
class Get_Line extends AbstractStructBase
{
    /**
     * The CatalogReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2018/01 - V1400] [Optionnel] - Référence catalogue - Relatif à la colonne [LIGNESERIE.GLS_IDSERIE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CatalogReference;
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/01 - V1201] [Optionnel] - Commentaire sur la ligne du document, pouvant être du texte brut ou du texte formaté RTF - Relatif à la colonne [LIGNE.GL_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The ComplementaryDescription
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11 - V1300] [Optionnel] - Libellé complémentaire à la ligne - Relatif à la colonne [LIGNE.GL_LIBCOMPL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ComplementaryDescription;
    /**
     * The DeliveryDate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11 - V1300] [Optionnel] - Date de livraison à la ligne - Relatif à la colonne [LIGNE.GL_DATELIVRAISON].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeliveryDate;
    /**
     * The DiscountTypeId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du type de remise - Relatif à la colonne [LIGNE.GL_TYPEREMISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DiscountTypeId;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/02 - V1105] [Optionnel] - Référence externe de la ligne. - Relatif à la colonne [LIGNE.GL_REFEXTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The InitialDeliveryDate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11 - V1300] [Optionnel] - Date de livraison initiale à la ligne - Relatif à la colonne [LIGNE.GL_DATELIVINITIALE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InitialDeliveryDate;
    /**
     * The ItemCode
     * Meta information extracted from the WSDL
     * - documentation: Code de l'article. - Relatif à la colonne [LIGNE.GL_CODEARTICLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ItemCode;
    /**
     * The ItemId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de l'article. - Relatif à la colonne [LIGNE.GL_ARTICLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ItemId;
    /**
     * The ItemReference
     * Meta information extracted from the WSDL
     * - documentation: Référence de l'article. - Relatif à la colonne [LIGNE.GL_REFARTBARRE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ItemReference;
    /**
     * The Label
     * Meta information extracted from the WSDL
     * - documentation: Libellé de la ligne. - Relatif à la colonne [LIGNE.GL_LIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Label;
    /**
     * The MovementReasonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/02 - V1105] [Optionnel] - Identifiant du motif de mouvement associé à la ligne. - Relatif à la colonne [LIGNE.GL_MOTIFMVT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MovementReasonId;
    /**
     * The OmniChannel
     * Meta information extracted from the WSDL
     * - documentation: Omni-canal.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine
     */
    public $OmniChannel;
    /**
     * The Origin
     * Meta information extracted from the WSDL
     * - documentation: Provenance de la ligne de document. - Relatif à la colonne [LIGNE.GL_TYPEPROVENANCE].
     * - minOccurs: 0
     * @var string
     */
    public $Origin;
    /**
     * The PackageReference
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/01 - V1201] [Optionnel] - Référence du colis - Relatif à la colonne [LIGNE.GL_REFCOLIS].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PackageReference;
    /**
     * The Quantity
     * Meta information extracted from the WSDL
     * - documentation: Quantité. - Relatif à la colonne [LIGNE.GL_QTEFACT].
     * - minOccurs: 0
     * @var float
     */
    public $Quantity;
    /**
     * The Rank
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2016/05 - V1300] [Optionnel] - Numéro d'ordre de la ligne - Relatif à la colonne [LIGNE.GL_NUMORDRE].
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Rank;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/10 - V1105] [Optionnel] - Identifiant du vendeur de la ligne. - Relatif à la colonne [LIGNE.GL_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The SerialNumberId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/12 - V1300] [Optionnel] - Numéro de série de l'article - Relatif à la colonne [LIGNESERIE.GLS_IDSERIE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SerialNumberId;
    /**
     * The TaxExcludedNetUnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Prix Unitaire Net H.T. - Relatif à la colonne [LIGNE.GL_PUHTNET].
     * - minOccurs: 0
     * @var float
     */
    public $TaxExcludedNetUnitPrice;
    /**
     * The TaxExcludedUnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Prix Unitaire H.T. - Relatif à la colonne [LIGNE.GL_PUHT].
     * - minOccurs: 0
     * @var float
     */
    public $TaxExcludedUnitPrice;
    /**
     * The TaxIncludedNetUnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Prix Unitaire Net T.T.C. - Relatif à la colonne [LIGNE.GL_PUTTCNET].
     * - minOccurs: 0
     * @var float
     */
    public $TaxIncludedNetUnitPrice;
    /**
     * The TaxIncludedUnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Prix Unitaire T.T.C. - Relatif à la colonne [LIGNE.GL_PUTTC].
     * - minOccurs: 0
     * @var float
     */
    public $TaxIncludedUnitPrice;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/02 - V1201] - Identifiant du dépôt de l'établissement de la ligne du document - Relatif à la colonne [LIGNE.GL_DEPOT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for Get_Line
     * @uses Get_Line::setCatalogReference()
     * @uses Get_Line::setComment()
     * @uses Get_Line::setComplementaryDescription()
     * @uses Get_Line::setDeliveryDate()
     * @uses Get_Line::setDiscountTypeId()
     * @uses Get_Line::setExternalReference()
     * @uses Get_Line::setInitialDeliveryDate()
     * @uses Get_Line::setItemCode()
     * @uses Get_Line::setItemId()
     * @uses Get_Line::setItemReference()
     * @uses Get_Line::setLabel()
     * @uses Get_Line::setMovementReasonId()
     * @uses Get_Line::setOmniChannel()
     * @uses Get_Line::setOrigin()
     * @uses Get_Line::setPackageReference()
     * @uses Get_Line::setQuantity()
     * @uses Get_Line::setRank()
     * @uses Get_Line::setSalesPersonId()
     * @uses Get_Line::setSerialNumberId()
     * @uses Get_Line::setTaxExcludedNetUnitPrice()
     * @uses Get_Line::setTaxExcludedUnitPrice()
     * @uses Get_Line::setTaxIncludedNetUnitPrice()
     * @uses Get_Line::setTaxIncludedUnitPrice()
     * @uses Get_Line::setWarehouseId()
     * @param string $catalogReference
     * @param string $comment
     * @param string $complementaryDescription
     * @param string $deliveryDate
     * @param string $discountTypeId
     * @param string $externalReference
     * @param string $initialDeliveryDate
     * @param string $itemCode
     * @param string $itemId
     * @param string $itemReference
     * @param string $label
     * @param string $movementReasonId
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine $omniChannel
     * @param string $origin
     * @param string $packageReference
     * @param float $quantity
     * @param int $rank
     * @param string $salesPersonId
     * @param string $serialNumberId
     * @param float $taxExcludedNetUnitPrice
     * @param float $taxExcludedUnitPrice
     * @param float $taxIncludedNetUnitPrice
     * @param float $taxIncludedUnitPrice
     * @param string $warehouseId
     */
    public function __construct($catalogReference = null, $comment = null, $complementaryDescription = null, $deliveryDate = null, $discountTypeId = null, $externalReference = null, $initialDeliveryDate = null, $itemCode = null, $itemId = null, $itemReference = null, $label = null, $movementReasonId = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine $omniChannel = null, $origin = null, $packageReference = null, $quantity = null, $rank = null, $salesPersonId = null, $serialNumberId = null, $taxExcludedNetUnitPrice = null, $taxExcludedUnitPrice = null, $taxIncludedNetUnitPrice = null, $taxIncludedUnitPrice = null, $warehouseId = null)
    {
        $this
            ->setCatalogReference($catalogReference)
            ->setComment($comment)
            ->setComplementaryDescription($complementaryDescription)
            ->setDeliveryDate($deliveryDate)
            ->setDiscountTypeId($discountTypeId)
            ->setExternalReference($externalReference)
            ->setInitialDeliveryDate($initialDeliveryDate)
            ->setItemCode($itemCode)
            ->setItemId($itemId)
            ->setItemReference($itemReference)
            ->setLabel($label)
            ->setMovementReasonId($movementReasonId)
            ->setOmniChannel($omniChannel)
            ->setOrigin($origin)
            ->setPackageReference($packageReference)
            ->setQuantity($quantity)
            ->setRank($rank)
            ->setSalesPersonId($salesPersonId)
            ->setSerialNumberId($serialNumberId)
            ->setTaxExcludedNetUnitPrice($taxExcludedNetUnitPrice)
            ->setTaxExcludedUnitPrice($taxExcludedUnitPrice)
            ->setTaxIncludedNetUnitPrice($taxIncludedNetUnitPrice)
            ->setTaxIncludedUnitPrice($taxIncludedUnitPrice)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get CatalogReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCatalogReference()
    {
        return isset($this->CatalogReference) ? $this->CatalogReference : null;
    }
    /**
     * Set CatalogReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $catalogReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setCatalogReference($catalogReference = null)
    {
        // validation for constraint: string
        if (!is_null($catalogReference) && !is_string($catalogReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($catalogReference, true), gettype($catalogReference)), __LINE__);
        }
        if (is_null($catalogReference) || (is_array($catalogReference) && empty($catalogReference))) {
            unset($this->CatalogReference);
        } else {
            $this->CatalogReference = $catalogReference;
        }
        return $this;
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get ComplementaryDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComplementaryDescription()
    {
        return isset($this->ComplementaryDescription) ? $this->ComplementaryDescription : null;
    }
    /**
     * Set ComplementaryDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $complementaryDescription
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setComplementaryDescription($complementaryDescription = null)
    {
        // validation for constraint: string
        if (!is_null($complementaryDescription) && !is_string($complementaryDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($complementaryDescription, true), gettype($complementaryDescription)), __LINE__);
        }
        if (is_null($complementaryDescription) || (is_array($complementaryDescription) && empty($complementaryDescription))) {
            unset($this->ComplementaryDescription);
        } else {
            $this->ComplementaryDescription = $complementaryDescription;
        }
        return $this;
    }
    /**
     * Get DeliveryDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeliveryDate()
    {
        return isset($this->DeliveryDate) ? $this->DeliveryDate : null;
    }
    /**
     * Set DeliveryDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deliveryDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setDeliveryDate($deliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDate) && !is_string($deliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryDate, true), gettype($deliveryDate)), __LINE__);
        }
        if (is_null($deliveryDate) || (is_array($deliveryDate) && empty($deliveryDate))) {
            unset($this->DeliveryDate);
        } else {
            $this->DeliveryDate = $deliveryDate;
        }
        return $this;
    }
    /**
     * Get DiscountTypeId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDiscountTypeId()
    {
        return isset($this->DiscountTypeId) ? $this->DiscountTypeId : null;
    }
    /**
     * Set DiscountTypeId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $discountTypeId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setDiscountTypeId($discountTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($discountTypeId) && !is_string($discountTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($discountTypeId, true), gettype($discountTypeId)), __LINE__);
        }
        if (is_null($discountTypeId) || (is_array($discountTypeId) && empty($discountTypeId))) {
            unset($this->DiscountTypeId);
        } else {
            $this->DiscountTypeId = $discountTypeId;
        }
        return $this;
    }
    /**
     * Get ExternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalReference()
    {
        return isset($this->ExternalReference) ? $this->ExternalReference : null;
    }
    /**
     * Set ExternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        if (is_null($externalReference) || (is_array($externalReference) && empty($externalReference))) {
            unset($this->ExternalReference);
        } else {
            $this->ExternalReference = $externalReference;
        }
        return $this;
    }
    /**
     * Get InitialDeliveryDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInitialDeliveryDate()
    {
        return isset($this->InitialDeliveryDate) ? $this->InitialDeliveryDate : null;
    }
    /**
     * Set InitialDeliveryDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $initialDeliveryDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setInitialDeliveryDate($initialDeliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($initialDeliveryDate) && !is_string($initialDeliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($initialDeliveryDate, true), gettype($initialDeliveryDate)), __LINE__);
        }
        if (is_null($initialDeliveryDate) || (is_array($initialDeliveryDate) && empty($initialDeliveryDate))) {
            unset($this->InitialDeliveryDate);
        } else {
            $this->InitialDeliveryDate = $initialDeliveryDate;
        }
        return $this;
    }
    /**
     * Get ItemCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getItemCode()
    {
        return isset($this->ItemCode) ? $this->ItemCode : null;
    }
    /**
     * Set ItemCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $itemCode
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setItemCode($itemCode = null)
    {
        // validation for constraint: string
        if (!is_null($itemCode) && !is_string($itemCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemCode, true), gettype($itemCode)), __LINE__);
        }
        if (is_null($itemCode) || (is_array($itemCode) && empty($itemCode))) {
            unset($this->ItemCode);
        } else {
            $this->ItemCode = $itemCode;
        }
        return $this;
    }
    /**
     * Get ItemId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getItemId()
    {
        return isset($this->ItemId) ? $this->ItemId : null;
    }
    /**
     * Set ItemId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $itemId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setItemId($itemId = null)
    {
        // validation for constraint: string
        if (!is_null($itemId) && !is_string($itemId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemId, true), gettype($itemId)), __LINE__);
        }
        if (is_null($itemId) || (is_array($itemId) && empty($itemId))) {
            unset($this->ItemId);
        } else {
            $this->ItemId = $itemId;
        }
        return $this;
    }
    /**
     * Get ItemReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getItemReference()
    {
        return isset($this->ItemReference) ? $this->ItemReference : null;
    }
    /**
     * Set ItemReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $itemReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setItemReference($itemReference = null)
    {
        // validation for constraint: string
        if (!is_null($itemReference) && !is_string($itemReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($itemReference, true), gettype($itemReference)), __LINE__);
        }
        if (is_null($itemReference) || (is_array($itemReference) && empty($itemReference))) {
            unset($this->ItemReference);
        } else {
            $this->ItemReference = $itemReference;
        }
        return $this;
    }
    /**
     * Get Label value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabel()
    {
        return isset($this->Label) ? $this->Label : null;
    }
    /**
     * Set Label value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $label
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        if (is_null($label) || (is_array($label) && empty($label))) {
            unset($this->Label);
        } else {
            $this->Label = $label;
        }
        return $this;
    }
    /**
     * Get MovementReasonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMovementReasonId()
    {
        return isset($this->MovementReasonId) ? $this->MovementReasonId : null;
    }
    /**
     * Set MovementReasonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $movementReasonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setMovementReasonId($movementReasonId = null)
    {
        // validation for constraint: string
        if (!is_null($movementReasonId) && !is_string($movementReasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($movementReasonId, true), gettype($movementReasonId)), __LINE__);
        }
        if (is_null($movementReasonId) || (is_array($movementReasonId) && empty($movementReasonId))) {
            unset($this->MovementReasonId);
        } else {
            $this->MovementReasonId = $movementReasonId;
        }
        return $this;
    }
    /**
     * Get OmniChannel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine|null
     */
    public function getOmniChannel()
    {
        return isset($this->OmniChannel) ? $this->OmniChannel : null;
    }
    /**
     * Set OmniChannel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine $omniChannel
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setOmniChannel(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetOmniChannelLine $omniChannel = null)
    {
        if (is_null($omniChannel) || (is_array($omniChannel) && empty($omniChannel))) {
            unset($this->OmniChannel);
        } else {
            $this->OmniChannel = $omniChannel;
        }
        return $this;
    }
    /**
     * Get Origin value
     * @return string|null
     */
    public function getOrigin()
    {
        return $this->Origin;
    }
    /**
     * Set Origin value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $origin
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setOrigin($origin = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid($origin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin', is_array($origin) ? implode(', ', $origin) : var_export($origin, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues())), __LINE__);
        }
        $this->Origin = $origin;
        return $this;
    }
    /**
     * Get PackageReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPackageReference()
    {
        return isset($this->PackageReference) ? $this->PackageReference : null;
    }
    /**
     * Set PackageReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $packageReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setPackageReference($packageReference = null)
    {
        // validation for constraint: string
        if (!is_null($packageReference) && !is_string($packageReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($packageReference, true), gettype($packageReference)), __LINE__);
        }
        if (is_null($packageReference) || (is_array($packageReference) && empty($packageReference))) {
            unset($this->PackageReference);
        } else {
            $this->PackageReference = $packageReference;
        }
        return $this;
    }
    /**
     * Get Quantity value
     * @return float|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param float $quantity
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: float
        if (!is_null($quantity) && !(is_float($quantity) || is_numeric($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get Rank value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getRank()
    {
        return isset($this->Rank) ? $this->Rank : null;
    }
    /**
     * Set Rank value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $rank
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setRank($rank = null)
    {
        // validation for constraint: int
        if (!is_null($rank) && !(is_int($rank) || ctype_digit($rank))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rank, true), gettype($rank)), __LINE__);
        }
        if (is_null($rank) || (is_array($rank) && empty($rank))) {
            unset($this->Rank);
        } else {
            $this->Rank = $rank;
        }
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get SerialNumberId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerialNumberId()
    {
        return isset($this->SerialNumberId) ? $this->SerialNumberId : null;
    }
    /**
     * Set SerialNumberId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serialNumberId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setSerialNumberId($serialNumberId = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumberId) && !is_string($serialNumberId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serialNumberId, true), gettype($serialNumberId)), __LINE__);
        }
        if (is_null($serialNumberId) || (is_array($serialNumberId) && empty($serialNumberId))) {
            unset($this->SerialNumberId);
        } else {
            $this->SerialNumberId = $serialNumberId;
        }
        return $this;
    }
    /**
     * Get TaxExcludedNetUnitPrice value
     * @return float|null
     */
    public function getTaxExcludedNetUnitPrice()
    {
        return $this->TaxExcludedNetUnitPrice;
    }
    /**
     * Set TaxExcludedNetUnitPrice value
     * @param float $taxExcludedNetUnitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setTaxExcludedNetUnitPrice($taxExcludedNetUnitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($taxExcludedNetUnitPrice) && !(is_float($taxExcludedNetUnitPrice) || is_numeric($taxExcludedNetUnitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxExcludedNetUnitPrice, true), gettype($taxExcludedNetUnitPrice)), __LINE__);
        }
        $this->TaxExcludedNetUnitPrice = $taxExcludedNetUnitPrice;
        return $this;
    }
    /**
     * Get TaxExcludedUnitPrice value
     * @return float|null
     */
    public function getTaxExcludedUnitPrice()
    {
        return $this->TaxExcludedUnitPrice;
    }
    /**
     * Set TaxExcludedUnitPrice value
     * @param float $taxExcludedUnitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setTaxExcludedUnitPrice($taxExcludedUnitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($taxExcludedUnitPrice) && !(is_float($taxExcludedUnitPrice) || is_numeric($taxExcludedUnitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxExcludedUnitPrice, true), gettype($taxExcludedUnitPrice)), __LINE__);
        }
        $this->TaxExcludedUnitPrice = $taxExcludedUnitPrice;
        return $this;
    }
    /**
     * Get TaxIncludedNetUnitPrice value
     * @return float|null
     */
    public function getTaxIncludedNetUnitPrice()
    {
        return $this->TaxIncludedNetUnitPrice;
    }
    /**
     * Set TaxIncludedNetUnitPrice value
     * @param float $taxIncludedNetUnitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setTaxIncludedNetUnitPrice($taxIncludedNetUnitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($taxIncludedNetUnitPrice) && !(is_float($taxIncludedNetUnitPrice) || is_numeric($taxIncludedNetUnitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxIncludedNetUnitPrice, true), gettype($taxIncludedNetUnitPrice)), __LINE__);
        }
        $this->TaxIncludedNetUnitPrice = $taxIncludedNetUnitPrice;
        return $this;
    }
    /**
     * Get TaxIncludedUnitPrice value
     * @return float|null
     */
    public function getTaxIncludedUnitPrice()
    {
        return $this->TaxIncludedUnitPrice;
    }
    /**
     * Set TaxIncludedUnitPrice value
     * @param float $taxIncludedUnitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setTaxIncludedUnitPrice($taxIncludedUnitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($taxIncludedUnitPrice) && !(is_float($taxIncludedUnitPrice) || is_numeric($taxIncludedUnitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($taxIncludedUnitPrice, true), gettype($taxIncludedUnitPrice)), __LINE__);
        }
        $this->TaxIncludedUnitPrice = $taxIncludedUnitPrice;
        return $this;
    }
    /**
     * Get WarehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getWarehouseId()
    {
        return isset($this->WarehouseId) ? $this->WarehouseId : null;
    }
    /**
     * Set WarehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        if (is_null($warehouseId) || (is_array($warehouseId) && empty($warehouseId))) {
            unset($this->WarehouseId);
        } else {
            $this->WarehouseId = $warehouseId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
