<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_Payment StructType
 * Meta information extracted from the WSDL
 * - documentation: Paiement.
 * - nillable: true
 * - type: tns:Get_Payment
 * @subpackage Structs
 */
class Get_Payment extends AbstractStructBase
{
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - documentation: Montant du paiement (dans la devise du paiement). - Relatif à la colonne [PIEDECHE.GPE_MONTANTENCAIS].
     * - minOccurs: 0
     * @var float
     */
    public $Amount;
    /**
     * The CashAmount
     * Meta information extracted from the WSDL
     * - documentation: Montant payé dans la devise. - Relatif à la colonne [PIEDECHE.GPE_MONTANTECHE].
     * - minOccurs: 0
     * @var float
     */
    public $CashAmount;
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - documentation: Code du mode de paiement. - Relatif à la colonne [PIEDECHE.GPE_MODEPAIE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Code;
    /**
     * The CreditCard
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard
     */
    public $CreditCard;
    /**
     * The Currency
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la devise. - Relatif à la colonne [PIEDECHE.GPE_DEVISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Currency;
    /**
     * The CurrencySymbol
     * Meta information extracted from the WSDL
     * - documentation: [Obsolète].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CurrencySymbol;
    /**
     * The DueDate
     * Meta information extracted from the WSDL
     * - documentation: Date de l'échéance. - Relatif à la colonne [PIEDECHE.GPE_DATEECHE].
     * - minOccurs: 0
     * @var string
     */
    public $DueDate;
    /**
     * The IsReceivedPayment
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/09 - V1105] - Dans le cas d'une commande non eCommerce, indique que le règlement est un règlement percu. Dans les autres cas la valeur par défaut est false. - Relatif à la colonne [PIEDECHE.GPE_PERCU].
     * - minOccurs: 0
     * @var bool
     */
    public $IsReceivedPayment;
    /**
     * The Label
     * Meta information extracted from the WSDL
     * - documentation: Libellé de la devise. - Relatif à la colonne [PIEDECHE.GPE_CBLIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Label;
    /**
     * Constructor method for Get_Payment
     * @uses Get_Payment::setAmount()
     * @uses Get_Payment::setCashAmount()
     * @uses Get_Payment::setCode()
     * @uses Get_Payment::setCreditCard()
     * @uses Get_Payment::setCurrency()
     * @uses Get_Payment::setCurrencySymbol()
     * @uses Get_Payment::setDueDate()
     * @uses Get_Payment::setIsReceivedPayment()
     * @uses Get_Payment::setLabel()
     * @param float $amount
     * @param float $cashAmount
     * @param string $code
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard
     * @param string $currency
     * @param string $currencySymbol
     * @param string $dueDate
     * @param bool $isReceivedPayment
     * @param string $label
     */
    public function __construct($amount = null, $cashAmount = null, $code = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard = null, $currency = null, $currencySymbol = null, $dueDate = null, $isReceivedPayment = null, $label = null)
    {
        $this
            ->setAmount($amount)
            ->setCashAmount($cashAmount)
            ->setCode($code)
            ->setCreditCard($creditCard)
            ->setCurrency($currency)
            ->setCurrencySymbol($currencySymbol)
            ->setDueDate($dueDate)
            ->setIsReceivedPayment($isReceivedPayment)
            ->setLabel($label);
    }
    /**
     * Get Amount value
     * @return float|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: float
        if (!is_null($amount) && !(is_float($amount) || is_numeric($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get CashAmount value
     * @return float|null
     */
    public function getCashAmount()
    {
        return $this->CashAmount;
    }
    /**
     * Set CashAmount value
     * @param float $cashAmount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setCashAmount($cashAmount = null)
    {
        // validation for constraint: float
        if (!is_null($cashAmount) && !(is_float($cashAmount) || is_numeric($cashAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($cashAmount, true), gettype($cashAmount)), __LINE__);
        }
        $this->CashAmount = $cashAmount;
        return $this;
    }
    /**
     * Get Code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCode()
    {
        return isset($this->Code) ? $this->Code : null;
    }
    /**
     * Set Code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $code
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        if (is_null($code) || (is_array($code) && empty($code))) {
            unset($this->Code);
        } else {
            $this->Code = $code;
        }
        return $this;
    }
    /**
     * Get CreditCard value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard|null
     */
    public function getCreditCard()
    {
        return isset($this->CreditCard) ? $this->CreditCard : null;
    }
    /**
     * Set CreditCard value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setCreditCard(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard $creditCard = null)
    {
        if (is_null($creditCard) || (is_array($creditCard) && empty($creditCard))) {
            unset($this->CreditCard);
        } else {
            $this->CreditCard = $creditCard;
        }
        return $this;
    }
    /**
     * Get Currency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrency()
    {
        return isset($this->Currency) ? $this->Currency : null;
    }
    /**
     * Set Currency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currency
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        if (is_null($currency) || (is_array($currency) && empty($currency))) {
            unset($this->Currency);
        } else {
            $this->Currency = $currency;
        }
        return $this;
    }
    /**
     * Get CurrencySymbol value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCurrencySymbol()
    {
        return isset($this->CurrencySymbol) ? $this->CurrencySymbol : null;
    }
    /**
     * Set CurrencySymbol value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $currencySymbol
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setCurrencySymbol($currencySymbol = null)
    {
        // validation for constraint: string
        if (!is_null($currencySymbol) && !is_string($currencySymbol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencySymbol, true), gettype($currencySymbol)), __LINE__);
        }
        if (is_null($currencySymbol) || (is_array($currencySymbol) && empty($currencySymbol))) {
            unset($this->CurrencySymbol);
        } else {
            $this->CurrencySymbol = $currencySymbol;
        }
        return $this;
    }
    /**
     * Get DueDate value
     * @return string|null
     */
    public function getDueDate()
    {
        return $this->DueDate;
    }
    /**
     * Set DueDate value
     * @param string $dueDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setDueDate($dueDate = null)
    {
        // validation for constraint: string
        if (!is_null($dueDate) && !is_string($dueDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dueDate, true), gettype($dueDate)), __LINE__);
        }
        $this->DueDate = $dueDate;
        return $this;
    }
    /**
     * Get IsReceivedPayment value
     * @return bool|null
     */
    public function getIsReceivedPayment()
    {
        return $this->IsReceivedPayment;
    }
    /**
     * Set IsReceivedPayment value
     * @param bool $isReceivedPayment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setIsReceivedPayment($isReceivedPayment = null)
    {
        // validation for constraint: boolean
        if (!is_null($isReceivedPayment) && !is_bool($isReceivedPayment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isReceivedPayment, true), gettype($isReceivedPayment)), __LINE__);
        }
        $this->IsReceivedPayment = $isReceivedPayment;
        return $this;
    }
    /**
     * Get Label value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabel()
    {
        return isset($this->Label) ? $this->Label : null;
    }
    /**
     * Set Label value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $label
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        if (is_null($label) || (is_array($label) && empty($label))) {
            unset($this->Label);
        } else {
            $this->Label = $label;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Payment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
