<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Lock StructType
 * Meta information extracted from the WSDL
 * - documentation: [Ajouté 2013/08 - V1105] - Permet le blocage d'un document de vente ecommerce.
 * @subpackage Structs
 */
class Lock extends AbstractStructBase
{
    /**
     * The lockRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request
     */
    public $lockRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for Lock
     * @uses Lock::setLockRequest()
     * @uses Lock::setClientContext()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request $lockRequest
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request $lockRequest = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setLockRequest($lockRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get lockRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request|null
     */
    public function getLockRequest()
    {
        return isset($this->lockRequest) ? $this->lockRequest : null;
    }
    /**
     * Set lockRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request $lockRequest
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock
     */
    public function setLockRequest(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request $lockRequest = null)
    {
        if (is_null($lockRequest) || (is_array($lockRequest) && empty($lockRequest))) {
            unset($this->lockRequest);
        } else {
            $this->lockRequest = $lockRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
