<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Lock_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Paramètres d'entrée à fournir pour le blocage de la commande.
 * - nillable: true
 * - type: tns:Lock_Request
 * @subpackage Structs
 */
class Lock_Request extends AbstractStructBase
{
    /**
     * The Identifier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier
     */
    public $Identifier;
    /**
     * The ReasonId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du motif de blocage. - Relatif à la colonne [MPIECEECO.MEJ_MOTIFANNUL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReasonId;
    /**
     * Constructor method for Lock_Request
     * @uses Lock_Request::setIdentifier()
     * @uses Lock_Request::setReasonId()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @param string $reasonId
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null, $reasonId = null)
    {
        $this
            ->setIdentifier($identifier)
            ->setReasonId($reasonId);
    }
    /**
     * Get Identifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier|null
     */
    public function getIdentifier()
    {
        return isset($this->Identifier) ? $this->Identifier : null;
    }
    /**
     * Set Identifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request
     */
    public function setIdentifier(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null)
    {
        if (is_null($identifier) || (is_array($identifier) && empty($identifier))) {
            unset($this->Identifier);
        } else {
            $this->Identifier = $identifier;
        }
        return $this;
    }
    /**
     * Get ReasonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReasonId()
    {
        return isset($this->ReasonId) ? $this->ReasonId : null;
    }
    /**
     * Set ReasonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reasonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request
     */
    public function setReasonId($reasonId = null)
    {
        // validation for constraint: string
        if (!is_null($reasonId) && !is_string($reasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonId, true), gettype($reasonId)), __LINE__);
        }
        if (is_null($reasonId) || (is_array($reasonId) && empty($reasonId))) {
            unset($this->ReasonId);
        } else {
            $this->ReasonId = $reasonId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
