<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OmniChannel StructType
 * Meta information extracted from the WSDL
 * - documentation: Données Omni-Canal
 * - nillable: true
 * - type: tns:OmniChannel
 * @subpackage Structs
 */
class OmniChannel extends AbstractStructBase
{
    /**
     * The BillingStatus
     * Meta information extracted from the WSDL
     * - documentation: Statut de facturation de la commande - Relatif à la colonne [MPIECEECO.MEJ_CDEECOMFACT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $BillingStatus;
    /**
     * The CancelDate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Date d'annulation. Notez que l'heure n'est pas prise en compte. Donnée en consultation uniquement. - Relatif à la colonne [MPIECEECO.MEJ_DATEANNUL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CancelDate;
    /**
     * The CancelReasonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Identifiant du motif de blocage ou d'annulation. Donnée en consultation uniquement. - Relatif à la colonne [MPIECEECO.MEJ_MOTIFANNUL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CancelReasonId;
    /**
     * The CancelStatus
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Status d'annulation. Donnée en consultation uniquement. - Relatif à la colonne [PIECE.GP_STATUTANNUL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CancelStatus;
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Commentaire - Relatif à la colonne [MPIECEECO.MEJ_COMMENTAIRE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The DeliveryStoreId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la boutique de retrait de la commande. - Relatif à la colonne [MPIECEECO.CDEECOMETAB].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeliveryStoreId;
    /**
     * The DeliveryType
     * Meta information extracted from the WSDL
     * - documentation: Type d’envoi de la commande - Relatif à la colonne [MPIECEECO.MEJ_CDEECOMENVOI].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeliveryType;
    /**
     * The DeliveryWarehouseId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/02 - V1201] [Optionnel] - Identifiant du dépôt de livraison du document - Relatif à la colonne [MPIECEECO.MEJ_CDEECOMDEPOT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeliveryWarehouseId;
    /**
     * The FollowUpStatus
     * Meta information extracted from the WSDL
     * - documentation: Statut de suivi de la commande - Relatif à la colonne [MPIECEECO.MEJ_CDEECOMSUIVI].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowUpStatus;
    /**
     * The GiftMessage
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Message cadeau repris sur une carte personnalisée. - Relatif à la colonne [MPIECEECO.MEJ_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GiftMessage;
    /**
     * The GiftMessageType
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Type de carte cadeau. - Valeur par defaut: None - Relatif à la colonne [MPIECEECO.MEJ_MESSAGECADEAU].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $GiftMessageType;
    /**
     * The LockingDate
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Date de blocage. Donnée en consultation uniquement. - Relatif à la colonne [MPIECEECO.MEJ_DATEBLOCAGE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LockingDate;
    /**
     * The OriginStoreId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2019/08 - V1400] [Optionnel] - Identifiant du magasin de saisie de la commande - Relatif à la colonne [MPIECEECO.MEJ_ETABEDIT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $OriginStoreId;
    /**
     * The OriginalDocument
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/11 - V1105] [Optionnel] - Document ecommerce d'origine (annonces de retour eCommerce). - Valeur par defaut: nil.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier
     */
    public $OriginalDocument;
    /**
     * The PaymentMethodId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/11 - V1105] [Optionnel] - Identifiant du mode de paiement (annonces de retour eCommerce). - Valeur par defaut: AVE/RMB.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PaymentMethodId;
    /**
     * The PaymentStatus
     * Meta information extracted from the WSDL
     * - documentation: Statut de règlement de la commande - Relatif à la colonne [MPIECEECO.MEJ_CDEECOMREGLT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PaymentStatus;
    /**
     * The ReturnStatus
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1104] - Statut de retour de la commande - Relatif à la colonne [MPIECEECO.MEJ_CDEECOMRETOUR].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReturnStatus;
    /**
     * The ReturnType
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/11 - V1105] [Optionnel] - Type de retour (annonces de retour eCommerce). - Valeur par defaut: .
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReturnType;
    /**
     * The ShippingStatus
     * Meta information extracted from the WSDL
     * - documentation: Statut d’expédition de la commande - Relatif à la colonne [MPIECEECO.MEJ_CDEECOMEXPED].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ShippingStatus;
    /**
     * The Tracking
     * Meta information extracted from the WSDL
     * - documentation: Tracking de la livraison - Relatif à la colonne [MPIECEECO.MEJ_TRACKING].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Tracking;
    /**
     * The Transporter
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/05 - V1104] [Optionnel] - Transporteur. - Relatif à la colonne [MPIECEECO.MEJ_TRANSPORT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Transporter;
    /**
     * Constructor method for OmniChannel
     * @uses OmniChannel::setBillingStatus()
     * @uses OmniChannel::setCancelDate()
     * @uses OmniChannel::setCancelReasonId()
     * @uses OmniChannel::setCancelStatus()
     * @uses OmniChannel::setComment()
     * @uses OmniChannel::setDeliveryStoreId()
     * @uses OmniChannel::setDeliveryType()
     * @uses OmniChannel::setDeliveryWarehouseId()
     * @uses OmniChannel::setFollowUpStatus()
     * @uses OmniChannel::setGiftMessage()
     * @uses OmniChannel::setGiftMessageType()
     * @uses OmniChannel::setLockingDate()
     * @uses OmniChannel::setOriginStoreId()
     * @uses OmniChannel::setOriginalDocument()
     * @uses OmniChannel::setPaymentMethodId()
     * @uses OmniChannel::setPaymentStatus()
     * @uses OmniChannel::setReturnStatus()
     * @uses OmniChannel::setReturnType()
     * @uses OmniChannel::setShippingStatus()
     * @uses OmniChannel::setTracking()
     * @uses OmniChannel::setTransporter()
     * @param string $billingStatus
     * @param string $cancelDate
     * @param string $cancelReasonId
     * @param string $cancelStatus
     * @param string $comment
     * @param string $deliveryStoreId
     * @param string $deliveryType
     * @param string $deliveryWarehouseId
     * @param string $followUpStatus
     * @param string $giftMessage
     * @param string $giftMessageType
     * @param string $lockingDate
     * @param string $originStoreId
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $originalDocument
     * @param string $paymentMethodId
     * @param string $paymentStatus
     * @param string $returnStatus
     * @param string $returnType
     * @param string $shippingStatus
     * @param string $tracking
     * @param string $transporter
     */
    public function __construct($billingStatus = null, $cancelDate = null, $cancelReasonId = null, $cancelStatus = null, $comment = null, $deliveryStoreId = null, $deliveryType = null, $deliveryWarehouseId = null, $followUpStatus = null, $giftMessage = null, $giftMessageType = null, $lockingDate = null, $originStoreId = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $originalDocument = null, $paymentMethodId = null, $paymentStatus = null, $returnStatus = null, $returnType = null, $shippingStatus = null, $tracking = null, $transporter = null)
    {
        $this
            ->setBillingStatus($billingStatus)
            ->setCancelDate($cancelDate)
            ->setCancelReasonId($cancelReasonId)
            ->setCancelStatus($cancelStatus)
            ->setComment($comment)
            ->setDeliveryStoreId($deliveryStoreId)
            ->setDeliveryType($deliveryType)
            ->setDeliveryWarehouseId($deliveryWarehouseId)
            ->setFollowUpStatus($followUpStatus)
            ->setGiftMessage($giftMessage)
            ->setGiftMessageType($giftMessageType)
            ->setLockingDate($lockingDate)
            ->setOriginStoreId($originStoreId)
            ->setOriginalDocument($originalDocument)
            ->setPaymentMethodId($paymentMethodId)
            ->setPaymentStatus($paymentStatus)
            ->setReturnStatus($returnStatus)
            ->setReturnType($returnType)
            ->setShippingStatus($shippingStatus)
            ->setTracking($tracking)
            ->setTransporter($transporter);
    }
    /**
     * Get BillingStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getBillingStatus()
    {
        return isset($this->BillingStatus) ? $this->BillingStatus : null;
    }
    /**
     * Set BillingStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\BillingStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\BillingStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $billingStatus
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setBillingStatus($billingStatus = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\BillingStatus::valueIsValid($billingStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\BillingStatus', is_array($billingStatus) ? implode(', ', $billingStatus) : var_export($billingStatus, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\BillingStatus::getValidValues())), __LINE__);
        }
        if (is_null($billingStatus) || (is_array($billingStatus) && empty($billingStatus))) {
            unset($this->BillingStatus);
        } else {
            $this->BillingStatus = $billingStatus;
        }
        return $this;
    }
    /**
     * Get CancelDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCancelDate()
    {
        return isset($this->CancelDate) ? $this->CancelDate : null;
    }
    /**
     * Set CancelDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cancelDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setCancelDate($cancelDate = null)
    {
        // validation for constraint: string
        if (!is_null($cancelDate) && !is_string($cancelDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cancelDate, true), gettype($cancelDate)), __LINE__);
        }
        if (is_null($cancelDate) || (is_array($cancelDate) && empty($cancelDate))) {
            unset($this->CancelDate);
        } else {
            $this->CancelDate = $cancelDate;
        }
        return $this;
    }
    /**
     * Get CancelReasonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCancelReasonId()
    {
        return isset($this->CancelReasonId) ? $this->CancelReasonId : null;
    }
    /**
     * Set CancelReasonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cancelReasonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setCancelReasonId($cancelReasonId = null)
    {
        // validation for constraint: string
        if (!is_null($cancelReasonId) && !is_string($cancelReasonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cancelReasonId, true), gettype($cancelReasonId)), __LINE__);
        }
        if (is_null($cancelReasonId) || (is_array($cancelReasonId) && empty($cancelReasonId))) {
            unset($this->CancelReasonId);
        } else {
            $this->CancelReasonId = $cancelReasonId;
        }
        return $this;
    }
    /**
     * Get CancelStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCancelStatus()
    {
        return isset($this->CancelStatus) ? $this->CancelStatus : null;
    }
    /**
     * Set CancelStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CancelStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CancelStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $cancelStatus
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setCancelStatus($cancelStatus = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CancelStatus::valueIsValid($cancelStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CancelStatus', is_array($cancelStatus) ? implode(', ', $cancelStatus) : var_export($cancelStatus, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\CancelStatus::getValidValues())), __LINE__);
        }
        if (is_null($cancelStatus) || (is_array($cancelStatus) && empty($cancelStatus))) {
            unset($this->CancelStatus);
        } else {
            $this->CancelStatus = $cancelStatus;
        }
        return $this;
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get DeliveryStoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeliveryStoreId()
    {
        return isset($this->DeliveryStoreId) ? $this->DeliveryStoreId : null;
    }
    /**
     * Set DeliveryStoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deliveryStoreId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setDeliveryStoreId($deliveryStoreId = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryStoreId) && !is_string($deliveryStoreId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryStoreId, true), gettype($deliveryStoreId)), __LINE__);
        }
        if (is_null($deliveryStoreId) || (is_array($deliveryStoreId) && empty($deliveryStoreId))) {
            unset($this->DeliveryStoreId);
        } else {
            $this->DeliveryStoreId = $deliveryStoreId;
        }
        return $this;
    }
    /**
     * Get DeliveryType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeliveryType()
    {
        return isset($this->DeliveryType) ? $this->DeliveryType : null;
    }
    /**
     * Set DeliveryType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DeliveryType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DeliveryType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $deliveryType
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setDeliveryType($deliveryType = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DeliveryType::valueIsValid($deliveryType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DeliveryType', is_array($deliveryType) ? implode(', ', $deliveryType) : var_export($deliveryType, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DeliveryType::getValidValues())), __LINE__);
        }
        if (is_null($deliveryType) || (is_array($deliveryType) && empty($deliveryType))) {
            unset($this->DeliveryType);
        } else {
            $this->DeliveryType = $deliveryType;
        }
        return $this;
    }
    /**
     * Get DeliveryWarehouseId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeliveryWarehouseId()
    {
        return isset($this->DeliveryWarehouseId) ? $this->DeliveryWarehouseId : null;
    }
    /**
     * Set DeliveryWarehouseId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deliveryWarehouseId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setDeliveryWarehouseId($deliveryWarehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryWarehouseId) && !is_string($deliveryWarehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryWarehouseId, true), gettype($deliveryWarehouseId)), __LINE__);
        }
        if (is_null($deliveryWarehouseId) || (is_array($deliveryWarehouseId) && empty($deliveryWarehouseId))) {
            unset($this->DeliveryWarehouseId);
        } else {
            $this->DeliveryWarehouseId = $deliveryWarehouseId;
        }
        return $this;
    }
    /**
     * Get FollowUpStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowUpStatus()
    {
        return isset($this->FollowUpStatus) ? $this->FollowUpStatus : null;
    }
    /**
     * Set FollowUpStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\FollowUpStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\FollowUpStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $followUpStatus
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setFollowUpStatus($followUpStatus = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\FollowUpStatus::valueIsValid($followUpStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\FollowUpStatus', is_array($followUpStatus) ? implode(', ', $followUpStatus) : var_export($followUpStatus, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\FollowUpStatus::getValidValues())), __LINE__);
        }
        if (is_null($followUpStatus) || (is_array($followUpStatus) && empty($followUpStatus))) {
            unset($this->FollowUpStatus);
        } else {
            $this->FollowUpStatus = $followUpStatus;
        }
        return $this;
    }
    /**
     * Get GiftMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGiftMessage()
    {
        return isset($this->GiftMessage) ? $this->GiftMessage : null;
    }
    /**
     * Set GiftMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $giftMessage
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setGiftMessage($giftMessage = null)
    {
        // validation for constraint: string
        if (!is_null($giftMessage) && !is_string($giftMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($giftMessage, true), gettype($giftMessage)), __LINE__);
        }
        if (is_null($giftMessage) || (is_array($giftMessage) && empty($giftMessage))) {
            unset($this->GiftMessage);
        } else {
            $this->GiftMessage = $giftMessage;
        }
        return $this;
    }
    /**
     * Get GiftMessageType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGiftMessageType()
    {
        return isset($this->GiftMessageType) ? $this->GiftMessageType : null;
    }
    /**
     * Set GiftMessageType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\GiftMessageType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\GiftMessageType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $giftMessageType
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setGiftMessageType($giftMessageType = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\GiftMessageType::valueIsValid($giftMessageType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\GiftMessageType', is_array($giftMessageType) ? implode(', ', $giftMessageType) : var_export($giftMessageType, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\GiftMessageType::getValidValues())), __LINE__);
        }
        if (is_null($giftMessageType) || (is_array($giftMessageType) && empty($giftMessageType))) {
            unset($this->GiftMessageType);
        } else {
            $this->GiftMessageType = $giftMessageType;
        }
        return $this;
    }
    /**
     * Get LockingDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLockingDate()
    {
        return isset($this->LockingDate) ? $this->LockingDate : null;
    }
    /**
     * Set LockingDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $lockingDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setLockingDate($lockingDate = null)
    {
        // validation for constraint: string
        if (!is_null($lockingDate) && !is_string($lockingDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lockingDate, true), gettype($lockingDate)), __LINE__);
        }
        if (is_null($lockingDate) || (is_array($lockingDate) && empty($lockingDate))) {
            unset($this->LockingDate);
        } else {
            $this->LockingDate = $lockingDate;
        }
        return $this;
    }
    /**
     * Get OriginStoreId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getOriginStoreId()
    {
        return isset($this->OriginStoreId) ? $this->OriginStoreId : null;
    }
    /**
     * Set OriginStoreId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $originStoreId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setOriginStoreId($originStoreId = null)
    {
        // validation for constraint: string
        if (!is_null($originStoreId) && !is_string($originStoreId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originStoreId, true), gettype($originStoreId)), __LINE__);
        }
        if (is_null($originStoreId) || (is_array($originStoreId) && empty($originStoreId))) {
            unset($this->OriginStoreId);
        } else {
            $this->OriginStoreId = $originStoreId;
        }
        return $this;
    }
    /**
     * Get OriginalDocument value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier|null
     */
    public function getOriginalDocument()
    {
        return isset($this->OriginalDocument) ? $this->OriginalDocument : null;
    }
    /**
     * Set OriginalDocument value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $originalDocument
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setOriginalDocument(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $originalDocument = null)
    {
        if (is_null($originalDocument) || (is_array($originalDocument) && empty($originalDocument))) {
            unset($this->OriginalDocument);
        } else {
            $this->OriginalDocument = $originalDocument;
        }
        return $this;
    }
    /**
     * Get PaymentMethodId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPaymentMethodId()
    {
        return isset($this->PaymentMethodId) ? $this->PaymentMethodId : null;
    }
    /**
     * Set PaymentMethodId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $paymentMethodId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setPaymentMethodId($paymentMethodId = null)
    {
        // validation for constraint: string
        if (!is_null($paymentMethodId) && !is_string($paymentMethodId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paymentMethodId, true), gettype($paymentMethodId)), __LINE__);
        }
        if (is_null($paymentMethodId) || (is_array($paymentMethodId) && empty($paymentMethodId))) {
            unset($this->PaymentMethodId);
        } else {
            $this->PaymentMethodId = $paymentMethodId;
        }
        return $this;
    }
    /**
     * Get PaymentStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPaymentStatus()
    {
        return isset($this->PaymentStatus) ? $this->PaymentStatus : null;
    }
    /**
     * Set PaymentStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\PaymentStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\PaymentStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $paymentStatus
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setPaymentStatus($paymentStatus = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\PaymentStatus::valueIsValid($paymentStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\PaymentStatus', is_array($paymentStatus) ? implode(', ', $paymentStatus) : var_export($paymentStatus, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\PaymentStatus::getValidValues())), __LINE__);
        }
        if (is_null($paymentStatus) || (is_array($paymentStatus) && empty($paymentStatus))) {
            unset($this->PaymentStatus);
        } else {
            $this->PaymentStatus = $paymentStatus;
        }
        return $this;
    }
    /**
     * Get ReturnStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReturnStatus()
    {
        return isset($this->ReturnStatus) ? $this->ReturnStatus : null;
    }
    /**
     * Set ReturnStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\OrderReturnStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\OrderReturnStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $returnStatus
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setReturnStatus($returnStatus = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\OrderReturnStatus::valueIsValid($returnStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\OrderReturnStatus', is_array($returnStatus) ? implode(', ', $returnStatus) : var_export($returnStatus, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\OrderReturnStatus::getValidValues())), __LINE__);
        }
        if (is_null($returnStatus) || (is_array($returnStatus) && empty($returnStatus))) {
            unset($this->ReturnStatus);
        } else {
            $this->ReturnStatus = $returnStatus;
        }
        return $this;
    }
    /**
     * Get ReturnType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReturnType()
    {
        return isset($this->ReturnType) ? $this->ReturnType : null;
    }
    /**
     * Set ReturnType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ReturnType::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ReturnType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $returnType
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setReturnType($returnType = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ReturnType::valueIsValid($returnType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ReturnType', is_array($returnType) ? implode(', ', $returnType) : var_export($returnType, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ReturnType::getValidValues())), __LINE__);
        }
        if (is_null($returnType) || (is_array($returnType) && empty($returnType))) {
            unset($this->ReturnType);
        } else {
            $this->ReturnType = $returnType;
        }
        return $this;
    }
    /**
     * Get ShippingStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getShippingStatus()
    {
        return isset($this->ShippingStatus) ? $this->ShippingStatus : null;
    }
    /**
     * Set ShippingStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ShippingStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ShippingStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $shippingStatus
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setShippingStatus($shippingStatus = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ShippingStatus::valueIsValid($shippingStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ShippingStatus', is_array($shippingStatus) ? implode(', ', $shippingStatus) : var_export($shippingStatus, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\ShippingStatus::getValidValues())), __LINE__);
        }
        if (is_null($shippingStatus) || (is_array($shippingStatus) && empty($shippingStatus))) {
            unset($this->ShippingStatus);
        } else {
            $this->ShippingStatus = $shippingStatus;
        }
        return $this;
    }
    /**
     * Get Tracking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTracking()
    {
        return isset($this->Tracking) ? $this->Tracking : null;
    }
    /**
     * Set Tracking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tracking
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setTracking($tracking = null)
    {
        // validation for constraint: string
        if (!is_null($tracking) && !is_string($tracking)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tracking, true), gettype($tracking)), __LINE__);
        }
        if (is_null($tracking) || (is_array($tracking) && empty($tracking))) {
            unset($this->Tracking);
        } else {
            $this->Tracking = $tracking;
        }
        return $this;
    }
    /**
     * Get Transporter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTransporter()
    {
        return isset($this->Transporter) ? $this->Transporter : null;
    }
    /**
     * Set Transporter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $transporter
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public function setTransporter($transporter = null)
    {
        // validation for constraint: string
        if (!is_null($transporter) && !is_string($transporter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transporter, true), gettype($transporter)), __LINE__);
        }
        if (is_null($transporter) || (is_array($transporter) && empty($transporter))) {
            unset($this->Transporter);
        } else {
            $this->Transporter = $transporter;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
