<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaleDocumentLineIdentifier StructType
 * Meta information extracted from the WSDL
 * - documentation: Critères d'identification d'une ligne de document de vente : fournir soit 'Key' soit 'Reference' pour rechercher un document respectivement par sa clef ou bien par sa référence
 * - nillable: true
 * - type: tns:SaleDocumentLineIdentifier
 * @subpackage Structs
 */
class SaleDocumentLineIdentifier extends AbstractStructBase
{
    /**
     * The DocumentId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/11].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier
     */
    public $DocumentId;
    /**
     * The LineId
     * Meta information extracted from the WSDL
     * - documentation: Numéro de ligne du document - Relatif à la colonne [LIGNE.GL_NUMORDRE].
     * - minOccurs: 0
     * @var int
     */
    public $LineId;
    /**
     * Constructor method for SaleDocumentLineIdentifier
     * @uses SaleDocumentLineIdentifier::setDocumentId()
     * @uses SaleDocumentLineIdentifier::setLineId()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $documentId
     * @param int $lineId
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $documentId = null, $lineId = null)
    {
        $this
            ->setDocumentId($documentId)
            ->setLineId($lineId);
    }
    /**
     * Get DocumentId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier|null
     */
    public function getDocumentId()
    {
        return isset($this->DocumentId) ? $this->DocumentId : null;
    }
    /**
     * Set DocumentId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $documentId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier
     */
    public function setDocumentId(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $documentId = null)
    {
        if (is_null($documentId) || (is_array($documentId) && empty($documentId))) {
            unset($this->DocumentId);
        } else {
            $this->DocumentId = $documentId;
        }
        return $this;
    }
    /**
     * Get LineId value
     * @return int|null
     */
    public function getLineId()
    {
        return $this->LineId;
    }
    /**
     * Set LineId value
     * @param int $lineId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier
     */
    public function setLineId($lineId = null)
    {
        // validation for constraint: int
        if (!is_null($lineId) && !(is_int($lineId) || ctype_digit($lineId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lineId, true), gettype($lineId)), __LINE__);
        }
        $this->LineId = $lineId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentLineIdentifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
