<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateHeader_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Entête du document de vente.
 * - nillable: true
 * - type: tns:UpdateHeader_Request
 * @subpackage Structs
 */
class UpdateHeader_Request extends AbstractStructBase
{
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/01 - V1201] [Optionnel] - Commentaire sur l'en-tête de document, pouvant être du texte brut ou du texte formaté RTF - Relatif à la colonne [PIECE.GP_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The DeliveryAddress
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Adresse de livraison du document de vente.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public $DeliveryAddress;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - documentation: Référence externe. - Relatif à la colonne [PIECE.GP_REFEXTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The ExternalReferenceDate
     * Meta information extracted from the WSDL
     * - documentation: Date de la référence externe. - Relatif à la colonne [PIECE.GP_DATEREFEXTERNE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * @var string
     */
    public $ExternalReferenceDate;
    /**
     * The FollowedReference
     * Meta information extracted from the WSDL
     * - documentation: Référence de suivi. - Relatif à la colonne [PIECE.GP_REFSUIVI].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowedReference;
    /**
     * The Identifier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier
     */
    public $Identifier;
    /**
     * The InvoicingAddress
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Adresse de facturation du document de vente.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public $InvoicingAddress;
    /**
     * The LinesUnmodifiable
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Précise si les lignes sont non modifiables. - Valeur par defaut: False.
     * - minOccurs: 0
     * @var bool
     */
    public $LinesUnmodifiable;
    /**
     * The OmniChannel
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Informations omni-canal.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public $OmniChannel;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/10 - V1105] [Optionnel] - Identifiant du vendeur. - Relatif à la colonne [PIECE.GP_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The UserDefinedDates
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Dates libres utilisateur. - Relatif à la colonne [PIECE.GP_DATELIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate
     */
    public $UserDefinedDates;
    /**
     * The UserDefinedTables
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Tables libres utilisateur. - Relatif à la colonne [PIECE.GP_LIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable
     */
    public $UserDefinedTables;
    /**
     * The UserFields
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Champs libres utilisateur.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField
     */
    public $UserFields;
    /**
     * Constructor method for UpdateHeader_Request
     * @uses UpdateHeader_Request::setComment()
     * @uses UpdateHeader_Request::setDeliveryAddress()
     * @uses UpdateHeader_Request::setExternalReference()
     * @uses UpdateHeader_Request::setExternalReferenceDate()
     * @uses UpdateHeader_Request::setFollowedReference()
     * @uses UpdateHeader_Request::setIdentifier()
     * @uses UpdateHeader_Request::setInvoicingAddress()
     * @uses UpdateHeader_Request::setLinesUnmodifiable()
     * @uses UpdateHeader_Request::setOmniChannel()
     * @uses UpdateHeader_Request::setSalesPersonId()
     * @uses UpdateHeader_Request::setUserDefinedDates()
     * @uses UpdateHeader_Request::setUserDefinedTables()
     * @uses UpdateHeader_Request::setUserFields()
     * @param string $comment
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress
     * @param string $externalReference
     * @param string $externalReferenceDate
     * @param string $followedReference
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress
     * @param bool $linesUnmodifiable
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel
     * @param string $salesPersonId
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     */
    public function __construct($comment = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress = null, $externalReference = null, $externalReferenceDate = null, $followedReference = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress = null, $linesUnmodifiable = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel = null, $salesPersonId = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null)
    {
        $this
            ->setComment($comment)
            ->setDeliveryAddress($deliveryAddress)
            ->setExternalReference($externalReference)
            ->setExternalReferenceDate($externalReferenceDate)
            ->setFollowedReference($followedReference)
            ->setIdentifier($identifier)
            ->setInvoicingAddress($invoicingAddress)
            ->setLinesUnmodifiable($linesUnmodifiable)
            ->setOmniChannel($omniChannel)
            ->setSalesPersonId($salesPersonId)
            ->setUserDefinedDates($userDefinedDates)
            ->setUserDefinedTables($userDefinedTables)
            ->setUserFields($userFields);
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get DeliveryAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address|null
     */
    public function getDeliveryAddress()
    {
        return isset($this->DeliveryAddress) ? $this->DeliveryAddress : null;
    }
    /**
     * Set DeliveryAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setDeliveryAddress(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress = null)
    {
        if (is_null($deliveryAddress) || (is_array($deliveryAddress) && empty($deliveryAddress))) {
            unset($this->DeliveryAddress);
        } else {
            $this->DeliveryAddress = $deliveryAddress;
        }
        return $this;
    }
    /**
     * Get ExternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalReference()
    {
        return isset($this->ExternalReference) ? $this->ExternalReference : null;
    }
    /**
     * Set ExternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        if (is_null($externalReference) || (is_array($externalReference) && empty($externalReference))) {
            unset($this->ExternalReference);
        } else {
            $this->ExternalReference = $externalReference;
        }
        return $this;
    }
    /**
     * Get ExternalReferenceDate value
     * @return string|null
     */
    public function getExternalReferenceDate()
    {
        return $this->ExternalReferenceDate;
    }
    /**
     * Set ExternalReferenceDate value
     * @param string $externalReferenceDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setExternalReferenceDate($externalReferenceDate = null)
    {
        // validation for constraint: string
        if (!is_null($externalReferenceDate) && !is_string($externalReferenceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReferenceDate, true), gettype($externalReferenceDate)), __LINE__);
        }
        $this->ExternalReferenceDate = $externalReferenceDate;
        return $this;
    }
    /**
     * Get FollowedReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowedReference()
    {
        return isset($this->FollowedReference) ? $this->FollowedReference : null;
    }
    /**
     * Set FollowedReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $followedReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setFollowedReference($followedReference = null)
    {
        // validation for constraint: string
        if (!is_null($followedReference) && !is_string($followedReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($followedReference, true), gettype($followedReference)), __LINE__);
        }
        if (is_null($followedReference) || (is_array($followedReference) && empty($followedReference))) {
            unset($this->FollowedReference);
        } else {
            $this->FollowedReference = $followedReference;
        }
        return $this;
    }
    /**
     * Get Identifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier|null
     */
    public function getIdentifier()
    {
        return isset($this->Identifier) ? $this->Identifier : null;
    }
    /**
     * Set Identifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setIdentifier(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null)
    {
        if (is_null($identifier) || (is_array($identifier) && empty($identifier))) {
            unset($this->Identifier);
        } else {
            $this->Identifier = $identifier;
        }
        return $this;
    }
    /**
     * Get InvoicingAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address|null
     */
    public function getInvoicingAddress()
    {
        return isset($this->InvoicingAddress) ? $this->InvoicingAddress : null;
    }
    /**
     * Set InvoicingAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setInvoicingAddress(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress = null)
    {
        if (is_null($invoicingAddress) || (is_array($invoicingAddress) && empty($invoicingAddress))) {
            unset($this->InvoicingAddress);
        } else {
            $this->InvoicingAddress = $invoicingAddress;
        }
        return $this;
    }
    /**
     * Get LinesUnmodifiable value
     * @return bool|null
     */
    public function getLinesUnmodifiable()
    {
        return $this->LinesUnmodifiable;
    }
    /**
     * Set LinesUnmodifiable value
     * @param bool $linesUnmodifiable
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setLinesUnmodifiable($linesUnmodifiable = null)
    {
        // validation for constraint: boolean
        if (!is_null($linesUnmodifiable) && !is_bool($linesUnmodifiable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($linesUnmodifiable, true), gettype($linesUnmodifiable)), __LINE__);
        }
        $this->LinesUnmodifiable = $linesUnmodifiable;
        return $this;
    }
    /**
     * Get OmniChannel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel|null
     */
    public function getOmniChannel()
    {
        return isset($this->OmniChannel) ? $this->OmniChannel : null;
    }
    /**
     * Set OmniChannel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setOmniChannel(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel = null)
    {
        if (is_null($omniChannel) || (is_array($omniChannel) && empty($omniChannel))) {
            unset($this->OmniChannel);
        } else {
            $this->OmniChannel = $omniChannel;
        }
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get UserDefinedDates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate|null
     */
    public function getUserDefinedDates()
    {
        return isset($this->UserDefinedDates) ? $this->UserDefinedDates : null;
    }
    /**
     * Set UserDefinedDates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setUserDefinedDates(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null)
    {
        if (is_null($userDefinedDates) || (is_array($userDefinedDates) && empty($userDefinedDates))) {
            unset($this->UserDefinedDates);
        } else {
            $this->UserDefinedDates = $userDefinedDates;
        }
        return $this;
    }
    /**
     * Get UserDefinedTables value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable|null
     */
    public function getUserDefinedTables()
    {
        return isset($this->UserDefinedTables) ? $this->UserDefinedTables : null;
    }
    /**
     * Set UserDefinedTables value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setUserDefinedTables(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null)
    {
        if (is_null($userDefinedTables) || (is_array($userDefinedTables) && empty($userDefinedTables))) {
            unset($this->UserDefinedTables);
        } else {
            $this->UserDefinedTables = $userDefinedTables;
        }
        return $this;
    }
    /**
     * Get UserFields value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField|null
     */
    public function getUserFields()
    {
        return isset($this->UserFields) ? $this->UserFields : null;
    }
    /**
     * Set UserFields value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public function setUserFields(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null)
    {
        if (is_null($userFields) || (is_array($userFields) && empty($userFields))) {
            unset($this->UserFields);
        } else {
            $this->UserFields = $userFields;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
