<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Update_Header StructType
 * Meta information extracted from the WSDL
 * - documentation: Entête de document de vente.
 * - nillable: true
 * - type: tns:Update_Header
 * @subpackage Structs
 */
class Update_Header extends AbstractStructBase
{
    /**
     * The Active
     * Meta information extracted from the WSDL
     * - documentation: Document actif. - Relatif à la colonne [PIECE.GP_VIVANTE].
     * - minOccurs: 0
     * @var bool
     */
    public $Active;
    /**
     * The Comment
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2015/01 - V1201] [Optionnel] - Commentaire sur l'en-tête de document, pouvant être du texte brut ou du texte formaté RTF - Relatif à la colonne [PIECE.GP_BLOCNOTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Comment;
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - documentation: Date du document. - Relatif à la colonne [PIECE.GP_DATEPIECE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * @var string
     */
    public $Date;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - documentation: Référence externe. - Relatif à la colonne [PIECE.GP_REFEXTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The ExternalReferenceDate
     * Meta information extracted from the WSDL
     * - documentation: Date de référencement externe. - Relatif à la colonne [PIECE.GP_DATEREFEXTERNE]. La date passée en entrée ne doit pas spécifier des informations d'heure.
     * - minOccurs: 0
     * @var string
     */
    public $ExternalReferenceDate;
    /**
     * The FollowedReference
     * Meta information extracted from the WSDL
     * - documentation: Référence de suivi. - Relatif à la colonne [PIECE.GP_REFSUIVI].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowedReference;
    /**
     * The LinesUnmodifiable
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/08 - V1105] [Optionnel] - Précise si les lignes sont non modifiables. - Valeur par defaut: False - Relatif à la colonne [PIECE.GP_NONMODIFIABLE].
     * - minOccurs: 0
     * @var bool
     */
    public $LinesUnmodifiable;
    /**
     * The OmniChannel
     * Meta information extracted from the WSDL
     * - documentation: Informations omnicanal.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel
     */
    public $OmniChannel;
    /**
     * The Origin
     * Meta information extracted from the WSDL
     * - documentation: Provenance. - Relatif à la colonne [PIECE.GP_TYPEPROVENANCE].
     * - minOccurs: 0
     * @var string
     */
    public $Origin;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2014/10 - V1105] [Optionnel] - Identifiant du vendeur. - Relatif à la colonne [PIECE.GP_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The TaxExcluded
     * Meta information extracted from the WSDL
     * - documentation: Document H.T. - Relatif à la colonne [PIECE.GP_FACTUREHT].
     * - minOccurs: 0
     * @var bool
     */
    public $TaxExcluded;
    /**
     * The UserDefinedDates
     * Meta information extracted from the WSDL
     * - documentation: Dates libres utilisateur. - Relatif à la colonne [PIECE.GP_DATELIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate
     */
    public $UserDefinedDates;
    /**
     * The UserDefinedTables
     * Meta information extracted from the WSDL
     * - documentation: Tables libres utilisateur. - Relatif à la colonne [PIECE.GP_LIBREPIECEx].
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable
     */
    public $UserDefinedTables;
    /**
     * The UserFields
     * Meta information extracted from the WSDL
     * - documentation: Champs utilisateur du document.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField
     */
    public $UserFields;
    /**
     * Constructor method for Update_Header
     * @uses Update_Header::setActive()
     * @uses Update_Header::setComment()
     * @uses Update_Header::setDate()
     * @uses Update_Header::setExternalReference()
     * @uses Update_Header::setExternalReferenceDate()
     * @uses Update_Header::setFollowedReference()
     * @uses Update_Header::setLinesUnmodifiable()
     * @uses Update_Header::setOmniChannel()
     * @uses Update_Header::setOrigin()
     * @uses Update_Header::setSalesPersonId()
     * @uses Update_Header::setTaxExcluded()
     * @uses Update_Header::setUserDefinedDates()
     * @uses Update_Header::setUserDefinedTables()
     * @uses Update_Header::setUserFields()
     * @param bool $active
     * @param string $comment
     * @param string $date
     * @param string $externalReference
     * @param string $externalReferenceDate
     * @param string $followedReference
     * @param bool $linesUnmodifiable
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel
     * @param string $origin
     * @param string $salesPersonId
     * @param bool $taxExcluded
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     */
    public function __construct($active = null, $comment = null, $date = null, $externalReference = null, $externalReferenceDate = null, $followedReference = null, $linesUnmodifiable = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel = null, $origin = null, $salesPersonId = null, $taxExcluded = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null)
    {
        $this
            ->setActive($active)
            ->setComment($comment)
            ->setDate($date)
            ->setExternalReference($externalReference)
            ->setExternalReferenceDate($externalReferenceDate)
            ->setFollowedReference($followedReference)
            ->setLinesUnmodifiable($linesUnmodifiable)
            ->setOmniChannel($omniChannel)
            ->setOrigin($origin)
            ->setSalesPersonId($salesPersonId)
            ->setTaxExcluded($taxExcluded)
            ->setUserDefinedDates($userDefinedDates)
            ->setUserDefinedTables($userDefinedTables)
            ->setUserFields($userFields);
    }
    /**
     * Get Active value
     * @return bool|null
     */
    public function getActive()
    {
        return $this->Active;
    }
    /**
     * Set Active value
     * @param bool $active
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setActive($active = null)
    {
        // validation for constraint: boolean
        if (!is_null($active) && !is_bool($active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($active, true), gettype($active)), __LINE__);
        }
        $this->Active = $active;
        return $this;
    }
    /**
     * Get Comment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComment()
    {
        return isset($this->Comment) ? $this->Comment : null;
    }
    /**
     * Set Comment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comment
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setComment($comment = null)
    {
        // validation for constraint: string
        if (!is_null($comment) && !is_string($comment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comment, true), gettype($comment)), __LINE__);
        }
        if (is_null($comment) || (is_array($comment) && empty($comment))) {
            unset($this->Comment);
        } else {
            $this->Comment = $comment;
        }
        return $this;
    }
    /**
     * Get Date value
     * @return string|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * Set Date value
     * @param string $date
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Get ExternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalReference()
    {
        return isset($this->ExternalReference) ? $this->ExternalReference : null;
    }
    /**
     * Set ExternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        if (is_null($externalReference) || (is_array($externalReference) && empty($externalReference))) {
            unset($this->ExternalReference);
        } else {
            $this->ExternalReference = $externalReference;
        }
        return $this;
    }
    /**
     * Get ExternalReferenceDate value
     * @return string|null
     */
    public function getExternalReferenceDate()
    {
        return $this->ExternalReferenceDate;
    }
    /**
     * Set ExternalReferenceDate value
     * @param string $externalReferenceDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setExternalReferenceDate($externalReferenceDate = null)
    {
        // validation for constraint: string
        if (!is_null($externalReferenceDate) && !is_string($externalReferenceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReferenceDate, true), gettype($externalReferenceDate)), __LINE__);
        }
        $this->ExternalReferenceDate = $externalReferenceDate;
        return $this;
    }
    /**
     * Get FollowedReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowedReference()
    {
        return isset($this->FollowedReference) ? $this->FollowedReference : null;
    }
    /**
     * Set FollowedReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $followedReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setFollowedReference($followedReference = null)
    {
        // validation for constraint: string
        if (!is_null($followedReference) && !is_string($followedReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($followedReference, true), gettype($followedReference)), __LINE__);
        }
        if (is_null($followedReference) || (is_array($followedReference) && empty($followedReference))) {
            unset($this->FollowedReference);
        } else {
            $this->FollowedReference = $followedReference;
        }
        return $this;
    }
    /**
     * Get LinesUnmodifiable value
     * @return bool|null
     */
    public function getLinesUnmodifiable()
    {
        return $this->LinesUnmodifiable;
    }
    /**
     * Set LinesUnmodifiable value
     * @param bool $linesUnmodifiable
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setLinesUnmodifiable($linesUnmodifiable = null)
    {
        // validation for constraint: boolean
        if (!is_null($linesUnmodifiable) && !is_bool($linesUnmodifiable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($linesUnmodifiable, true), gettype($linesUnmodifiable)), __LINE__);
        }
        $this->LinesUnmodifiable = $linesUnmodifiable;
        return $this;
    }
    /**
     * Get OmniChannel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel|null
     */
    public function getOmniChannel()
    {
        return isset($this->OmniChannel) ? $this->OmniChannel : null;
    }
    /**
     * Set OmniChannel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setOmniChannel(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\OmniChannel $omniChannel = null)
    {
        if (is_null($omniChannel) || (is_array($omniChannel) && empty($omniChannel))) {
            unset($this->OmniChannel);
        } else {
            $this->OmniChannel = $omniChannel;
        }
        return $this;
    }
    /**
     * Get Origin value
     * @return string|null
     */
    public function getOrigin()
    {
        return $this->Origin;
    }
    /**
     * Set Origin value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $origin
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setOrigin($origin = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::valueIsValid($origin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin', is_array($origin) ? implode(', ', $origin) : var_export($origin, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\DocumentOrigin::getValidValues())), __LINE__);
        }
        $this->Origin = $origin;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get TaxExcluded value
     * @return bool|null
     */
    public function getTaxExcluded()
    {
        return $this->TaxExcluded;
    }
    /**
     * Set TaxExcluded value
     * @param bool $taxExcluded
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setTaxExcluded($taxExcluded = null)
    {
        // validation for constraint: boolean
        if (!is_null($taxExcluded) && !is_bool($taxExcluded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($taxExcluded, true), gettype($taxExcluded)), __LINE__);
        }
        $this->TaxExcluded = $taxExcluded;
        return $this;
    }
    /**
     * Get UserDefinedDates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate|null
     */
    public function getUserDefinedDates()
    {
        return isset($this->UserDefinedDates) ? $this->UserDefinedDates : null;
    }
    /**
     * Set UserDefinedDates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setUserDefinedDates(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedDate $userDefinedDates = null)
    {
        if (is_null($userDefinedDates) || (is_array($userDefinedDates) && empty($userDefinedDates))) {
            unset($this->UserDefinedDates);
        } else {
            $this->UserDefinedDates = $userDefinedDates;
        }
        return $this;
    }
    /**
     * Get UserDefinedTables value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable|null
     */
    public function getUserDefinedTables()
    {
        return isset($this->UserDefinedTables) ? $this->UserDefinedTables : null;
    }
    /**
     * Set UserDefinedTables value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setUserDefinedTables(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserDefinedTable $userDefinedTables = null)
    {
        if (is_null($userDefinedTables) || (is_array($userDefinedTables) && empty($userDefinedTables))) {
            unset($this->UserDefinedTables);
        } else {
            $this->UserDefinedTables = $userDefinedTables;
        }
        return $this;
    }
    /**
     * Get UserFields value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField|null
     */
    public function getUserFields()
    {
        return isset($this->UserFields) ? $this->UserFields : null;
    }
    /**
     * Set UserFields value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public function setUserFields(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUserField $userFields = null)
    {
        if (is_null($userFields) || (is_array($userFields) && empty($userFields))) {
            unset($this->UserFields);
        } else {
            $this->UserFields = $userFields;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
