<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Update_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Document de vente à modifier.
 * - nillable: true
 * - type: tns:Update_Request
 * @subpackage Structs
 */
class Update_Request extends AbstractStructBase
{
    /**
     * The DeliveryAddress
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Adresse de livraison du document de vente.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public $DeliveryAddress;
    /**
     * The Header
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header
     */
    public $Header;
    /**
     * The Identifier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier
     */
    public $Identifier;
    /**
     * The InvoicingAddress
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Adresse de facturation du document de vente.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address
     */
    public $InvoicingAddress;
    /**
     * The Lines
     * Meta information extracted from the WSDL
     * - documentation: Liste des lignes du document de vente.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line
     */
    public $Lines;
    /**
     * The Payments
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Liste des paiements du document de vente.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment
     */
    public $Payments;
    /**
     * The ShippingTaxes
     * Meta information extracted from the WSDL
     * - documentation: [Optionnel] - Liste des frais de port du document de vente.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax
     */
    public $ShippingTaxes;
    /**
     * Constructor method for Update_Request
     * @uses Update_Request::setDeliveryAddress()
     * @uses Update_Request::setHeader()
     * @uses Update_Request::setIdentifier()
     * @uses Update_Request::setInvoicingAddress()
     * @uses Update_Request::setLines()
     * @uses Update_Request::setPayments()
     * @uses Update_Request::setShippingTaxes()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header $header
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line $lines
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax $shippingTaxes
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header $header = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line $lines = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax $shippingTaxes = null)
    {
        $this
            ->setDeliveryAddress($deliveryAddress)
            ->setHeader($header)
            ->setIdentifier($identifier)
            ->setInvoicingAddress($invoicingAddress)
            ->setLines($lines)
            ->setPayments($payments)
            ->setShippingTaxes($shippingTaxes);
    }
    /**
     * Get DeliveryAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address|null
     */
    public function getDeliveryAddress()
    {
        return isset($this->DeliveryAddress) ? $this->DeliveryAddress : null;
    }
    /**
     * Set DeliveryAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public function setDeliveryAddress(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $deliveryAddress = null)
    {
        if (is_null($deliveryAddress) || (is_array($deliveryAddress) && empty($deliveryAddress))) {
            unset($this->DeliveryAddress);
        } else {
            $this->DeliveryAddress = $deliveryAddress;
        }
        return $this;
    }
    /**
     * Get Header value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header|null
     */
    public function getHeader()
    {
        return isset($this->Header) ? $this->Header : null;
    }
    /**
     * Set Header value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header $header
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public function setHeader(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Header $header = null)
    {
        if (is_null($header) || (is_array($header) && empty($header))) {
            unset($this->Header);
        } else {
            $this->Header = $header;
        }
        return $this;
    }
    /**
     * Get Identifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier|null
     */
    public function getIdentifier()
    {
        return isset($this->Identifier) ? $this->Identifier : null;
    }
    /**
     * Set Identifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public function setIdentifier(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\SaleDocumentIdentifier $identifier = null)
    {
        if (is_null($identifier) || (is_array($identifier) && empty($identifier))) {
            unset($this->Identifier);
        } else {
            $this->Identifier = $identifier;
        }
        return $this;
    }
    /**
     * Get InvoicingAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address|null
     */
    public function getInvoicingAddress()
    {
        return isset($this->InvoicingAddress) ? $this->InvoicingAddress : null;
    }
    /**
     * Set InvoicingAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public function setInvoicingAddress(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Address $invoicingAddress = null)
    {
        if (is_null($invoicingAddress) || (is_array($invoicingAddress) && empty($invoicingAddress))) {
            unset($this->InvoicingAddress);
        } else {
            $this->InvoicingAddress = $invoicingAddress;
        }
        return $this;
    }
    /**
     * Get Lines value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line|null
     */
    public function getLines()
    {
        return isset($this->Lines) ? $this->Lines : null;
    }
    /**
     * Set Lines value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line $lines
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public function setLines(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Line $lines = null)
    {
        if (is_null($lines) || (is_array($lines) && empty($lines))) {
            unset($this->Lines);
        } else {
            $this->Lines = $lines;
        }
        return $this;
    }
    /**
     * Get Payments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment|null
     */
    public function getPayments()
    {
        return isset($this->Payments) ? $this->Payments : null;
    }
    /**
     * Set Payments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public function setPayments(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_Payment $payments = null)
    {
        if (is_null($payments) || (is_array($payments) && empty($payments))) {
            unset($this->Payments);
        } else {
            $this->Payments = $payments;
        }
        return $this;
    }
    /**
     * Get ShippingTaxes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax|null
     */
    public function getShippingTaxes()
    {
        return isset($this->ShippingTaxes) ? $this->ShippingTaxes : null;
    }
    /**
     * Set ShippingTaxes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax $shippingTaxes
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public function setShippingTaxes(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfUpdate_ShippingTax $shippingTaxes = null)
    {
        if (is_null($shippingTaxes) || (is_array($shippingTaxes) && empty($shippingTaxes))) {
            unset($this->ShippingTaxes);
        } else {
            $this->ShippingTaxes = $shippingTaxes;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
