<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Update_Tax StructType
 * Meta information extracted from the WSDL
 * - documentation: Taxe.
 * - nillable: true
 * - type: tns:Update_Tax
 * @subpackage Structs
 */
class Update_Tax extends AbstractStructBase
{
    /**
     * The Amount
     * Meta information extracted from the WSDL
     * - documentation: Montant de la taxe. - Relatif à la colonne [LIGNE.GL_TOTALTAXEDEVx].
     * - minOccurs: 0
     * @var float
     */
    public $Amount;
    /**
     * The FamilyId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant de la famille de taxe. - Relatif à la colonne [LIGNE.GL_FAMILLETAXEx].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FamilyId;
    /**
     * Constructor method for Update_Tax
     * @uses Update_Tax::setAmount()
     * @uses Update_Tax::setFamilyId()
     * @param float $amount
     * @param string $familyId
     */
    public function __construct($amount = null, $familyId = null)
    {
        $this
            ->setAmount($amount)
            ->setFamilyId($familyId);
    }
    /**
     * Get Amount value
     * @return float|null
     */
    public function getAmount()
    {
        return $this->Amount;
    }
    /**
     * Set Amount value
     * @param float $amount
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: float
        if (!is_null($amount) && !(is_float($amount) || is_numeric($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->Amount = $amount;
        return $this;
    }
    /**
     * Get FamilyId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFamilyId()
    {
        return isset($this->FamilyId) ? $this->FamilyId : null;
    }
    /**
     * Set FamilyId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $familyId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax
     */
    public function setFamilyId($familyId = null)
    {
        // validation for constraint: string
        if (!is_null($familyId) && !is_string($familyId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($familyId, true), gettype($familyId)), __LINE__);
        }
        if (is_null($familyId) || (is_array($familyId) && empty($familyId))) {
            unset($this->FamilyId);
        } else {
            $this->FamilyId = $familyId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Update_Tax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
