<?php

namespace FiloBlu\CegidY2\Tools;

use WsdlToPhp\PackageGenerator\ConfigurationReader\GeneratorOptions;
use WsdlToPhp\PackageGenerator\Generator\Generator;

require_once __DIR__ . '/bootstrap.php';

$services = Utils::getConfiguration();

$systemGenerator = new SystemXmlGenerator($services);
$systemGenerator->generate();


if (is_dir(__DIR__ .'/../Base')) {
    Utils::rrmdir(__DIR__ . '/../Base');
}

if (is_dir('Api')) {
    Utils::rrmdir('Api');
}

$baseUrl = 'https://90277394-test-retail-ondemand.cegid.cloud/Y2/%s.svc?singlewsdl';


foreach ($services as $service) {
    $options = GeneratorOptions::instance();
    $options
        ->setOrigin(sprintf($baseUrl, $service))
        ->setSrcDirname('/')
        ->setDestination(__DIR__ ."/../Api/{$service}")
        ->setNamespace("FiloBlu\\CegidY2\\Api\\{$service}")
        ->setStandalone(false)
        ->setGenerateTutorialFile(false);
    $generator = new Generator($options);
    $generator->generatePackage();
}


Utils::rcopy(__DIR__ .'/vendor/wsdltophp/packagebase/src/', __DIR__.'/../Base');

